Global EXEPATH$, OUTPATH$, GENERALPATH$, LIBPATH$
Global ErrorCount, ConsoleOpened, Parameter_Quiet

NewList files.s() ; all files
NewList libs.s()  ; libraries

NewList lines.s()  ; lines from function.desc files


XIncludeFile "procs.pbi"


;
; init
;
EXEPATH$     = _ExePath()
If Right(EXEPATH$,1)<>"\"
  EXEPATH$+"\"
EndIf
OUTPATH$     = EXEPATH$+"output\"
GENERALPATH$ = EXEPATH$+"general\"
LIBPATH$     = EXEPATH$+"libs\"

If UCase(ProgramParameter()) = "/QUIET"
  Parameter_Quiet = 1
EndIf



;
; Delete old output
;
If ExamineDirectory(0,OUTPATH$,"*")
  Repeat
    Select NextDirectoryEntry()
      Case 0
        Break
      Case 1
        Name$ = DirectoryEntryName()
        If Name$ <> "." And Name$ <> ".."
          DeleteFile(OUTPATH$+Name$)
        EndIf
    EndSelect
  ForEver
Else
  _Error("cant examine directory: "+OUTPATH$)
EndIf



;
; copy default files
;
If ExamineDirectory(0,GENERALPATH$,"*")
  Repeat
    Select NextDirectoryEntry()
      Case 0
        Break
      Case 1
        Name$ = DirectoryEntryName()
        If Name$ <> "." And Name$ <> ".."
          AddElement(files())
          files() = Name$
          CopyFile(GENERALPATH$+Name$,OUTPATH$+Name$)
        EndIf
    EndSelect
  ForEver
Else
  _Error("cant examine directory: "+GENERALPATH$)
EndIf



;
; get library names
;
If ExamineDirectory(0,LIBPATH$,"*")
  Repeat
    Select NextDirectoryEntry()
      Case 0
        Break
      Case 2
        Name$ = DirectoryEntryName()
        If Name$ <> "." And Name$ <> ".."
          AddElement(libs())
          libs() = Name$
        EndIf
    EndSelect
  ForEver
Else
  _Error("cant examine directory: "+LIBPATH$)
EndIf




;
; TOC.hhc -> Microsoft HTMLHELP - Table of Contents
;
If CreateFile(1,OUTPATH$+"TOC.hhc")=0
  _Error("cant create TOC.hhc")
Else
  WriteStringN("<!DOCTYPE HTML PUBLIC "+#DQUOTE$+"-//IETF//DTD HTML//EN"+#DQUOTE$+">")
  WriteStringN("<HTML>")
  WriteStringN("")
  WriteStringN("  <HEAD>")
  WriteStringN("    <meta name="+#DQUOTE$+"GENERATOR"+#DQUOTE$+" content="+#DQUOTE$+"PBOSL Help Generator"+#DQUOTE$+">")
  WriteStringN("    <!-- Sitemap 1.0 -->")
  WriteStringN("  </HEAD>")
  WriteStringN("")
  WriteStringN("  <BODY>")
  WriteStringN("")
  WriteStringN("    <OBJECT type="+#DQUOTE$+"text/site properties"+#DQUOTE$+">")
  WriteStringN("      <param name="+#DQUOTE$+"Window Styles"+#DQUOTE$+" value="+#DQUOTE$+"0x801222"+#DQUOTE$+">") ; 801024
  WriteStringN("    </OBJECT>")
  WriteStringN("")
  WriteStringN("    <UL>")
    AddSite("PBOSL","PBOSL.html",0)
    ForEach libs()
      AddLibrary(libs())
    Next
  WriteStringN("    </UL>")
  WriteStringN("")
  WriteStringN("  </BODY>")
  WriteStringN("")
  WriteStringN("</HTML>")
  CloseFile(1)
EndIf



;
; PBOSL.hhp -> Microsoft HTMLHELP Project
;
If CreateFile(1,OUTPATH$+"PBOSL.hhp")=0
  _Error("cant create PBOSL.hhp")
Else
  WriteStringN("[OPTIONS]")
  WriteStringN("Compatibility=1.1 or later")
  WriteStringN("Compiled file=PBOSL.chm")
  WriteStringN("Contents file=TOC.hhc")
  WriteStringN("Default Window=Default")
  WriteStringN("Default topic=PBOSL.html")
  WriteStringN("Display compile progress=No")
  WriteStringN("Display compile notes=Yes")
  WriteStringN("Index file=Index.hhk")
  WriteStringN("Full-text search=Yes")
  WriteStringN("Binary Index=No")
  WriteStringN("Auto Index=No")
  WriteStringN("Enhanced decompilation=No")
  WriteStringN("Binary TOC=No")
  WriteStringN("Flat=No")
  WriteStringN("Language=0x409 English (United States)")
  WriteStringN("Title=PBOSL --- PureBasic OpenSource Libraries")
  WriteStringN("")
  WriteStringN("[WINDOWS]")
  WriteStringN("Default="+#DQUOTE$+"PBOSL --- PureBasic OpenSource Libraries"+#DQUOTE$+","+#DQUOTE$+"TOC.hhc"+#DQUOTE$+","+#DQUOTE$+"Index.hhk"+#DQUOTE$+","+#DQUOTE$+"PBOSL.html"+#DQUOTE$+","+#DQUOTE$+"PBOSL.html"+#DQUOTE$+",,,,,0x43120,,0x302e,[0,0,1024,600],0x10030000,,,,,,0")
  ;WriteStringN("Default="+#DQUOTE$+"PBOSL --- PureBasic OpenSource Libraries"+#DQUOTE$+","+#DQUOTE$+"TOC.hhc"+#DQUOTE$+","+#DQUOTE$+"Index.hhk"+#DQUOTE$+","+#DQUOTE$+"PBOSL.html"+#DQUOTE$+","+#DQUOTE$+"PBOSL.html"+#DQUOTE$+",,,,,0x40121,0,0x100c,[0,0,500,400],0x0,0x0,,0,0,0")
  WriteStringN("")
  WriteStringN("[FILES]")
  ForEach files()
    WriteStringN(files())
  Next
  CloseFile(1)
EndIf



;
; Index.hhk -> Microsoft HTMLHELP Index File
;
If CreateFile(1,OUTPATH$+"Index.hhk")=0
  _Error("cant create Index.hhk")
Else
  WriteStringN("<!DOCTYPE HTML PUBLIC "+#DQUOTE$+"-//IETF//DTD HTML//EN"+#DQUOTE$+">")
  WriteStringN("<HTML>")
  WriteStringN("")
  WriteStringN("  <HEAD>")
  WriteStringN("    <meta name="+#DQUOTE$+"GENERATOR"+#DQUOTE$+" content="+#DQUOTE$+"PBOSL Help Generator"+#DQUOTE$+">")
  WriteStringN("    <!-- Sitemap 1.0 -->")
  WriteStringN("  </HEAD>")
  WriteStringN("")
  WriteStringN("  <BODY>")
  WriteStringN("    <UL>")
  WriteStringN("    </UL>")
  WriteStringN("  </BODY>")
  WriteStringN("")
  WriteStringN("</HTML>")
  CloseFile(1)
EndIf



If ErrorCount And Parameter_Quiet=0
  A$ = " error"
  If ErrorCount > 1 : A$+"s" : EndIf

  PrintN("")
  PrintN(StrU(ErrorCount,#LONG)+A$+". please press enter to continue.")
  Input()
EndIf

; ExecutableFormat=Console
; Executable=G:\-SOURCE-\-LIBs-\PBOSL\-DOCS-\generate.exe
; DisableDebugger
; EOF