;
; helper procedures
;
Procedure.s _ExePath()
  A$ = Space(2048)
  GetModuleFileName_(0,@A$,2048)
  ProcedureReturn GetPathPart(A$)
EndProcedure



Procedure _Error(msg$)
  If Parameter_Quiet=0
    If ConsoleOpened = 0
       ConsoleOpened = 1
       OpenConsole()
    EndIf
    ErrorCount + 1
    PrintN("ERROR: "+msg$)
  EndIf
EndProcedure



Procedure AddSite(name$,file$,spaces)
  If name$ = "Overview" Or name$ = "Introduction"
    pic = 17
  Else
    pic = 11
  EndIf
  A$ = Space(spaces)
  WriteStringN(A$+"      <LI> <OBJECT type="+#DQUOTE$+"text/sitemap"+#DQUOTE$+">")
  WriteStringN(A$+"             <param name="+#DQUOTE$+"Name"+#DQUOTE$+" value="+#DQUOTE$+name$+#DQUOTE$+">")
  WriteStringN(A$+"             <param name="+#DQUOTE$+"Local"+#DQUOTE$+" value="+#DQUOTE$+file$+#DQUOTE$+">")
  WriteStringN(A$+"             <param name="+#DQUOTE$+"ImageNumber"+#DQUOTE$+" value="+#DQUOTE$+Str(pic)+#DQUOTE$+">")
  WriteStringN(A$+"           </OBJECT>")
EndProcedure



Procedure.s FoundAT(text$)
  If UCase(Left(text$,8))="FUNCTION"
    Beep_(800,100)
    ProcedureReturn Right(text$,Len(text$)-8)
  EndIf
EndProcedure



Procedure.s ExtractLink(text$)
  *p.BYTE = @text$
  Repeat
    char = *p\b & $FF
    If (char >= 33 And char <= 126) And char <> ','
      *p+1
    Else
      *p\b = 0
      char = 0
    EndIf
  Until char = 0
  ProcedureReturn text$
EndProcedure


Procedure WriteFuncLine(text$)
  text$ = Trim(text$)
  len   = Len(text$)
  If len And Asc(text$)<>';'
    ; @LineBreak
    text$ = ReplaceString(text$,"@LineBreak","</p><p><br></p><p>",1)
    ; @NewLine
    text$ = ReplaceString(text$,"@NewLine","</p><p></p><p>",1)

    ; @Link
    pos = 0
    Repeat
      klammern$=""
      utext$ = UCase(text$)
      pos = FindString(utext$,"@LINK",pos+1)
      If pos
        ; <a href="+#DQUOTE$+command$+".html"+#DQUOTE$+">"+command$+A$+"</a>
        temp1$ = Left(text$,pos-1)
        temp2$ = Trim(Right(text$,Len(text$)-pos-4))
        link$  = ExtractLink(temp2$)
        temp2$ = Right(temp2$,Len(temp2$)-Len(link$))
        If Right(link$,2)="()"
          link$=Left(link$,Len(link$)-2)
          klammern$="()"
        EndIf
        link$ = ReplaceString(link$,"/","\",1)
        text$=temp1$+"<a href="+#DQUOTE$+link$+".html"+#DQUOTE$+">"+GetFilePart(link$)+klammern$+"</a>"+temp2$
        ;MessageRequester("INFO",temp1$+#LF$+temp2$+#LF$+link$)
        ;MessageRequester("INFO",text$)
      EndIf
    Until pos=0
    
    WriteStringN("<p>"+text$+"</p>")
  EndIf
EndProcedure

Procedure WriteFuncDesc()
  ResetList(lines())
  While NextElement(lines())
    text$ = lines()
    len   = Len(text$)
    If len
      utext$=UCase(text$)
      ; @FUNCTION
      If Left(utext$,9)="@FUNCTION"
        WriteString("<p><b>Syntax:</b><br><br></p></p></td></tr>")
        WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 70px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=100.0%>")
        WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+"><span class="+#DQUOTE$+"highlight"+#DQUOTE$+">"+Trim(Right(text$,len-9))+"</span><br><br></td></tr>")
        WriteStringN("<tr><td><p>")
      ; @DESCRIPTION
      ElseIf Left(utext$,12)="@DESCRIPTION"
        WriteString("<p><b>Description:</b><br><br></p></p></td></tr>")
        WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 70px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=100.0%>")
        WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+"><p>")
        While NextElement(lines())
          If UCase(Left(lines(),15))="@ENDDESCRIPTION"
            Break
          Else
            WriteFuncLine(lines())
          EndIf
        Wend
        WriteStringN("<br></p></td></tr><tr><td><p>")
      ; @PARAMETERS
      ElseIf Left(utext$,11)="@PARAMETERS"
        WriteString("<p><b>Parameters:</b><br><br></p></p></td></tr>")
        WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 70px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=100.0%>")
        WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+"><p>")
        WriteStringN("<table x-use-null-cells style="+#DQUOTE$+"x-cell-content-align: top; border-spacing: 0px; left: 0px; top: 0px;"+#DQUOTE$)
        WriteStringN("width=700 cellspacing=0> <col style="+#DQUOTE$+"width: 20.0%;"+#DQUOTE$+"><col style="+#DQUOTE$+"width: 5.0%;"+#DQUOTE$+"><col style="+#DQUOTE$+"width: 75.0%;"+#DQUOTE$+">")
        While NextElement(lines())
          If UCase(Left(lines(),14))="@ENDPARAMETERS"
            Break
          Else
            temp$  = lines()
            param$ = StringField(temp$,1,"=")
            desc$  = Trim(Right(temp$,Len(temp$)-Len(param$)-1))
            param$ = Trim(param$)
            If desc$ Or param$
              WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 5px; padding-left: 0px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=20.0%>")
              WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+">")
              WriteFuncLine(param$)
              WriteStringN("</td>")
              WriteStringN("<td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 0px; padding-left: 0px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=5.0%>")
              WriteStringN("<p style="+#DQUOTE$+"font-weight: normal;"+#DQUOTE$+">=</td>")
              WriteStringN("<td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 5px; padding-left: 0px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=75.0%>")
              WriteStringN("<p style="+#DQUOTE$+"font-weight: normal;"+#DQUOTE$+">")
              WriteFuncLine(desc$)
              WriteString("</td></tr>")
            EndIf
          EndIf
        Wend
        WriteStringN("</table><br></p></td></tr><tr><td><p>")
      ; @RETURNVALUE
      ElseIf Left(utext$,12)="@RETURNVALUE"
;         WriteString("<p><b>Return Values:</b><br><br></p></p></td></tr>")
;         WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 70px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=100.0%>")
;         WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+"><p>")
;         While NextElement(lines())
;           If UCase(Left(lines(),15))="@ENDRETURNVALUE"
;             Break
;           Else
;             WriteFuncLine(lines())
;           EndIf
;         Wend
;         WriteStringN("<br></p></td></tr><tr><td><p>")
        WriteString("<p><b>Return Values:</b><br><br></p></p></td></tr>")
        WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 70px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=100.0%>")
        WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+"><p>")
        WriteStringN("<table x-use-null-cells style="+#DQUOTE$+"x-cell-content-align: top; border-spacing: 0px; left: 0px; top: 0px;"+#DQUOTE$)
        WriteStringN("width=700 cellspacing=0> <col style="+#DQUOTE$+"width: 20.0%;"+#DQUOTE$+"><col style="+#DQUOTE$+"width: 5.0%;"+#DQUOTE$+"><col style="+#DQUOTE$+"width: 75.0%;"+#DQUOTE$+">")
        While NextElement(lines())
          If UCase(Left(lines(),15))="@ENDRETURNVALUE"
            Break
          Else
            temp$  = lines()
            If FindString(temp$,"=",1)
              param$ = StringField(temp$,1,"=")
              desc$  = Trim(Right(temp$,Len(temp$)-Len(param$)-1))
              param$ = Trim(param$)
              A$     = "="
            Else
              param$ = temp$
              desc$  = ""
              param$ = Trim(param$)
              A$     = ""
            EndIf
            WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 5px; padding-left: 0px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=20.0%>")
            WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+">")
            WriteFuncLine(param$)
            WriteStringN("</td>")
            WriteStringN("<td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 0px; padding-left: 0px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=5.0%>")
            WriteStringN("<p style="+#DQUOTE$+"font-weight: normal;"+#DQUOTE$+">"+A$+"</td>")
            WriteStringN("<td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 5px; padding-left: 0px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=75.0%>")
            WriteStringN("<p style="+#DQUOTE$+"font-weight: normal;"+#DQUOTE$+">")
            WriteFuncLine(desc$)
            WriteString("</td></tr>")
          EndIf
        Wend
        WriteStringN("</table><br></p></td></tr><tr><td><p>")


      ; @REMARKS
      ElseIf Left(utext$,8)="@REMARKS"
        WriteString("<p><b>Remarks:</b><br><br></p></p></td></tr>")
        WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 70px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=100.0%>")
        WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+"><p>")
        While NextElement(lines())
          If UCase(Left(lines(),11))="@ENDREMARKS"
            Break
          Else
            WriteFuncLine(lines())
          EndIf
        Wend
        WriteStringN("<br></p></td></tr><tr><td><p>")
      ; @SOURCEEXAMPLE
      ElseIf Left(utext$,14)="@SOURCEEXAMPLE"
        WriteString("<p><b>Example:</b><br><br></p></p></td></tr>")
        WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 70px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=100.0%>")
        WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+"><pre>")
        While NextElement(lines())
          If UCase(Left(lines(),17))="@ENDSOURCEEXAMPLE"
            Break
          ElseIf UCase(Left(lines(),18))="@NEXTSOURCEEXAMPLE"
            WriteStringN("</pre><p></p><pre>")
          Else
            WriteStringN(lines())
          EndIf
        Wend
        WriteStringN("</pre></td></tr><tr><td><p>")
      ; @SUPPORTEDOS
      ElseIf Left(utext$,12)="@SUPPORTEDOS"
        WriteStringN("<p><br><b>Supported OS:&nbsp;&nbsp;&nbsp;<span class="+#DQUOTE$+"highlight"+#DQUOTE$+">"+Trim(Right(text$,len-12))+"</span></b><br><br></p>")
      ; @IMAGE
      ElseIf Left(utext$,6)="@IMAGE"
        WriteString("<p><b>Image:</b><br><br></p></p></td></tr>")
        WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 70px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=100.0%>")
        WriteString("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+"><p>")
        temp$ = Trim(Right(text$,len-6))
        idx=1
        Repeat
          image$ = Trim(StringField(temp$,idx,","))
          If image$
            If UCase(image$)="@LINEBREAK"
              WriteString("<br>")
            ElseIf UCase(image$)="@SPACE"
              WriteString("&nbsp;")
            Else
              img$=Trim(StringField(image$,1,"|"))
              alt$=Trim(StringField(image$,2,"|"))
              If alt$=""
                alt$=img$
              EndIf
              WriteString("<img src="+#DQUOTE$+img$+#DQUOTE$+" x-maintain-ratio=TRUE border=0 alt="+alt$+">")
            EndIf
          EndIf
          idx+1
        Until image$=""
        WriteStringN("</p><br><br></td></tr>")
        WriteStringN("<tr><td><p>")
      ; @LINEBREAK
      ;ElseIf Left(utext$,10)="@LINEBREAK"
      ;  WriteString("<p><br></p>")
      ; ...
      Else
        WriteFuncLine(text$)
      EndIf
    EndIf
  Wend
  WriteStringN("")
EndProcedure


Procedure GenerateFunctionDescription(lib$,Command$)
  If ReadFile(4,LIBPATH$+lib$+"\"+Command$+".desc")=0
    _Error("cant open description file "+LIBPATH$+lib$+"\"+Command$)
  Else
    ClearList(lines())
    While Eof(4)=0
      line$    = ReadString()
      Repeat
        newline$ = ""
        If Right(line$,2)=" _"
          line$    = Left(line$,Len(line$)-1)
          newline$ = ReadString()
          line$    + newline$
        EndIf
      Until newline$="" Or Eof(4)
      AddElement(lines())
      lines() = line$
    Wend
    CloseFile(4)

    If CreateFile(5,OUTPATH$+Command$+".html")=0
      _Error("cant create file "+OUTPATH$+Command$+".html")
    Else
      WriteStringN("<!DOCTYPE HTML PUBLIC "+#DQUOTE$+"-//IETF//DTD HTML//EN"+#DQUOTE$+">")
      WriteStringN("<html><head><title>"+Command$+"()</title><link rel=StyleSheet href=PBOSL.css></head><body>")
      WriteStringN("<table x-use-null-cells style="+#DQUOTE$+"x-cell-content-align: top; border-spacing: 0px; left: 0px; top: 37px;"+#DQUOTE$)
      WriteStringN(" width=800px cellspacing=0> <col style="+#DQUOTE$+"width: 100.0%;"+#DQUOTE$+">")
      WriteStringN("<tr valign=top><td><h2>"+Command$+"</h2>")
      WriteStringN("</td></tr><tr><td><p>")
        WriteFuncDesc()
      WriteStringN("</p></td></tr>")
      WriteStringN("</table><p>&nbsp;</p></body></html>")
      CloseFile(5)
      UseFile(1)
      AddSite(Command$,Command$+".html",7)
    EndIf
  EndIf
EndProcedure



Procedure AddLibraryCommands(lib$)
    ; Introduction
    If FileSize(LIBPATH$+lib$+"\Intro.html")>0
      AddElement(files())
      files() = "Intro_"+lib$+".html"
      CopyFile(LIBPATH$+lib$+"\Intro.html",OUTPATH$+files())
      AddSite("Introduction",files(),7)
    EndIf

    ; Overview
    If FileSize(LIBPATH$+lib$+"\Overview.txt")>0
      If ReadFile(2,LIBPATH$+lib$+"\Overview.txt")=0
        _Error("cant read file: "+LIBPATH$+lib$+"\Overview.txt")
      Else
        name$ = "Overview_"+lib$+".html"
        If CreateFile(3,OUTPATH$+name$)=0
          _Error("cant create file: "+OUTPATH$+name$)
        Else
          UseFile(1)
          AddElement(files())
          files() = name$
          AddSite("Overview",name$,7)
          UseFile(3)

          WriteStringN("<!DOCTYPE HTML PUBLIC "+#DQUOTE$+"-//IETF//DTD HTML//EN"+#DQUOTE$+">")
          WriteStringN("<html><head><title>Overview</title><link rel=StyleSheet href=PBOSL.css></head>")
          WriteStringN("<body>")
          WriteStringN("<h2>"+lib$+" Overview</h2>")
          WriteStringN("<table x-use-null-cells style="+#DQUOTE$+"x-cell-content-align: top; border-spacing: 0px; left: 0px; top: 37px;"+#DQUOTE$)
          WriteStringN(" width=800px cellspacing=0> <col style="+#DQUOTE$+"width: 40.0%;"+#DQUOTE$+"><col style="+#DQUOTE$+"width: 60.0%;"+#DQUOTE$+">")

          While Eof(2)=0
            UseFile(2)
            Line$ = Trim(ReadString())
            UseFile(3)
            If Line$ And Asc(Line$)<>';'
              If Asc(Line$)='*'
                ; Header
                Line$ = Trim(Right(Line$,Len(Line$)-1))
                WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 10px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=40.0%>")
                WriteStringN("<p style="+#DQUOTE$+"font-weight: bold;"+#DQUOTE$+"><br>"+Line$+"<br><br></td></tr>")
              ElseIf UCase(Left(Line$,12))="@DESCRIPTION"
                ; @DESCRIPTION
                WriteStringN("</table><table x-use-null-cells style="+#DQUOTE$+"x-cell-content-align: top; border-spacing: 0px; left: 0px; top: 37px;"+#DQUOTE$)
                WriteStringN(" width=800px cellspacing=0> <col style="+#DQUOTE$+"width: 100.0%;"+#DQUOTE$+">")

                WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 10px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=100.0%>")
                WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+"><p>")
                While Eof(2)=0
                  UseFile(2)
                  Line$ = Trim(ReadString())
                  UseFile(3)
                  If UCase(Left(Line$,15))="@ENDDESCRIPTION"
                     Break
                  Else
                     WriteFuncLine(Line$)
                  EndIf
                Wend
                WriteStringN("</tr></tr></table>")
                WriteStringN("<table x-use-null-cells style="+#DQUOTE$+"x-cell-content-align: top; border-spacing: 0px; left: 0px; top: 37px;"+#DQUOTE$)
                WriteStringN(" width=800px cellspacing=0> <col style="+#DQUOTE$+"width: 40.0%;"+#DQUOTE$+"><col style="+#DQUOTE$+"width: 60.0%;"+#DQUOTE$+">")
              Else
                ; Command and Description
                A$ = ""
                If UCase(Line$) = "<BR>" Or UCase(Line$) = "@NEWLINE" Or UCase(Line$) = "@LINEBREAK" ; empty line
                   Line$ = "<br> <br>"
                ElseIf Asc(Line$)='.'                  ; .XYZ       = XYZ is no function
                   Line$ = Trim(Right(Line$,Len(Line$)-1))
                Else                                   ;            = function, add brackets ()
                   A$ = "()"
                EndIf
                Command$ = StringField(Line$,1," ")
                Line$    = Trim(Right(Line$,Len(Line$)-Len(command$)))
                WriteStringN("<tr valign=top> <td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 20px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=40.0%>")
                WriteStringN("<p style="+#DQUOTE$+"font-weight: bold; x-text-underline: off;"+#DQUOTE$+"><a href="+#DQUOTE$+command$+".html"+#DQUOTE$+">"+command$+A$+"</a></td>")
                WriteStringN("<td colspan=1 rowspan=1 style="+#DQUOTE$+"padding-right: 10px; padding-left: 10px; border-bottom-style: none; border-right-style: none; border-left-style: none; border-top-style: none;"+#DQUOTE$+" width=60.0%>")
                WriteStringN("<p style="+#DQUOTE$+"font-weight: normal;"+#DQUOTE$+">"+Line$+"</td></tr>")
                
                ; generate function description
                If Command$ And Line$ <> "<br> <br>"
                  If FileSize(LIBPATH$+lib$+"\"+Command$+".desc")>0
                    GenerateFunctionDescription(lib$,Command$)
                  Else
                    _Error("cant find file "+LIBPATH$+lib$+"\"+Command$+".desc")
                  EndIf
                EndIf
              EndIf
            EndIf
          Wend

          UseFile(3)
          WriteStringN("</table><p>&nbsp;</p></body></html>")
          CloseFile(3)

        EndIf
        CloseFile(2)
      EndIf
    Else
      _Error("Overview.txt for library '"+lib$+"' missing!")
    EndIf
  If ExamineDirectory(0,LIBPATH$+lib$,"")
    Repeat
      Select NextDirectoryEntry()
        Case 0
          Break
        Case 1
          Name$ = UCase(DirectoryEntryName())
          If Name$ <> "." And Name$ <> ".." And Name$ <> "INTRO.HTML" And Name$ <> "OVERVIEW.TXT" And GetExtensionPart(Name$) <> "DESC"
            CopyFile(LIBPATH$+lib$+"\"+Name$,OUTPATH$+Name$)
          EndIf
      EndSelect
    ForEver
  EndIf
EndProcedure



Procedure AddLibrary(lib$)
  WriteStringN("      <LI> <OBJECT type="+#DQUOTE$+"text/sitemap"+#DQUOTE$+">")
  WriteStringN("             <param name="+#DQUOTE$+"Name"+#DQUOTE$+" value="+#DQUOTE$+lib$+#DQUOTE$+">")
  WriteStringN("             <param name="+#DQUOTE$+"ImageNumber"+#DQUOTE$+" value="+#DQUOTE$+"1"+#DQUOTE$+">")
  WriteStringN("           </OBJECT>")
  WriteStringN("           <UL>")
    AddLibraryCommands(lib$)
  UseFile(1)
  WriteStringN("           </UL>")
EndProcedure



; ExecutableFormat=
; EOF