;
;  AppRunning ?
;  (c) 2002 Siegfried Rings
;    This library is free software; you can redistribute it and/or
;    modify it under the terms of the GNU Lesser General Public
;    License as published by the Free Software Foundation; either
;    version 2.1 of the License, Or (at your option) any later version.
;
;    This library is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
;    Lesser General Public License For more details. 
;
; this Function is to Check if a app is already present
; you have to call function at start of your code
;
; many thx must got to DANILO for generally helping 

%macro PBFunction 1 ;Thx Fred for this handy-macro
  GLOBAL PB_%1
PB_%1:
%endmacro

EXTERN _GetLastError@0 ;this is a ApiCall
EXTERN _CloseHandle@4  ; same
EXTERN _CreateMutexA@12; same 
EXTERN _GetLastError@0 ; same
EXTERN _SYS_GetParameterIndex@4 ;(const TCHAR *Parameter);
EXTERN _SYS_ResolveParameter@4 ;(int Index);

SEGMENT .text USE32 CLASS=CODE

PBFunction AppRunning_Init ;Init the AppRunning nothing to do here now.
  RET
 
PBFunction AppRunning_END ;Exit the AppRunning
  CMP dword [v_hMutex] ,0 ;compare MUTEX Variable against NULL
  JE AppEnd2
  PUSH   EAX ;Push MutexHandler to stack
  CALL  _CloseHandle@4 ;Close that Mutex now
  XOR    eax,eax;Set eax to NULL
AppEnd2:
RET;return

PBFunction AppRunning ;This is the PurebasicFunctionsEntryPoint
  MOV dword [v_Stringadress],eax ;save Stringadress of AppName (First Argument is always in EAX, rest(if there are some) are on stack
  PUSH eax
  CALL _SYS_GetParameterIndex@4
  CMP eax, 0
  JE .nopbstring
    PUSH eax
    CALL _SYS_ResolveParameter@4
    MOV dword [v_Stringadress],eax
  .nopbstring

  Mov eax,[v_MutexCreated];Move Content from this Variable into eax
  cmp eax,0; Compare them against NULL,Is there already a Mutex (From my own) ?
  jne NotRunning ;Okay our Mutex iss already created so we can leave the function

  PUSH dword [v_Stringadress];Push Adress of String AppName on Stack
  PUSH   dword 0;NULL to Stack
  PUSH   dword 0;NULL to Stack
  CALL  _CreateMutexA@12;Create a new Mutex now!
  MOV    dword [v_hMutex],eax;save MutexNumber(Handler)
  CALL  _GetLastError@0;Ask GetLastError 
  cmp eax,183 ;#ERROR_ALREADY_EXISTS  IS already running ?
  je IsRunning;YES so jump to IsRunning-Label
  Mov dword [v_MutexCreated],1 ;Save new MutexFlag
NotRunning:
  MOV eax,0 ;Move NULL in Return-Agrument
  RET 

IsRunning:
  PUSH   dword [v_hMutex] ;Okay we do not need the Mutex anymore
  CALL  _CloseHandle@4    ;so we Close him now.
  MOV    dword [v_hMutex],0;and delete save Mutexhandler
  Mov eax,1;Okay there is another App running so we Set One as Back
  RET 

SEGMENT .bss CLASS=DATA
ALIGNB 4;
v_hMutex RESD 1
v_Stringadress RESD 1
v_MutexCreated RESD 1
I_BSSEnd
