;Normalisieren des Vectors.
; s.f = 1/sqr(x*x + y*y + z*z)
; x*s
; y*s
; z*s

format MS COFF
Public PB_Vector_Normalize2
section '.text' code readable executable
PB_Vector_Normalize2:
; dword [esp+ 0] : rcksprungadresse
; dword [esp+ 4] : Vector der Normalisiert werden muss.
; dword [esp+ 8] : Zielvector
MOV	eax, [esp+4]	; lade den pointer zu den Vector in eax
MOV	ebx, [esp+8]	; lade den Pointer zum Zielvector in ebx
FLD	dword [eax]	; lade X Wert des Vectors
; st0 : x
FMUL	st0,st0		; x*x
; st0 : x*x
FLD	dword [eax+4]	; lade Y Wert des Vectors
; st0 : y
; st1 : x*x
FMUL	st0,st0		; y*y
; st0 : y*y
; st1 : x*x
FLD	dword [eax+8]	; lade Z Wert des Vectors
; st0 : z
; st1 : y*y
; st2 : x*x
FMUL	st0,st0		; z*z
; st0 : z*z
; st1 : y*y
; st2 : x*x
FADD	st0,st1
; st0 : z*z + y*y
; st1 : y*y
; st2 : x*x
FADD	st0,st2
; st0 : z*z + y*y + x*x
; st1 : y*y
; st2 : x*x
FSQRT
; st0 : sqr(z*z + y*y + x*x)
; st1 : y*y
; st2 : x*x
FLD1			; Lade 1
; st0 : 1
; st1 : sqr(z*z + y*y + x*x)
; st2 : y*y
; st3 : x*x
FDIV	st0,st1		; dividere st0/st1
; st0 : 1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : y*y
; st3 : x*x
FSTP	st3
; st0 : sqr(z*z + y*y + x*x)
; st1 : y*y
; st2 : 1/sqr(z*z + y*y + x*x)
FSTP	st1
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
FLD	dword [eax]	; lade x
; st0 : x
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FMUL	st0,st2		; 1/sqr(z*z + y*y + x*x)*x -> st0
; st0 : x*1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FSTP	dword [ebx]	; Speicher das x ergebniss
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
FLD	dword [eax+4]	; lade y
; st0 : y
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FMUL	st0,st2		; 1/sqr(z*z + y*y + x*x)*y -> st0
; st0 : y*1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FSTP	dword [ebx+4]	; speicher das y ergebniss
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
FLD	dword [eax+8]	; lade z
; st0 : z
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FMUL	st0,st2		; 1/sqr(z*z + y*y + x*x)*z -> st0
; st0 : z*1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FSTP	dword [ebx+8]	; speicher das z ergebniss
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
FSTP	st1
; st0 : sqr(z*z + y*y + x*x)
FSTP	st0
RET	8