;Normalisieren des Vectors.
; s.f = 1/sqr(x*x + y*y + z*z)
; x*s
; y*s
; z*s

format MS COFF
Public PB_Vector_Normalize3
section '.text' code readable executable
PB_Vector_Normalize3:
; dword [esp+ 0] : rcksprungadresse
; dword [esp+ 4] : x Pointer
; dword [esp+ 8] : y Pointer
; dword [esp+12] : z Pointer
MOV	eax,[esp+4]	; lade den Pointer zu X
FLD	dword [eax]	; lade X Wert des Vectors
; st0 : x
FMUL	st0,st0		; x*x
; st0 : x*x
MOV	eax,[esp+8]	; lade den Pointer zu Y
FLD	dword [eax]	; lade Y Wert des Vectors
; st0 : y
; st1 : x*x
FMUL	st0,st0		; y*y
; st0 : y*y
; st1 : x*x
MOV	eax,[esp+12]	; lade den Pointer zu Z
FLD	dword [eax]	; lade Z Wert des Vectors
; st0 : z
; st1 : y*y
; st2 : x*x
FMUL	st0,st0		; z*z
; st0 : z*z
; st1 : y*y
; st2 : x*x
FADD	st0,st1
; st0 : z*z + y*y
; st1 : y*y
; st2 : x*x
FADD	st0,st2
; st0 : z*z + y*y + x*x
; st1 : y*y
; st2 : x*x
FSQRT
; st0 : sqr(z*z + y*y + x*x)
; st1 : y*y
; st2 : x*x
FLD1			; Lade 1
; st0 : 1
; st1 : sqr(z*z + y*y + x*x)
; st2 : y*y
; st3 : x*x
FDIV	st0,st1		; dividere st0/st1
; st0 : 1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : y*y
; st3 : x*x
FSTP	st3
; st0 : sqr(z*z + y*y + x*x)
; st1 : y*y
; st2 : 1/sqr(z*z + y*y + x*x)
FSTP	st1
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
MOV	eax,[esp+4]	; lade pointer zu x
FLD	dword [eax]	; lade x
; st0 : x
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FMUL	st0,st2		; 1/sqr(z*z + y*y + x*x)*x -> st0
; st0 : x*1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
MOV	eax, [esp+4]	; lade x pointer
FSTP	dword [eax]	; Speicher das x ergebniss im pointer
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
MOV	eax,[esp+8]     ; lade pointer zu y
FLD	dword [eax]	; lade y
; st0 : y
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FMUL	st0,st2		; 1/sqr(z*z + y*y + x*x)*y -> st0
; st0 : y*1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
MOV	eax, [esp+8]   ; lade y pointer
FSTP	dword [eax]	; Speicher das y ergebniss im pointer
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
MOV	eax,[esp+12]    ; lade pointer zu z
FLD	dword [eax]	; lade z
; st0 : z
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FMUL	st0,st2		; 1/sqr(z*z + y*y + x*x)*z -> st0
; st0 : z*1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
MOV	eax, [esp+12]   ; lade z pointer
FSTP	dword [eax]	; Speicher das z ergebniss im pointer
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
FSTP	st1
; st0 : sqr(z*z + y*y + x*x)
FSTP	st0
RET	12