;Normalisieren des Vectors.
; s.f = 1/sqr(x*x + y*y + z*z)
; x*s
; y*s
; z*s

format MS COFF
Public PB_Vector_Normalize4
section '.text' code readable executable
PB_Vector_Normalize4:
; dword [esp+ 0] : rcksprungadresse
; dword [esp+ 4] : x wert
; dword [esp+ 8] : y wert
; dword [esp+12] : z wert
; dword [esp+16] : x ziel Pointer
; dword [esp+20] : y ziel Pointer
; dword [esp+24] : z ziel Pointer

FLD	dword [esp+4]	; lade X Wert des Vectors
; st0 : x
FMUL	st0,st0		; x*x
; st0 : x*x
FLD	dword [esp+8]	; lade Y Wert des Vectors
; st0 : y
; st1 : x*x
FMUL	st0,st0		; y*y
; st0 : y*y
; st1 : x*x
FLD	dword [esp+12]	; lade Z Wert des Vectors
; st0 : z
; st1 : y*y
; st2 : x*x
FMUL	st0,st0		; z*z
; st0 : z*z
; st1 : y*y
; st2 : x*x
FADD	st0,st1
; st0 : z*z + y*y
; st1 : y*y
; st2 : x*x
FADD	st0,st2
; st0 : z*z + y*y + x*x
; st1 : y*y
; st2 : x*x
FSQRT
; st0 : sqr(z*z + y*y + x*x)
; st1 : y*y
; st2 : x*x
FLD1			; Lade 1
; st0 : 1
; st1 : sqr(z*z + y*y + x*x)
; st2 : y*y
; st3 : x*x
FDIV	st0,st1		; dividere st0/st1
; st0 : 1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : y*y
; st3 : x*x
FSTP	st3
; st0 : sqr(z*z + y*y + x*x)
; st1 : y*y
; st2 : 1/sqr(z*z + y*y + x*x)
FSTP	st1
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
FLD	dword [esp+4]	; lade x
; st0 : x
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FMUL	st0,st2		; 1/sqr(z*z + y*y + x*x)*x -> st0
; st0 : x*1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
MOV	eax, [esp+16]   ; lade x pointer
FSTP	dword [eax]	; Speicher das x ergebniss im pointer
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
FLD	dword [esp+8]	; lade y
; st0 : y
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FMUL	st0,st2		; 1/sqr(z*z + y*y + x*x)*y -> st0
; st0 : y*1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
MOV	eax, [esp+20]   ; lade y pointer
FSTP	dword [eax]	; Speicher das y ergebniss im pointer
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
FLD	dword [esp+12]	; lade z
; st0 : z
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
FMUL	st0,st2		; 1/sqr(z*z + y*y + x*x)*z -> st0
; st0 : z*1/sqr(z*z + y*y + x*x)
; st1 : sqr(z*z + y*y + x*x)
; st2 : 1/sqr(z*z + y*y + x*x)
MOV	eax, [esp+24]   ; lade z pointer
FSTP	dword [eax]	; Speicher das z ergebniss im pointer
; st0 : sqr(z*z + y*y + x*x)
; st1 : 1/sqr(z*z + y*y + x*x)
FSTP	st1
; st0 : sqr(z*z + y*y + x*x)
FSTP	st0
RET	24