;Spatproduct(Vector *a,Vector *b,Vector *c)
;Erechnet das Spatprodukt der gegebenen Vectoren.
;Formel des Spatproduktes:
;result = (ay * bz - az * by)*cx + (az * bx - ax * bz)*cy + (ax * by - ay * bx)*cz

format MS COFF
Public PB_Vector_Spatproduct
section '.text' code readable executable
PB_Vector_Spatproduct:
; dword [esp+ 0] : rcksprungadresse
; dword [esp+ 4] : Vector a
; dword [esp+ 8] : Vector b
; dword [esp+12] : Vector c

MOV	eax,[esp+4]	; Speichere den Pointer zum vector a in eax
MOV	ebx,[esp+8]	; Speichere den Pointer zum Vector b in eax
PUSH	ecx		; Speichere Altes ecx
; dword [esp+ 0] : altes ecx
; dword [esp+ 4] : rcksprungadresse
; dword [esp+ 8] : Vector a
; dword [esp+12] : Vector b
; dword [esp+16] : Vector c
MOV	ecx,[esp+16]	; Speichere den Pointer zum Vector c in eax

FLD	dword [eax+4]	; Lade ay
; st0 : ay
FMUL	dword [ebx+8]	; Multiplitziere mit bz
; st0 : ay*bz
FLD	dword [eax+8]	; lade az
; st0 : az
; st1 : ay*bz
FMUL	dword [ebx+4]	; Multiplitziere mit by
; st0 : az*by
; st1 : ay*bz
FSUBP	st1,st0		; ay*bz-az*by
; st0 : ay*bz-az*by
FMUL	dword [ecx]	; Multiplitziere mit cx
; st0 : (ay*bz-az*by)*cx

FLD	dword [eax+8]	; lade az
; st0 : az
; st1 : (ay*bz-az*by)*cx
FMUL	dword [ebx]	; Multiplitziere mit bx
; st0 : az*bx
; st1 : (ay*bz-az*by)*cx
FLD	dword [eax]	; lade ax
; st0 : ax
; st1 : az*bx
; st2 : (ay*bz-az*by)*cx
FMUL	dword [ebx+8]	; Multiplitziere mit bz
; st0 : ax*bz
; st1 : az*bx
; st2 : (ay*bz-az*by)*cx
FSUBP	st1,st0		; az*bx-ax*bz
; st0 : az*bx-ax*bz
; st1 : (ay*bz-az*by)*cx
FMUL	dword [ecx+4]	; Multiplitziere mit cy
; st0 : (az*bx-ax*bz)*cy
; st1 : (ay*bz-az*by)*cx

FADDP	st1,st0		; Addiere (ay*bz-az*by)*cx mit (az*bx-ax*bz)*cy
; st0 : (ay*bz-az*by)*cx + (az*bx-ax*bz)*cy

FLD	dword [eax]	; lade ax
; st0 : ax
; st1 : (ay*bz-az*by)*cx + (az*bx-ax*bz)*cy
FMUL	dword [ebx+4]	; Multiplitziere mit by
; st0 : ax*by
; st1 : (ay*bz-az*by)*cx + (az*bx-ax*bz)*cy
FLD	dword [eax+4]	; Lade ay
; st0 : ay
; st1 : ax*by
; st2 : (ay*bz-az*by)*cx + (az*bx-ax*bz)*cy
FMUL	dword [ebx]	; Multiplitzire mit bx
; st0 : ay*bx
; st1 : ax*by
; st2 : (ay*bz-az*by)*cx + (az*bx-ax*bz)*cy
FSUBP	st1,st0		; ax*by-ay*bx
; st0 : ax*by-ay*bx
; st1 : (ay*bz-az*by)*cx + (az*bx-ax*bz)*cy
FMUL	dword [ecx+8]	; Multiplitziere mit cz
; st0 : (ax*by-ay*bx)*cz
; st1 : (ay*bz-az*by)*cx + (az*bx-ax*bz)*cy

FADDP	st1,st0		; Addiere (ay*bz-az*by)*cx + (az*bx-ax*bz)*cy mit (ax*by-ay*bx)*cz
; st0 : (ay*bz-az*by)*cx + (az*bx-ax*bz)*cy + (ax*by-ay*bx)*cz

POP	ecx		; Schreibe altes ecx zurck
RET	12