/*
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */


/*
 *
 *   works on Windows + Linux  -  should work on MacOS too
 *   -----------------------------------------------------
 *
 */


/*
 *
 * PBOSL declarations
 *
 */

#if _WIN32 == 1
  #define PBFUNCTION(a) extern a __stdcall   /* for Windows */
#else
  #define PBFUNCTION(a) extern a             /* for Linux   */
#endif

/* 
 *
 * PBOSL_AnimSprite
 *
 */
typedef struct {
   long SpriteNumber;
   unsigned long Transparent;
   unsigned long Xsize;
   unsigned long Ysize;
   unsigned long AnimCount;
   unsigned long DirectionCount;
   unsigned long currentAnim;
   unsigned long currentDirection;
   unsigned long XclipStart;
   unsigned long YclipStart;
   unsigned long AutoFrameTime;
   unsigned long AutoFrameDirection;
   unsigned long AutoFrameLastTime;
} AnimSprite;


PBFUNCTION(unsigned long) PB_NextAnimFrame(AnimSprite *anim);
PBFUNCTION(unsigned long) PB_PrevAnimFrame(AnimSprite *anim);

PBFUNCTION(AnimSprite*)   PB_CreateAnimSprite(AnimSprite *anim,
                                              long sprite,
                                              unsigned long xsize,
                                              unsigned long ysize);

PBFUNCTION(unsigned long) PB_CollisionAnimSprite2(AnimSprite *anim,
                                                  long x1,
                                                  long y1,
                                                  long sprite,
                                                  long x2,
                                                  long y2,
                                                  unsigned long collisionmode );

PBFUNCTION(unsigned long) PB_CollisionSpriteAnim2(long sprite,
                                                  long x1,
                                                  long y1,
                                                  AnimSprite *anim,
                                                  long x2,
                                                  long y2,
                                                  unsigned long collisionmode );

PBFUNCTION(unsigned long) PB_CollisionAnimAnim2(AnimSprite *anim1,
                                                long x1,
                                                long y1,
                                                AnimSprite *anim2,
                                                long x2,
                                                long y2,
                                                unsigned long collisionmode );

PBFUNCTION(void)          AnimSprite_CalcClipStart(AnimSprite *anim);
PBFUNCTION(void)          AnimSprite_CalcAnimSpriteDisplay(AnimSprite *anim);



/* 
 *
 * imported PureBasic functions
 *
 */

PBFUNCTION(unsigned long) PB_SpriteWidth(long sprite);
PBFUNCTION(unsigned long) PB_SpriteHeight(long sprite);

PBFUNCTION(long) PB_ClipSprite(long sprite,
                               unsigned long xstart,
                               unsigned long ystart,
                               unsigned long width,
                               unsigned long height);

PBFUNCTION(long) PB_DisplayTransparentSprite(long sprite,
                                             long x,
                                             long y);

PBFUNCTION(long) PB_SpritePixelCollision(long sprite1,
                                         long x1,
                                         long y1,
                                         long sprite2,
                                         long x2,
                                         long y2);

PBFUNCTION(long) PB_SpriteCollision(long sprite1,
                                    long x1,
                                    long y1,
                                    long sprite2,
                                    long x2,
                                    long y2);

PBFUNCTION(unsigned long) PB_ElapsedMilliseconds();
