/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "AnimSprite.h" /* Win + Linux + MacOS? */



PBFUNCTION(unsigned long) PB_CollisionAnimAnim2(AnimSprite *anim1,
                                                long x1,
                                                long y1,
                                                AnimSprite *anim2,
                                                long x2,
                                                long y2,
                                                unsigned long collisionmode ) {
   // check collision animsprite vs. animsprite
   //
   // collisonmode:
   //    0 = exact pixel collision (default)
   //    1 = block collision
   if (anim1 && anim2) {
      PB_ClipSprite( anim1->SpriteNumber,
                     anim1->XclipStart,
                     anim1->YclipStart,
                     anim1->Xsize,
                     anim1->Ysize );

      PB_ClipSprite( anim2->SpriteNumber,
                     anim2->XclipStart,
                     anim2->YclipStart,
                     anim2->Xsize,
                     anim2->Ysize );

      if(!collisionmode)
         return PB_SpritePixelCollision(anim1->SpriteNumber, x1, y1,
                                        anim2->SpriteNumber, x2, y2 );
      else
         return PB_SpriteCollision(anim1->SpriteNumber, x1, y1,
                                   anim2->SpriteNumber, x2, y2 );
   }
   return 0;
}
