/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "AnimSprite.h" /* Win + Linux + MacOS? */



PBFUNCTION(unsigned long) PB_CollisionAnimSprite2(AnimSprite *anim,
                                                  long x1,
                                                  long y1,
                                                  long sprite,
                                                  long x2,
                                                  long y2,
                                                  unsigned long collisionmode ) {
   // check collision animsprite vs. sprite
   //
   // collisonmode:
   //    0 = exact pixel collision (default)
   //    1 = block collision
   if(anim) {
      PB_ClipSprite( anim->SpriteNumber,
                     anim->XclipStart,
                     anim->YclipStart,
                     anim->Xsize,
                     anim->Ysize );

      if(!collisionmode)
         return PB_SpritePixelCollision(anim->SpriteNumber,x1,y1,sprite,x2,y2);
      else
         return PB_SpriteCollision(anim->SpriteNumber,x1,y1,sprite,x2,y2);
   }
   return 0;
}
