/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "AnimSprite.h" /* Win + Linux + MacOS? */



PBFUNCTION(AnimSprite*) PB_CreateAnimSprite(AnimSprite *anim,
                                            long sprite,
                                            unsigned long xsize,
                                            unsigned long ysize ) {
   if(!anim) return 0; // check 0-pointer

   anim->SpriteNumber       = sprite;                           // Sprite-Number
   anim->Xsize              = xsize;                            // X-Size of 1 Frame
   anim->Ysize              = ysize;                            // Y-Size of 1 Frame
   anim->currentAnim        = 1;                                // current Anim
   anim->currentDirection   = 1;                                // current Direction
   anim->AutoFrameTime      = 0;                                // time between frames
   anim->AutoFrameDirection = 0;                                // Direction - default: right -->
   anim->AutoFrameLastTime  = 0;                                // last time in ms
   
   anim->AnimCount          = PB_SpriteWidth(sprite)  / xsize;  // Anim-Count
   anim->DirectionCount     = PB_SpriteHeight(sprite) / ysize;  // Direction-Count

   return anim;
}
