/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "AnimSprite.h" /* Win + Linux + MacOS? */



PBFUNCTION(void) AnimSprite_CalcAnimSpriteDisplay(AnimSprite *anim) {
   // if automatic animation is used,
   // it calculates the current frame

   // if automatic animation, update frames
   if (anim->AutoFrameTime) {
      if ( anim->AutoFrameLastTime == 0 ) {
         // set start time for the first time
         anim->AutoFrameLastTime = PB_ElapsedMilliseconds();
      }
      else {
         int temp, temp2;
         temp  = PB_ElapsedMilliseconds();
         temp2 = anim->AutoFrameLastTime + anim->AutoFrameTime;

         // time to update
         if (temp2 == temp) {
            anim->AutoFrameLastTime = temp;

            if ( anim->AutoFrameDirection ) PB_PrevAnimFrame(anim);
            else                            PB_NextAnimFrame(anim);
         }
         // catch up frames
         else if (temp2 < temp) {
            unsigned long difference;
            difference = (temp - temp2) / anim->AutoFrameTime;
            difference++;

            while (difference) { // loop to update frames
               if ( anim->AutoFrameDirection ) PB_PrevAnimFrame(anim);
               else                            PB_NextAnimFrame(anim);
               difference--;
            }

            // exactly update last frame time
            difference = anim->AutoFrameTime % (temp - temp2);
            anim->AutoFrameLastTime = temp + difference;
         }
      }
   }

   // set sprite clipping
   PB_ClipSprite( anim->SpriteNumber,
                  anim->XclipStart,
                  anim->YclipStart,
                  anim->Xsize,
                  anim->Ysize );
}
