/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "SkinWin.h"


PBFUNCTION(long) PB_SetWinBackgroundImage2(HWND win, HBITMAP bmp, long redraw) {
   if(win && bmp) {
     /*
     if (GetWindowLong(win,GWL_STYLE)&WS_CHILD) {
        LOGBRUSH lb;
        lb.lbStyle = BS_PATTERN;
        //lb.lbColor = DIB_RGB_COLORS;
        lb.lbHatch = (long)bmp;
        HBRUSH brush = CreateBrushIndirect(&lb);
        if (brush) {
           DeleteObject((HGDIOBJ)SetClassLong(win,GCL_HBRBACKGROUND,(long)brush));
           return 1;
        }
        return 0;
     }
     */
     long index = sub_swGetBackground(win,1);
     if (index != -1) {
        // get new bitmap dimension
        BITMAP bmpstruct;
        if (GetObject(bmp,sizeof(BITMAP),&bmpstruct)) {
           sw_BackgroundArea[index].width       = bmpstruct.bmWidth;
           sw_BackgroundArea[index].height      = bmpstruct.bmHeight;
        }
        else return 0;
  
        // set window handle
        sw_BackgroundArea[index].window = win;
  
        // set new callback, if not already done
        if (sw_BackgroundArea[index].oldCallback == 0)//(WNDPROC)sub_swBackgroundCallback)
            sw_BackgroundArea[index].oldCallback
                = (WNDPROC)SetWindowLong(win,GWL_WNDPROC,(long)sub_swBackgroundCallback);
  
        // delete old background brush
        DeleteObject((HGDIOBJ)SetClassLong(win,GCL_HBRBACKGROUND,0));
  
        sw_BackgroundArea[index].hBmp = bmp;
  
        // redraw window background
        if(redraw) {
          InvalidateRect(win,0,1);
          UpdateWindow(win);
        }
  
        // return true - successful
        return index+1; // true = index+1, needed by SetWinBackgroundColor
     }
   }
   // failed
   return 0;
}

