/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include <windows.h>
#include <PBOSL.h>

//#define And &&
//#define Or  ||

typedef struct {
   HWND     window;      // window handle
   WNDPROC  oldCallback; // original window callback

   HBITMAP  hBmp;        // background bitmap handle
   long     hBmp_free;   // flag for SetWinBackgroundColor

   long     width;       // width  of background image
   long     height;      // height of background image
} _sw_Background;

//typedef struct {
//   _sw_Background *back[];
//} _sw_BackgroundArea;

extern _sw_Background            *sw_BackgroundArea;
extern long                       sw_BackgroundAreaSize;
extern HDC                        sw_hDC;

// INTERNAL FUNCTIONS

PBFUNCTION(LRESULT) CALLBACK sub_swBackgroundCallback(HWND hwnd,UINT Msg,WPARAM wParam,LPARAM lParam);

PBFUNCTION(long) PB_SetWinBackgroundImage2(HWND hWnd, HBITMAP hBmp, long redraw);
PBFUNCTION(HRGN) PB_SkinWinMakeRegion    (HBITMAP hBmp, long x, long y);
PBFUNCTION(long) PB_SkinWin2             (HWND hWnd, HBITMAP hBmp, long x, long y);

PBFUNCTION(long) sub_swGetBackground (HWND win, long getnew);
PBFUNCTION(void) sub_swRedraw        (HWND hWnd);
PBFUNCTION(void) sub_swChangeStyle   (HWND hWnd,unsigned long flag,unsigned long set);
PBFUNCTION(void) sub_swChangeExStyle (HWND hWnd,unsigned long flag,unsigned long set);
PBFUNCTION(long) sub_swEnableMenuItem(HWND hWnd,unsigned long item,unsigned long OnOff);

// PB MEMORY FUNCTIONS
PBFUNCTION(void*) PB_AllocateMemory(long size);
PBFUNCTION(long)  PB_FreeMemory(void *memory);
PBFUNCTION(void*) PB_ReAllocateMemory(void *memory, long new_size);
