/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "SkinWin.h"


PBFUNCTION(HRGN) PB_SkinWinMakeRegion(HBITMAP hBmp,
                                      long    x,
                                      long    y) {
   if(hBmp) {
      HDC      hDC_bmp;
      HBITMAP  hBmp_old;
      BITMAP   bmpstruct;
      COLORREF transparent, color;
      HRGN     LineRegion=0, FullRegion=0;
      long     In_Line=0, In_First_Region=1, StartLine_X=0;

      // get bitmap dimension
      if (GetObject(hBmp,sizeof(BITMAP),&bmpstruct)==0) return 0;

      // create DC
      if(!(hDC_bmp = CreateCompatibleDC(0))) return 0;

      // use DC with hBmp
      hBmp_old = SelectObject(hDC_bmp,hBmp);

      // get transparent pixel
      transparent = GetPixel(hDC_bmp,x,y);
      
      // scan image and make region
      for(y=0; y<bmpstruct.bmHeight; y++) {
         for(x=0; x<bmpstruct.bmWidth; x++) {
            color = GetPixel(hDC_bmp,x,y);
            if((color==transparent) || (x == bmpstruct.bmWidth-1)) {
               if(In_Line) {
                  In_Line    = 0;
                  LineRegion = CreateRectRgn(StartLine_X,y,x,y+1);
                  if(In_First_Region) {
                     In_First_Region = 0;
                     FullRegion      = LineRegion;
                  }
                  else {
                     CombineRgn(FullRegion,FullRegion,LineRegion,RGN_OR);
                     DeleteObject(LineRegion);
                  }
               }
            }
            else if(In_Line == 0) {
               In_Line     = 1;
               StartLine_X = x;
            }
         }
      }
      // cleanup
      SelectObject(hDC_bmp,hBmp_old);
      DeleteDC(hDC_bmp);
      // return region
      return FullRegion;
   }
   return 0;
}

