/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "SkinWin.h"


PBFUNCTION(LRESULT) CALLBACK sub_swBackgroundCallback(HWND   hWnd,   // handle of window
                                          UINT   Msg,	   // message identifier
                                          WPARAM wParam, // first message parameter
                                          LPARAM lParam  // second message parameter
                                         ) {

   
   
   if (!sw_hDC) sw_hDC = CreateCompatibleDC(0);
/*
   {
      HDC DesktopDC  = GetDC(GetDesktopWindow());
      sw_hDC = CreateCompatibleDC(DesktopDC);
      ReleaseDC(GetDesktopWindow(),DesktopDC);
   }
*/

   long index = sub_swGetBackground(hWnd,0);
   if (index != -1) {
      RECT winrect;
      switch (Msg) {
         case WM_ERASEBKGND:
            
            GetClientRect(hWnd,&winrect);
            
            HBITMAP oldbmp = SelectObject(sw_hDC,sw_BackgroundArea[index].hBmp);

            for (int x=0; x < winrect.right; x+=sw_BackgroundArea[index].width)
               for (int y=0; y < winrect.bottom; y+=sw_BackgroundArea[index].height)
                  BitBlt( (HDC)wParam,
                           x,
                           y,
                           sw_BackgroundArea[index].width,
                           sw_BackgroundArea[index].height,
                           sw_hDC,
                           0,
                           0,
                           SRCCOPY);
            
            SelectObject(sw_hDC,oldbmp);

            return 1;

         default:
           if (sw_BackgroundArea[index].oldCallback)
             return CallWindowProc(sw_BackgroundArea[index].oldCallback,
                                   hWnd,
                                   Msg,
                                   wParam,
                                   lParam);
      }
   }
   return DefWindowProc(hWnd,Msg,wParam,lParam);
}

