/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "SkinWin.h"


PBFUNCTION(long) sub_swEnableMenuItem(HWND hWnd,
                                      unsigned long item,
                                      unsigned long OnOff) {
   if(hWnd) {
      HMENU menu;
      // get system menu
      if(menu = GetSystemMenu(hWnd,0)) {
         long count, ID;
         // get item count
         if(count = GetMenuItemCount(menu)) {
            for(count--; count; count--) {
               // search item in menu
               ID = GetMenuItemID(menu,count);
               // return count, the item position
               if((ID == item) || (ID == item&(~0x8000))) break;
            }
            if(count>=0) {
               // Enable/Disable Menu Item
               MENUITEMINFO mii;
               mii.cbSize     = sizeof(MENUITEMINFO);
               mii.fMask      = MIIM_STATE|MIIM_ID|MIIM_DATA|MIIM_TYPE;
               mii.cch        = 100;
               mii.dwTypeData = malloc(1024);
               if(!mii.dwTypeData) return 0;
               GetMenuItemInfo(menu,count,MF_BYPOSITION,&mii);
               mii.fState     = OnOff ? MF_ENABLED : MF_GRAYED;
               mii.wID        = OnOff ? item       : item&(~0x8000);
               mii.fMask      = MIIM_STATE|MIIM_ID;
               SetMenuItemInfo(menu,count,MF_BYPOSITION,&mii);
               free(mii.dwTypeData);
               return 1;
            }
         }
      }
      
   }
   return 0;
}

