/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "SkinWin.h"


PBFUNCTION(long) sub_swGetBackground(HWND win, long getnew) {

   if (sw_BackgroundArea) {
      // search for existing win
      for (long i=0; i<sw_BackgroundAreaSize; i++) {
         if (sw_BackgroundArea[i].window == win) {
           // free old hBmp if it was created
           // by SetWinBackgroundColor
           if(getnew) {
              if (sw_BackgroundArea[i].hBmp_free)
                DeleteObject(sw_BackgroundArea[i].hBmp);
           }
           // found: return index of win
           return i;
         }
      }
      
      // no new free slot needed
      if (getnew==0) {
         return -1; // failed
      }
   }

   // create new slot
   if (getnew) {
      if (sw_BackgroundArea==0) {
         sw_BackgroundArea = PB_AllocateMemory( sizeof(_sw_Background) );
        
         if (sw_BackgroundArea) {
            sw_BackgroundAreaSize = 1;
            sw_BackgroundArea[0].window      = 0;
            sw_BackgroundArea[0].oldCallback = 0;
            sw_BackgroundArea[0].hBmp_free   = 0;
            sw_BackgroundArea[0].hBmp        = 0;
            return  0; // new slot, index 0
         }
         else {
            return -1; // failed
         }
      }
      else {
         _sw_Background *new_mem = PB_ReAllocateMemory( sw_BackgroundArea, (sizeof(_sw_Background) * (sw_BackgroundAreaSize+1)) );
         if (new_mem) {
            sw_BackgroundArea = new_mem;
            sw_BackgroundArea[sw_BackgroundAreaSize].window      = 0;
            sw_BackgroundArea[sw_BackgroundAreaSize].oldCallback = 0;
            sw_BackgroundArea[sw_BackgroundAreaSize].hBmp_free   = 0;
            sw_BackgroundArea[sw_BackgroundAreaSize].hBmp        = 0;
            sw_BackgroundAreaSize++;
            return sw_BackgroundAreaSize-1; // new slot, last index
         }
      }
   }

   return -1; // failed
}

