/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "SkinWinFast.h"



PBFUNCTION(unsigned long) PB_FreeFastSkin(RGNDATA *region_data) {
   if(region_data) {
      if(sw_FastSkinArea) {
         // search entry
         for(long i=0; i<sw_FastSkinAreaSize; i++) {
            if(sw_FastSkinArea[i].region_data == region_data) {
               // free bitmap
               if (sw_FastSkinArea[i].hBmp)        DeleteObject (sw_FastSkinArea[i].hBmp);
               // free region data
               if (sw_FastSkinArea[i].region_data) PB_FreeMemory(sw_FastSkinArea[i].region_data);
               
               // set both to 0
               sw_FastSkinArea[i].hBmp        = 0;
               sw_FastSkinArea[i].region_data = 0;
               // return success
               return 1;
            }
         }
      }
   }
   return 0;
}

