/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "SkinWinFast.h"



PBFUNCTION(long) PB_SkinWinFast(HWND hWnd, RGNDATA *region_data) {
   if(hWnd && region_data) {
      if(sw_FastSkinArea) {
         // search entry and set skin
         for(long i=0; i<sw_FastSkinAreaSize; i++) {
            if(sw_FastSkinArea[i].region_data == region_data) {
               // make region
               HRGN region = ExtCreateRegion(0,
                                             sw_FastSkinArea[i].region_data_size,
                                             sw_FastSkinArea[i].region_data);
               // set background without updating
               PB_SetWinBackgroundImage2(hWnd,sw_FastSkinArea[i].hBmp,0);
               // set region
               SetWindowRgn(hWnd,region,1);
               // update background
               InvalidateRect(hWnd,0,1);
               UpdateWindow(hWnd);
               // return success
               return 1;
            }
         }
      }
   }
   return 0;
}

