/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include <windows.h>
#include <PBOSL.h>

//#define And &&
//#define Or  ||

typedef struct {
   unsigned long  signature;
   unsigned long  version;
   unsigned long  size_of_header;
   unsigned long  compressed;
   unsigned long  size_of_uncompressed_data;
   unsigned long  size_of_compressed_data;
   unsigned long  size_of_uncompressed_region_data;
   unsigned long  region_offset;
   unsigned long  size_of_uncompressed_bitmap;
   unsigned long  bitmap_offset;
   unsigned long  skin_width;
   unsigned long  skin_height;
} _sw_DKPS;

typedef struct {
   RGNDATA      *region_data;
   unsigned long region_data_size;
   HBITMAP       hBmp;
   unsigned long skin_width;
   unsigned long skin_height;
} _sw_FastSkin;


extern _sw_FastSkin *sw_FastSkinArea;
extern long          sw_FastSkinAreaSize;



// INTERNAL FUNCTIONS
PBFUNCTION(RGNDATA*) PB_CatchFastSkin(_sw_DKPS *skin);
PBFUNCTION(long)     sub_swGetFastSkinArea(void);
PBFUNCTION(long)     PB_GenerateFastSkin2(char *file_skin,char *file_skin_image,char *file_background,unsigned long compress,long x,long y);

// SKINWIN FUNCTIONS
PBFUNCTION(long)     PB_SetWinBackgroundImage2(HWND hWnd, HBITMAP hBmp, long redraw);
PBFUNCTION(HRGN)     PB_SkinWinMakeRegion(HBITMAP hBmp,long x,long y);


// PB MEMORY FUNCTIONS
PBFUNCTION(void*) PB_AllocateMemory(long size);
PBFUNCTION(long)  PB_FreeMemory(void *memory);
PBFUNCTION(void*) PB_ReAllocateMemory(void *memory, long new_size);
PBFUNCTION(void)  PB_CopyMemory(void *source, void *destination, unsigned long size);

// PB PACKER FUNCTIONS
PBFUNCTION(long)  PB_UnpackMemory(void *source, void *destination);
PBFUNCTION(long)  PB_PackMemory (void *source, void *destination, unsigned long size);
PBFUNCTION(long)  PB_PackMemory2(void *source, void *destination, unsigned long size, unsigned long level);
