/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include "SkinWinFast.h"



PBFUNCTION(long) sub_swGetFastSkinArea(void) {
   // create new slot
   if(sw_FastSkinArea==0) {
      sw_FastSkinArea = PB_AllocateMemory( sizeof(_sw_FastSkin) );
        
      if(sw_FastSkinArea) {
         sw_FastSkinAreaSize = 1;
         return  0; // new slot, index 0
      }
      else {
         return -1; // failed
      }
   }
   else {
      // search free slot
      for (long i=0; i<sw_FastSkinAreaSize; i++) {
         if((sw_FastSkinArea[i].region_data == 0) && (sw_FastSkinArea[i].hBmp == 0))
            return i;
      }

      // no free slot found, create new
      _sw_FastSkin *new_mem = PB_ReAllocateMemory( sw_FastSkinArea, (sizeof(_sw_FastSkin) * (sw_FastSkinAreaSize+1)) );
      if(new_mem) {
         sw_FastSkinArea = new_mem;
         sw_FastSkinAreaSize++;
         return sw_FastSkinAreaSize-1; // new slot, last index
      }
   }
   return -1; // failed
}
