/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include <PBOSL.h>
#include <windows.h>



void __stdcall PBOSL_Timer_Callback(unsigned int  TimerHandle,
                                    unsigned int  Msg,
                                    unsigned long TimerNumber,
                                    unsigned long dw1,
                                    unsigned long dw2) {
   // call PB-User's timer procedure, if not 0
   if(PBOSL_Timer_Procedures[TimerNumber])
      PBOSL_Timer_Procedures[TimerNumber]();
}



PBFUNCTION(unsigned long) PB_StartTimer(unsigned long TimerNumber,
                                        unsigned long Delay,
                                        void     (__stdcall* TimerProcedure)(void) ) {
   // max 16 timers, 0 - 15
   if(TimerNumber > 15) return 0;
   
   // if this timer is already used, kill it
   if(PBOSL_Timer_Handles[TimerNumber])
      timeKillEvent(PBOSL_Timer_Handles[TimerNumber]);
   
   // set timer procedure
   PBOSL_Timer_Procedures[TimerNumber] = TimerProcedure;

   // start new timer
   PBOSL_Timer_Handles[TimerNumber] = timeSetEvent(Delay,0,
                                                   PBOSL_Timer_Callback,
                                                   TimerNumber,
                                                   TIME_PERIODIC);
   // return timer handle
   return PBOSL_Timer_Handles[TimerNumber];
}
