/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include <PBOSL.h>
#include <windows.h>
#include <commctrl.h>



PBFUNCTION(unsigned long) PB_AddTBbutton(unsigned long buttonID,
                                         unsigned long image_index,
                                         unsigned char style) {
   if(PBOSL_TBpro_Current.TB) {
      // -2 = no image, needed for AddTBtextButton()
      if(image_index != -2) {
         // check for system icon
         if(image_index & 0x80000000) {
            if(PBOSL_TBpro_Current.ButtonSizeX == 16 || PBOSL_TBpro_Current.ButtonSizeX == 24) {
               image_index &= 0x7FFFFFFF;
               if(image_index > 32) return 0;
               image_index += PBOSL_TBpro_Current.ImageCount;
            }
            else return 0; // not size 16 or 24
         }
         image_index--;
      }

      TBBUTTON btn;
      btn.iBitmap   = image_index;
      btn.idCommand = buttonID;
      btn.fsState   = TBSTATE_ENABLED;
      btn.fsStyle   = style|BTNS_SHOWTEXT|TBSTYLE_AUTOSIZE;
      btn.dwData    = 0;
      btn.iString   = -1;
      
      if(SendMessage(PBOSL_TBpro_Current.TB,TB_ADDBUTTONS,1,(LPARAM)&btn)) {
         if(PBOSL_TBpro_Current.TT) {
            TOOLINFO ti;
            ti.cbSize   = sizeof(TOOLINFO);
            ti.uFlags   = TTF_SUBCLASS;
            ti.hwnd     = PBOSL_TBpro_Current.TB;
            ti.uId      = buttonID;
            ti.lpszText = 0;
            ti.hinst    = 0;
            ti.lParam   = 0;
            
            SendMessage(PBOSL_TBpro_Current.TB,
                        TB_GETITEMRECT,
                        SendMessage(PBOSL_TBpro_Current.TB,
                                    TB_COMMANDTOINDEX,
                                    buttonID,
                                    0),
                        (LPARAM)&ti.rect);
            
            SendMessage(PBOSL_TBpro_Current.TT,TTM_ADDTOOL,0,(LPARAM)&ti);
         }
         

         //
         // set button width manually on Win9x!!!!
         //
         // error description: the button width with style TBSTYLE_AUTOSIZE
         //                    is not always correct on plain Win9x systems
         //                    (plain Win9x = without latest IE updates).
         //                    The style TBSTYLE_AUTOSIZE is needed for
         //                    the toolbar to look nice on all systems,
         //                    so we manually set the button width on Win9x.
         //
         //                    With this workaround, toolbars on Win9x look
         //                    correct, like on Win2000.
         //
         OSVERSIONINFO osvi;
         osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
         GetVersionEx(&osvi);
         // if major OS version < 5 ( before Win2000 )
         if(osvi.dwMajorVersion < 5) {
            // extended width = 0 for text buttons,
            // 7 for other buttons
            short width = (image_index == -2) ? 0 : 7;
            // add 13 pixels for DropDown buttons
            if(style&BTNS_DROPDOWN || style&BTNS_WHOLEDROPDOWN) width += 13;
            // set corrected button width
            PB_SetTBbuttonWidth(buttonID,PBOSL_TBpro_Current.ButtonSizeX+width);
         }

         // return success
         return 1;
      }
   }
   return 0; // error
}
