/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include <PBOSL.h>
#include <windows.h>
#include <commctrl.h>



PBFUNCTION(unsigned long) PB_AddTBsysIcons(void) {
   if(PBOSL_TBpro_Current.TB) {
      if((PBOSL_TBpro_Current.ButtonSizeX == 16) || (PBOSL_TBpro_Current.ButtonSizeX == 24)) {
         // Add system icons
         SendMessage(PBOSL_TBpro_Current.TB,
                     TB_LOADIMAGES,
                     PBOSL_TBpro_Current.ButtonSizeX == 16 ? IDB_STD_SMALL_COLOR  : IDB_STD_LARGE_COLOR,
                     -1);
         SendMessage(PBOSL_TBpro_Current.TB,
                     TB_LOADIMAGES,
                     PBOSL_TBpro_Current.ButtonSizeX == 16 ? IDB_HIST_SMALL_COLOR : IDB_HIST_LARGE_COLOR,
                     -1);
         SendMessage(PBOSL_TBpro_Current.TB,
                     TB_LOADIMAGES,
                     PBOSL_TBpro_Current.ButtonSizeX == 16 ? IDB_VIEW_SMALL_COLOR : IDB_VIEW_LARGE_COLOR,
                     -1);

         // get the 3 image lists
         HIMAGELIST list, list_hot, list_disabled;
         list          = (HIMAGELIST)SendMessage(PBOSL_TBpro_Current.TB,TB_GETIMAGELIST,0,0);
         list_hot      = (HIMAGELIST)SendMessage(PBOSL_TBpro_Current.TB,TB_GETHOTIMAGELIST,0,0);
         list_disabled = (HIMAGELIST)SendMessage(PBOSL_TBpro_Current.TB,TB_GETDISABLEDIMAGELIST,0,0);
         
         // get image count
         unsigned long i, count;
         count = PBOSL_TBpro_Current.ImageCount;
         
         for(i=count; i<count+32; i++) {
            HICON icon;
            if(list_hot)
               if(icon = ImageList_GetIcon(list,i,ILD_TRANSPARENT|ILD_BLEND50)) {
                  ImageList_ReplaceIcon(list_hot,-1,icon);
                  DestroyIcon(icon);
               }
            if(list_disabled)
               if(icon = ImageList_GetIcon(list,i,ILD_TRANSPARENT|ILD_MASK)) {
                  ImageList_ReplaceIcon(list_disabled,-1,icon);
                  DestroyIcon(icon);
               }
         }
         // return success
         return 1;
      }
   }
   return 0; // error
}
