/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include <PBOSL.h>
#include <windows.h>
#include <commctrl.h>



PBFUNCTION(unsigned long) PB_ChangeTBbuttonImage(unsigned long buttonID,
                                                 unsigned long image_index) {
   if(PBOSL_TBpro_Current.TB) {
      // -2 = no image
      if(image_index != -2) {
         // check for system icon
         if(image_index & 0x80000000) {
            if(PBOSL_TBpro_Current.ButtonSizeX == 16 || PBOSL_TBpro_Current.ButtonSizeX == 24) {
               image_index &= 0x7FFFFFFF;
               if(image_index > 32) return 0;
               image_index += PBOSL_TBpro_Current.ImageCount;
            }
            else return 0; // not size 16 or 24
         }
         image_index--;
      }
      
      if(SendMessage(PBOSL_TBpro_Current.TB,
                     TB_CHANGEBITMAP,
                     buttonID,
                     image_index)) {

         // WORKAROUND FOR UPDATING THE BUTTON IMAGE
         // WITHOUT FLICKERING
         // DOESNT WORK WITHOUT THIS
         unsigned long oldstate;
         oldstate = SendMessage(PBOSL_TBpro_Current.TB,TB_GETSTATE,buttonID,0);
         SendMessage(PBOSL_TBpro_Current.TB,TB_SETSTATE,buttonID,oldstate|TBSTATE_WRAP);
         SendMessage(PBOSL_TBpro_Current.TB,TB_SETSTATE,buttonID,oldstate);

         // return success
         return 1;
      }
      
   }
   return 0; // error
}
