/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include <PBOSL.h>
#include <windows.h>
#include <commctrl.h>



PBFUNCTION(HWND) PB_CreateTB2(unsigned long ToolbarNumber,
                              HWND          Window,
                              unsigned long Xsize,
                              unsigned long Ysize,
                              long          flags) {
   HWND TB, TT;
   long i, slot=-1;

   // check window handle
   if(!Window) return 0;

   // check pointer to handles and find new slot
   if(!PBOSL_TBpro_Handles) return 0;

   // find new slow in TB handles
   for(i=0; i<PBOSL_TBpro_Handles_Size; i++) {
      // find free slot
      if(!PBOSL_TBpro_Handles[i].TB) {
         slot = i;
         break;
      }
   }
   // if no free slot, allocate new
   if(slot == -1) {
      PBOSL_Toolbar_Data *mem;
      if(mem = HeapReAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,PBOSL_TBpro_Handles,
                             (PBOSL_TBpro_Handles_Size+1)*sizeof(PBOSL_Toolbar_Data))) {
         PBOSL_TBpro_Handles = mem;
         slot                = PBOSL_TBpro_Handles_Size++;
      }
      else return 0; // cant alocate new slot, error
   }

   // default flags
   if(flags == -1) flags = TBSTYLE_TRANSPARENT | TBSTYLE_FLAT;

   // create toolbar
   if(TB = CreateWindowEx(0,                  // extended styles
                          TOOLBARCLASSNAME,   // class  name
                          0,                  // window name
                          flags|WS_CHILD|TBSTYLE_AUTOSIZE|CCS_NODIVIDER, // 
                          0, 0,               // x, y
                          0, 0,               // width, height
                          Window,             // Parent
                          (HMENU)-10000,      // menu handle or child ID
                          PB_Instance,        // Instance
                          0)) {               // creation data

      // set button struct size
      SendMessage(TB,TB_BUTTONSTRUCTSIZE,sizeof(TBBUTTON),0);
      // set bitmap size
      SendMessage(TB,TB_SETBITMAPSIZE   ,0,(LPARAM)(DWORD)MAKELONG(Xsize,Ysize));
      // set extended styles
      SendMessage(TB,TB_SETEXTENDEDSTYLE,0,TBSTYLE_EX_MIXEDBUTTONS|
                                           TBSTYLE_EX_DRAWDDARROWS|
                                           0x80 // TBSTYLE_EX_DOUBLEBUFFER
                                           //TBSTYLE_EX_HIDECLIPPEDBUTTONS
                                           );


      // create tooltip control
      if(TT = CreateWindowEx(WS_EX_TOPMOST,   // extended styles
                             TOOLTIPS_CLASS,  // class  name
                             0,               // window name
                             WS_POPUP|TTS_ALWAYSTIP|TTS_NOPREFIX,
                             CW_USEDEFAULT,   // x
                             CW_USEDEFAULT,   // y
                             CW_USEDEFAULT,   // width
                             CW_USEDEFAULT,   // height
                             TB,              // Parent
                             (HMENU)0,        // menu handle or child ID
                             PB_Instance,     // Instance
                             0)) {            // creation data
         // set max tooltip width
         SendMessage(PBOSL_TBpro_Current.TT,TTM_SETMAXTIPWIDTH,0,150);
      }

      // set this TB as current
      PBOSL_TBpro_Current.Number      = ToolbarNumber;
      PBOSL_TBpro_Current.TB          = TB;
      PBOSL_TBpro_Current.TT          = TT;
      PBOSL_TBpro_Current.HideFlag    = 0;
      PBOSL_TBpro_Current.ButtonSizeX = Xsize;
      PBOSL_TBpro_Current.ButtonSizeY = Ysize;

      // add to slot
      PBOSL_TBpro_Handles[slot]       = PBOSL_TBpro_Current;

      // show TB
      ShowWindow(TB,SW_SHOWNORMAL);

      // return TB handle      
      return TB;
   }
   return 0;
}
