/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include <PBOSL.h>
#include <windows.h>
#include <commctrl.h>



PBFUNCTION(unsigned long) PB_SetTBbuttonText(unsigned long  buttonID,
                                             char *text) {
   if(PBOSL_TBpro_Current.TB && buttonID) {
      TBBUTTONINFO btn_info;
      unsigned long ok;

      btn_info.cbSize    = sizeof(TBBUTTONINFO);
      btn_info.dwMask    = TBIF_TEXT;
      btn_info.pszText   = text;
      
      // set new text;
      ok = SendMessage(PBOSL_TBpro_Current.TB,
                       TB_SETBUTTONINFO,
                       buttonID,
                       (LPARAM)&btn_info);

      // bug workaround, add an empty string
      // doesnt work without this!
      SendMessage(PBOSL_TBpro_Current.TB,TB_ADDSTRING,0,(LPARAM)"");

      // update TB
      SendMessage(PBOSL_TBpro_Current.TB,TB_AUTOSIZE,0,0);

      // update tooltips
      PB_UpdateTBtooltips();

      return ok;
   }
   return 0;
}
