/*
 *
 *  Copyright (c) 2002-2005 by Danilo Krahn
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include <PBOSL.h>
#include <windows.h>
#include <commctrl.h>



PBFUNCTION(void) PB_UpdateTBtooltips2(unsigned long ToolbarNumber) {
   if(PBOSL_TBpro_Handles) {
      for(long i=0; i<PBOSL_TBpro_Handles_Size; i++) {
         if(PBOSL_TBpro_Handles[i].Number == ToolbarNumber) {
            if(PBOSL_TBpro_Handles[i].TB && PBOSL_TBpro_Handles[i].TT) {
               long count;
               
               if(count = SendMessage(PBOSL_TBpro_Handles[i].TB,
                                      TB_BUTTONCOUNT,0,0)) {
                  TBBUTTON btn;
                  
                  for(count--;count>=0;count--) {
                     SendMessage(PBOSL_TBpro_Handles[i].TB,
                                 TB_GETBUTTON,
                                 count,
                                 (LPARAM)&btn);
                     
                     // Check for 0 (Separator) -> Separators
                     // dont have a Tooltip!
                     if(btn.idCommand) {
                        TOOLINFO ti;
                        ti.cbSize = sizeof(TOOLINFO);
                        ti.uId    = btn.idCommand;
                        ti.hwnd   = PBOSL_TBpro_Handles[i].TB;
                        
                        // get new rect from TB button
                        SendMessage(PBOSL_TBpro_Handles[i].TB,
                                    TB_GETITEMRECT,
                                    SendMessage(PBOSL_TBpro_Handles[i].TB,
                                                TB_COMMANDTOINDEX,
                                                btn.idCommand,
                                                0),
                                    (LPARAM)&ti.rect);

                        // set new rect for tooltip
                        SendMessage(PBOSL_TBpro_Handles[i].TT,
                                    TTM_NEWTOOLRECT,
                                    0,
                                    (LPARAM)&ti);
                     }
                  }
               }
            }
         }
      }
   }
}
