;-----------------------------------------------------------------------------
;      (c) 2006 Sebastian S. aka edel & Thomas Schulz aka ts-soft
;
;     This library is free software; you can redistribute it and/or
;     modify it under the terms of the GNU Lesser General Public
;     License as published by the Free Software Foundation; either
;     version 2.1 of the License, Or (at your option) any later version.
;
;     This library is distributed in the hope that it will be useful,
;     but WITHOUT ANY WARRANTY; without even the implied warranty of
;     MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
;     Lesser General Public License For more details.
;-----------------------------------------------------------------------------

!EXTRN _PB_Object_GetOrAllocateID@8
!EXTRN _PB_Gadget_RegisterGadget@16
!EXTRN _PB_Gadget_RegisterGadget_UNICODE@16
!EXTRN _PB_Gadget_Objects

CompilerIf Defined(PB_GadgetVT, #PB_Structure) = #False
Structure PB_GadgetVT
  GadgetType.l
  SizeOf.l
  GadgetCallback.l
  FreeGadget.l
  GetGadgetState.l
  SetGadgetState.l
  GetGadgetText.l
  SetGadgetText.l
  AddGadgetItem2.l
  AddGadgetItem3.l
  RemoveGadgetItem.l
  ClearGadgetItemList.l
  ResizeGadget.l
  CountGadgetItems.l
  GetGadgetItemState.l
  SetGadgetItemState.l
  GetGadgetItemText.l
  SetGadgetItemText.l
  OpenGadgetList2.l
  GadgetX.l
  GadgetY.l
  GadgetWidth.l
  GadgetHeight.l
  HideGadget.l
  AddGadgetColumn.l
  RemoveGadgetColumn.l
  GetGadgetAttribute.l
  SetGadgetAttribute.l
  GetGadgetItemAttribute2.l
  SetGadgetItemAttribute2.l
  SetGadgetColor.l
  GetGadgetColor.l
  SetGadgetItemColor2.l
  GetGadgetItemColor2.l
  SetGadgetItemData.l
  GetGadgetItemData.l
EndStructure
CompilerEndIf

CompilerIf Defined(PB_Gadget, #PB_Structure) = #False
Structure PB_Gadget
  Gadget.l
  *VT.PB_GadgetVT
  UserData.l
  OldCallback.l
  Daten.l[4]
EndStructure
CompilerEndIf

;GetGadgetParent
;
;                  Rueckgabe : Parent Handle
;
Procedure GetGadgetParent()
  !EXTRN _PB_Object_GetThreadMemory@4
  !EXTRN _PB_Gadget_Globals
  !MOV   Eax,[_PB_Gadget_Globals]
  !push  eax
  !call  _PB_Object_GetThreadMemory@4
  !MOV   Eax,[Eax]
  ProcedureReturn
  CreateGadgetList(0)
EndProcedure

Structure Gadget_Info
  OldCallback.l
  DestroyProc.l
  PBID.l
EndStructure

Procedure RegGadget_Callback(hwnd, msg, wparam, lparam)
  Protected *Gadget_Info.Gadget_Info = GetProp_(hwnd, "GadgetInfo")
  Protected OldProc = *Gadget_Info\OldCallback
  
  If msg = #WM_NCDESTROY
    If *Gadget_Info
      If *Gadget_Info\DestroyProc
        CallFunctionFast(*Gadget_Info\DestroyProc, *Gadget_Info\pbid)
      EndIf
    EndIf
    RemoveProp_(hwnd, "GadgetInfo")
    FreeMemory(*Gadget_Info)
  EndIf
  
  ProcedureReturn CallWindowProc_(OldProc, hwnd, msg, wparam, lparam)
EndProcedure


;RegisterGadget
;                hwnd.l              ; Handle des Controls
;                ID.l                ; PB_ID
;                DestroyProc.l=0     ; Proc zum aufraeumen , kann null sein
;                *vt.PB_GadgetVT = 0 ; Gadget VT , kann null sein
;                unicode             ; 1 = unicode , 0 = ascii
;                Rueckgabe  :  wenn ID = -1 / PB_Any =  PB_ID
;                              sonst Handle des Controls

Global temphwnd.l
Global tempid.l

Procedure RegisterGadget(hwnd.l, ID.l, DestroyProc.l , *vttemp.PB_GadgetVT ,unicode)
  Protected *Gadget_Info.Gadget_Info
  Protected OldCallback.l
  Protected *vt.PB_GadgetVT
  
  If ((hwnd = 0) Or (id < #PB_Any))
    ProcedureReturn 0
  EndIf
  
  *vt = AllocateMemory(SizeOf(PB_GadgetVT))
  If *vttemp <> 0
    CopyMemory(*vttemp,*vt,SizeOf(PB_GadgetVT))
  EndIf
  
  temphwnd = hwnd
  tempid   = Id
  
  !MOV   esi,dword[v_tempid]
  !MOV   edi,[v_temphwnd]
  !PUSH  dword[v_tempid]
  !PUSH  dword [_PB_Gadget_Objects]   
  !CALL  _PB_Object_GetOrAllocateID@8 
  
  !PUSH  dword[p.p_vt]      ; vt 
  !PUSH  edi                ; hwnd 
  !PUSH  eax                ; *gadget
  !PUSH  esi                ; ID
  
  If Not unicode
    !CALL  _PB_Gadget_RegisterGadget@16
  Else
    !CALL  _PB_Gadget_RegisterGadget_UNICODE@16
  EndIf
  
  !mov   [p.v_hwnd],eax
  
  If DestroyProc
    
    *Gadget_Info = AllocateMemory(SizeOf(Gadget_Info))
    
    If id = #PB_Any
      *Gadget_Info\PBID = hwnd
    Else
      *Gadget_Info\PBID = ID
    EndIf   
    
    *Gadget_Info\DestroyProc = DestroyProc
    *Gadget_Info\OldCallback = SetWindowLong_(GadgetID(*Gadget_Info\PBID), #GWL_WNDPROC, @RegGadget_Callback())
    
    SetProp_(GadgetID(*Gadget_Info\PBID), "GadgetInfo", *Gadget_Info)
    
  EndIf
  
  ProcedureReturn hwnd
EndProcedure



; CreateGadget
;   Id.l        ; Gadget, kann auch #PB_Any sein!
;   ClassName.s ; Windows-Klassenname (muss Windows bekannt sein)
;   Text.s      ; ggf. Text/Überschrift
;   Style.l     ; Stil
;   X.l, Y.l    ; linke, obere Ecke des Gadgets auf dem Fenster
;   DX.l, DY.l  ; Größe des Gadgets
;   Optional:
;     ExStyle.l       ; erweiterter Stil
;     DestroyProc.l   ; Procedure-Adresse, einer Procedure zum Aufräumen
;     *vt.PB_GadgetVT ; Pointer zu einer gefüllten Structurevariable mit GadgetFunktionen!
;
; Rückgabe: hWnd oder ID (bei #PB_Any)

ProcedureDLL CreateGadget4(Id.l, ClassName.s, Text.s, Style.l, X.l, Y.l, CX.l, CY.l, ExStyle.l, DestroyProc.l, *vt.PB_GadgetVT)
  Protected hwnd.l
  Protected Parent.l    = GetGadgetParent()
  Protected hInstance.l = GetModuleHandle_(0)
  
  hwnd = CreateWindowEx_(ExStyle, ClassName, Text, Style, X, Y, CX, CY, Parent, 0, hInstance, 0)
  SendMessage_(hWnd, #WM_SETFONT, GetGadgetFont(#PB_Default), 1);
  
  If hwnd = #False : ProcedureReturn #False : EndIf
  
  ProcedureReturn RegisterGadget(hwnd, ID, DestroyProc, *vt,0)
EndProcedure

ProcedureDLL CreateGadget3(Id.l, ClassName.s, Text.s, Style.l, X.l, Y.l, CX.l, CY.l, ExStyle.l, DestroyProc.l)
  ProcedureReturn CreateGadget4(Id, ClassName, Text, Style, X, Y, CX, CY, ExStyle, DestroyProc, 0)
EndProcedure

ProcedureDLL CreateGadget2(Id.l, ClassName.s, Text.s, Style.l, X.l, Y.l, CX.l, CY.l, ExStyle.l)
  ProcedureReturn CreateGadget4(Id, ClassName, Text, Style, X, Y, CX, CY, ExStyle, 0, 0)
EndProcedure

ProcedureDLL CreateGadget(Id.l, ClassName.s, Text.s, Style.l, X.l, Y.l, CX.l, CY.l)
  ProcedureReturn CreateGadget4(Id, ClassName, Text, Style, X, Y, CX, CY, 0, 0, 0)
EndProcedure

ProcedureDLL CreateGadget4_UNICODE(Id.l, ClassName.s, Text.s, Style.l, X.l, Y.l, CX.l, CY.l, ExStyle.l, DestroyProc.l, *vt.PB_GadgetVT)
  Protected hwnd.l
  Protected Parent.l    = GetGadgetParent()
  Protected hInstance.l = GetModuleHandle_(0)
  
  createex_uni = GetProcAddress_(GetModuleHandle_("User32.dll"),"CreateWindowExW")
  
  hwnd = CallFunctionFast(createex_uni,ExStyle, ClassName, Text, Style, X, Y, CX, CY, Parent, id, hInstance, 0)
  
  SendMessage_(hWnd, #WM_SETFONT, GetGadgetFont(#PB_Default), 1);
  
  If hwnd = #False : ProcedureReturn #False : EndIf
  
  ProcedureReturn RegisterGadget(hwnd, ID, DestroyProc, *vt,1)
EndProcedure

ProcedureDLL CreateGadget3_UNICODE(Id.l, ClassName.s, Text.s, Style.l, X.l, Y.l, CX.l, CY.l, ExStyle.l, DestroyProc.l)
  ProcedureReturn CreateGadget4_UNICODE(Id, ClassName, Text, Style, X, Y, CX, CY, ExStyle, DestroyProc, 0)
EndProcedure

ProcedureDLL CreateGadget2_UNICODE(Id.l, ClassName.s, Text.s, Style.l, X.l, Y.l, CX.l, CY.l, ExStyle.l)
  ProcedureReturn CreateGadget4_UNICODE(Id, ClassName, Text, Style, X, Y, CX, CY, ExStyle, 0, 0)
EndProcedure

ProcedureDLL CreateGadget_UNICODE(Id.l, ClassName.s, Text.s, Style.l, X.l, Y.l, CX.l, CY.l)
  ProcedureReturn CreateGadget4_UNICODE(Id, ClassName, Text, Style, X, Y, CX, CY, 0, 0, 0)
EndProcedure
