;
; NT Service Lib for Purebasic
;
;-----------------------------------------------------------------------------
;     (c) 2004-2005 Siegfried Rings
;
;     This library is free software; you can redistribute it and/or
;     modify it under the terms of the GNU Lesser General Public
;     License as published by the Free Software Foundation; either
;     version 2.1 of the License, Or (at your option) any later version.
; 
;     This library is distributed in the hope that it will be useful,
;     but WITHOUT ANY WARRANTY; without even the implied warranty of
;     MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
;     Lesser General Public License For more details. 
;----------------------------------------------------------------------------- 

#SERVICE_WIN32_OWN_PROCESS    = $00000010
#SERVICE_WIN32_SHARE_PROCESS  = $00000020
;Thread Running/Pause ?
Global fPaused.l
Global fRunning.l
; Thread for the actual work
Global hThread.l
Global sStatus.SERVICE_STATUS 
;Event used to hold ServiceMain from completing
Global evTerminate.l

Global schSCManager.l
Global schService.l
Global ssStatus.SERVICE_STATUS
; 
Global sStatus.SERVICE_STATUS
Global SERVICE_NAME.s 

Global Logname.s

Global glbFunction;Userfunction
Global glbNFunction; Notify Funtion
Global hThread1.l

; 'Handle used to communicate status info with
; 'the SCM. Created by RegisterServiceCtrlHandler
Global hStatus.l


#SRSC_MANAGER_ALL_ACCESS=$F003F
;%SC_MANAGER_ALL_ACCESS         = %STANDARD_RIGHTS_REQUIRED Or %SC_MANAGER_CONNECT Or %SC_MANAGER_CREATE_SERVICE Or %SC_MANAGER_ENUMERATE_SERVICE Or %SC_MANAGER_LOCK _
;                                 Or %SC_MANAGER_QUERY_LOCK_STATUS Or %SC_MANAGER_MODIFY_BOOT_CONFIG
; ' Service Types (Bit Mask)
; #SERVICE_KERNEL_DRIVER        = &H00000001
; #SERVICE_FILE_SYSTEM_DRIVER   = &H00000002
; #SERVICE_ADAPTER              = &H00000004
; #SERVICE_RECOGNIZER_DRIVER    = &H00000008
; #SERVICE_DRIVER = %SERVICE_KERNEL_DRIVER Or %SERVICE_FILE_SYSTEM_DRIVER _
;                Or %SERVICE_RECOGNIZER_DRIVER
#SERVICE_WIN32_OWN_PROCESS    = $00000010
#SERVICE_WIN32_SHARE_PROCESS  = $00000020
#SERVICE_WIN32 = #SERVICE_WIN32_OWN_PROCESS | #SERVICE_WIN32_SHARE_PROCESS
#SERVICE_INTERACTIVE_PROCESS  = $00000100
; #SERVICE_TYPE_ALL = %SERVICE_WIN32 Or %SERVICE_ADAPTER Or %SERVICE_DRIVER _
;                  Or %SERVICE_INTERACTIVE_PROCESS
; 
; start types
#SERVICE_BOOT_START     = $00000000
#SERVICE_SYSTEM_START   = $00000001
#SERVICE_AUTO_START     = $00000002
#SERVICE_DEMAND_START   = $00000003
#SERVICE_DISABLED       = $00000004

; 
; ' Error control type
; 
; #SERVICE_ERROR_IGNORE   = &H00000000
#SERVICE_ERROR_NORMAL   = $00000001
; #SERVICE_ERROR_SEVERE   = &H00000002
; #SERVICE_ERROR_CRITICAL = &H00000003

#SRSERVICE_ALL_ACCESS=$F01FF

Global mem1
Global ActServices.l
Global MaxServices.l

ProcedureDLL ExamimeServices(); start examine all services

schSCManager = OpenSCManager_(0, 0, #SRSC_MANAGER_ALL_ACCESS)
If schSCManager <> 0
 Result=EnumServicesStatus_(schSCManager ,#SERVICE_WIN32,#SERVICE_ACTIVE |#SERVICE_INACTIVE,lpServices,cbBufSize,@pcbBytesNeeded,@lpServicesReturned,@lpResumeHandle)   
 If pcbBytesNeeded
  If Mem1
   GlobalFree_(Mem1)
  EndIf
  Mem1= GlobalAlloc_(#GMEM_FIXED,pcbBytesNeeded)
  Result=EnumServicesStatus_(schSCManager ,#SERVICE_WIN32,#SERVICE_ACTIVE|#SERVICE_INACTIVE,Mem1,pcbBytesNeeded,@pcbBytesNeeded,@lpServicesReturned,@lpResumeHandle)   
  ActServices.l=0
  Debug Result
  Debug lpServicesReturned
 EndIf 
 CloseHandle_(schSCManager )
EndIf
MaxServices=lpServicesReturned
ProcedureReturn lpServicesReturned
EndProcedure

ProcedureDLL NextServices(); get Next service (NULL if nothing)
If Actservices<Maxservices
 Actservices+1
 ProcedureReturn Actservices
Else
 ProcedureReturn 0
EndIf 
EndProcedure

ProcedureDLL.s GetServiceName(); Get the Servicename
 If mem1<>0
  ProcedureReturn PeekS(PeekL(Mem1+((Actservices - 1) * 36)))
 EndIf
EndProcedure

ProcedureDLL.s GetServiceDescription();Get a description of the service
 If mem1<>0
  ProcedureReturn PeekS( PeekL ( Mem1 + 4 + ((Actservices-1)*36)))
 EndIf
EndProcedure
ProcedureDLL.l GetServiceStatus();Get the Status of the Service (Started,Paused etc.)
 If mem1<>0
  ProcedureReturn PeekL(Mem1+12+((Actservices-1)*36))
 EndIf
EndProcedure

ProcedureDLL.s GetServiceDescriptionEx(Servicename.s)
 sTopKey.l = #HKEY_LOCAL_MACHINE 
 sKeyName.s = "SYSTEM\CurrentControlSet\Services\" + Servicename.s 
 GetHandle = RegOpenKeyEx_(stopKey, sKeyName, 0, #KEY_ALL_ACCESS, @hKey) 
 lpData.s=Space(1024)
 lpcbData=1024
 If GetHandle = #ERROR_SUCCESS 
  lType=#REG_SZ
 ; GetHandle = RegSetValueEx_(hkey, "Description", 0, #REG_SZ, @Description.s, Len(Description.s) + 1) 
; GetHandle = RegQueryValueEx_(hKey, sValueName  , 0, @lType, @lpData, @lpcbData) 
  GetHandle = RegQueryValueEx_(hKey,"Description", 0, @lType, @lpData, @lpcbData) 
  If Gethandle=0 And lpcbData>2
  RegCloseKey_(hkey) 
  ;MessageRequester("Info",lpdata.s,0)
  ProcedureReturn Left(lpdata,lpcbData-1)
   
  EndIf
 EndIf
EndProcedure

Procedure Service_Init()
 If Mem1
  GlobalFree_(Mem1)
 EndIf
EndProcedure
ProcedureDLL StartService(ServiceName.s) ;Start the service with the Name
     Returnwert=0
     schSCManager = OpenSCManager_(0, 0, #SRSC_MANAGER_ALL_ACCESS)
     If schSCManager <> 0
      schService = OpenService_(schSCManager, @ServiceName.s, #SRSERVICE_ALL_ACCESS)
      If schService <>0
       Returnwert=StartService_(schService, 0, 0) 
       CloseServiceHandle_(schService)
      EndIf
      CloseServiceHandle_(schSCManager)
     EndIf
     ProcedureReturn ReturnWert
EndProcedure

ProcedureDLL StopService(ServiceName.s);Stop the Service with the Name
 sStatus.SERVICE_STATUS
     Returnwert=0
     schSCManager = OpenSCManager_(0, 0, #SRSC_MANAGER_ALL_ACCESS)
     If schSCManager <> 0
      schService = OpenService_(schSCManager, @ServiceName.s, #SRSERVICE_ALL_ACCESS)
      If schService <>0
       Returnwert=ControlService_(schService, #SERVICE_CONTROL_STOP, sStatus) 
       CloseServiceHandle_(schService)
      EndIf
      CloseServiceHandle_(schSCManager)
     EndIf
     ProcedureReturn ReturnWert
EndProcedure

ProcedureDLL PauseService(ServiceName.s);Pause the Service with the name
 sStatus.SERVICE_STATUS
     Returnwert=0
     schSCManager = OpenSCManager_(0, 0, #SRSC_MANAGER_ALL_ACCESS)
     If schSCManager <> 0
      schService = OpenService_(schSCManager, @ServiceName.s, #SRSERVICE_ALL_ACCESS)
      If schService <>0
       Returnwert=ControlService_(schService, #SERVICE_CONTROL_PAUSE, sStatus) 
       CloseServiceHandle_(schService)
      EndIf
      CloseServiceHandle_(schSCManager)
     EndIf
     ProcedureReturn ReturnWert
EndProcedure
ProcedureDLL ResumeService(ServiceName.s);resume the Service with the name
 sStatus.SERVICE_STATUS
     Returnwert=0
     schSCManager = OpenSCManager_(0, 0, #SRSC_MANAGER_ALL_ACCESS)
     If schSCManager <> 0
      schService = OpenService_(schSCManager, @ServiceName.s, #SRSERVICE_ALL_ACCESS)
      If schService <>0
       Returnwert=ControlService_(schService, #SERVICE_CONTROL_CONTINUE, sStatus) 
       CloseServiceHandle_(schService)
      EndIf
      CloseServiceHandle_(schSCManager)
     EndIf
     ProcedureReturn ReturnWert
EndProcedure

ProcedureDLL Installservice(ServiceName.s,DisplayName.s,PathToServiceEXE.s,Description.s,StartParameter);Installs a service and start it
;ProcedureDLL Installservice(ServiceName.s,DisplayName.s,PathToServiceEXE.s); Installs a Service And starts it
 sStatus.SERVICE_STATUS
 dwDesiredAccess.l=#SRSERVICE_ALL_ACCESS
 dwServiceType.l=#SERVICE_WIN32_OWN_PROCESS | #SERVICE_INTERACTIVE_PROCESS
 dwStartType=StartParameter
 dwErrorControl.l=#SERVICE_ERROR_NORMAL
    schSCManager = OpenSCManager_(0, 0, #SRSC_MANAGER_ALL_ACCESS)
    If schSCManager = 0
       MessageRequester("Info","Cannot open SCManager ADMIN ?", 0)
       ProcedureReturn
    EndIf
    schService = CreateService_(schSCManager, @ServiceName.s,@DisplayName.s, dwDesiredAccess,dwServiceType,dwStartType,dwErrorControl,@PathToServiceEXE.s,0,0,0,0,0)
    If schService = 0
       MessageRequester("Info","CreateService Failed", 0)
       Goto Finish
    EndIf
    If QueryServiceStatus_(schService, @sStatus )  = 0
        MessageRequester("Info","QueryServiceStatus Failed" ,0)
        Goto Finish
    EndIf
    If sStatus\dwCurrentState = #SERVICE_STOPPED 
     If dwStartType= #SERVICE_AUTO_START Or dwStartType= #SERVICE_DEMAND_START   
      Result=StartService_(schService, 0, 0) 
      If Result= 0
       ;MessageRequester("Info","StartService Failed "+StrU(GetLastError_(),2), 0)
       Goto Finish
      EndIf
     EndIf
    EndIf
 ;MessageRequester("Info","Service Installed!", 0)
Finish:
    CloseServiceHandle_(schService)
    CloseServiceHandle_(schSCManager)
If Description.s<>"" 
 sTopKey.l = #HKEY_LOCAL_MACHINE 
 sKeyName.s = "SYSTEM\CurrentControlSet\Services\" + Servicename.s 
 GetHandle = RegOpenKeyEx_(stopKey, sKeyName, 0, #KEY_ALL_ACCESS, @hKey) 
 If GetHandle = #ERROR_SUCCESS 
  GetHandle = RegSetValueEx_(hkey, "Description", 0, #REG_SZ, @Description.s, Len(Description.s) + 1) 
 EndIf
 RegCloseKey_(hkey) 
EndIf
EndProcedure

; ' Removes a Service ,Stops it , then Deletes the SCManager Entry not the exe
ProcedureDLL RemoveService(ServiceName.s);Removes a service
 sStatus.SERVICE_STATUS
     schSCManager = OpenSCManager_(0,0, #SRSC_MANAGER_ALL_ACCESS)
     If schSCManager = 0
      ;MessageRequester("Info","CreateService Failed", 0)
      ProcedureReturn
     EndIf
     schService = OpenService_(schSCManager, @ServiceName.s, #SRSERVICE_ALL_ACCESS)
     If schService = 0
       ;MessageRequester("Info","OpenService Failed", 0)
       Goto RemoveFinish
     EndIf
     If ControlService_(schService, #SERVICE_CONTROL_STOP, sStatus) = 0 
       ;MessageRequester("Info","Unable to Stop Service", 0)
     EndIf
 
;Loop until its stopped, then delete it it only deletes the SCM entry, not the Executable.
 Repeat
   If QueryServiceStatus_(schService, sStatus ) = 0
      ;MessageRequester("Info","QueryServiceStatus Failed", 0)
    Goto RemoveFinish
   EndIf
; 
   If sStatus\dwCurrentState = #SERVICE_STOPPED 
    If DeleteService_(schService) = 0
     ;MessageRequester("Info","Unable To Remove Service", 0)
     Goto RemoveFinish
    EndIf
    ;MessageRequester("Info","Service Removed!", 0)
    Goto RemoveFinish
   EndIf
 ForEver
; 
 RemoveFinish:
   CloseServiceHandle_(schService)
   CloseServiceHandle_(schSCManager)
EndProcedure


 
Procedure Info(Instring.s)
 OutputDebugString_(Instring.s)
EndProcedure
 
;This is the main working thread for our service
Procedure.l MainThread(var.l) 
;     ' START HERE!
If glbFunction<>0
 id2.l 
 hThread1 = CreateThread_(0, 0, glbFunction, 0, 0, @id2 )
 If hThread1 <> 0
  ;fRunning  = 1
  ;ProcedureReturn 1
 Else
  
 EndIf
EndIf

;     ' All this does is beep every 5 seconds
;     ' Remove this annoying :) example and add your code here
     Repeat
         ;Sleep_(60000*5)
         ;Beep_(100,100)
         Sleep_(100)
         ;Beep_(100,100)
    ForEver
EndProcedure


;Initializes the service by starting its thread
Procedure.l ServiceInit()
id.l
 Info("service init")
hThread = CreateThread_(0, 0, @MainThread(), 0, 0, @id )
If hThread <> 0
  fRunning  = 1
  ProcedureReturn 1
EndIf
EndProcedure
 

;Resumes a paused primary thread
Procedure.l MyResumeService()
Info("resume service")
fPaused = #False
If ResumeThread_(hThread) = -1 
 ; It failed to resume, handle it if you want.
EndIf
EndProcedure

;Pauses the primary thread
Procedure.l MyPauseService()
 Info("pause service")
 fPaused = #True
 If SuspendThread_(hThread) = -1 
  ;It failed To pause, handle it If you want.
 EndIf
EndProcedure

;Stops the service by allowing ServiceMain to complete
Procedure.l MyStopService()
 Info("stop service")
 fRunning  = #False
 ;This will release ServiceMain
 SetEvent_(evTerminate)
EndProcedure
 
; ' Error Handler - Does nothing but bails.
Procedure.l  NTErrorHandler(srverr.l)
; A more robust error handler could (And should) be made.
Info("NTErrorHandler")
 ;End(srverr)
 End
EndProcedure

;This function consolidates the activities of
;updating the service status with SetsStatus.
Procedure.l SendStatus(dwCurrentState.l, dwWin32ExitCode.l,dwServiceSpecificExitCode.l, dwCheckPoint.l, dwWaitHint.l ) 
; 
Info("sendstatus "+Str(dwCheckPoint.l)+":"+Str(dwWaitHint) ) 
success.w
sStatus\dwServiceType = #SERVICE_WIN32_OWN_PROCESS
sStatus\dwCurrentState = dwCurrentState
If dwCurrentState = #SERVICE_START_PENDING 
  sStatus\dwControlsAccepted  = 0
Else
 sStatus\dwControlsAccepted = #SERVICE_ACCEPT_STOP |#SERVICE_ACCEPT_PAUSE_CONTINUE |#SERVICE_ACCEPT_SHUTDOWN
EndIf
; 
If dwServiceSpecificExitCode = 0 
 sStatus\dwWin32ExitCode = dwWin32ExitCode
Else
 sStatus\dwWin32ExitCode = #ERROR_SERVICE_SPECIFIC_ERROR
EndIf
 
sStatus\dwServiceSpecificExitCode  = dwServiceSpecificExitCode
sStatus\dwCheckPoint = dwCheckPoint
sStatus\dwWaitHint = dwWaitHint
 
;Pass the status record to the SCM
SetServiceStatus_(hStatus,sStatus)
ProcedureReturn #True;Return True
EndProcedure


;Dispatches events received from the service control manager
Procedure CtrlHandler(controlCode.l)
Info("CtrlHandler")
currentState.l
success.l

currentState = 0
If controlCode = #SERVICE_CONTROL_STOP
  currentState  = #SERVICE_STOP_PENDING
  ;Tell the SCM what's happening
  SendStatus(#SERVICE_STOP_PENDING, #NO_ERROR, 0, 1, 5000)
  ;Not much to do if not successful

  ; ####################
 
  ; Changed on 27.09.2005 by Peter Tbben (aka Kiffi)
  ; Stopping the service will be notified to the notify-function (if mentioned)
 
  SendStatus(currentState, #NO_ERROR, 0, 0, 0)

  ; First notify ...
  If glbNFunction<>0
    nopThread = CreateThread_(0, 0, glbNFunction, controlCode, 0, @id )
    WaitThread(nopThread)
  EndIf
 
  ; ... then stop the service
  MyStopService()
 
  ProcedureReturn
 
  ; ####################
 
EndIf 
; If controlCode = #SERVICE_CONTROL_STOP
;  currentState  = #SERVICE_STOP_PENDING
;  ;Tell the SCM what's happening
;  SendStatus(#SERVICE_STOP_PENDING, #NO_ERROR, 0, 1, 5000)
;  ;Not much to do if not successful
;  ;Stop the service
;  MyStopService()
;  ;ProcedureReturn
;  Goto SCHandler
; EndIf 

;Pause the service
If controlCode = #SERVICE_CONTROL_PAUSE 
 If fRunning <> 0 Or fPaused = 0 
  ;Tell the SCM what's happening
  SendStatus(#SERVICE_PAUSE_PENDING, #NO_ERROR, 0, 1, 1000)
  MyPauseService()
  currentState  = #SERVICE_PAUSED
  Goto SCHandler
 EndIf
EndIf

;Resume from a pause
If controlCode = #SERVICE_CONTROL_CONTINUE 
 If fRunning <> 0 Or  fPaused = 1 
  ;Tell the SCM what's happening
  SendStatus(#SERVICE_CONTINUE_PENDING, #NO_ERROR, 0, 1, 1000)
  MyResumeService()
  currentState  = #SERVICE_RUNNING
  Goto SCHandler
 EndIf
EndIf
;Update current status
If controlCode = #SERVICE_CONTROL_INTERROGATE 
 ; it will fall to bottom and send status
 ;Could do cleanup here but it must be very quick.
EndIf
If controlCode = #SERVICE_CONTROL_SHUTDOWN 
 ;The service is notified when system
 ;shutdown occurs.
 ;Do nothing on shutdown, in this example.
EndIf
; 
SCHandler:
 SendStatus(currentState, #NO_ERROR, 0, 0, 0)
If glbNFunction<>0 
  ;CallFunctionFast(glbNFunction,controlCode)
  nopThread = CreateThread_(0, 0, glbNFunction, controlcode, 0, @id )
EndIf

EndProcedure

;Handle an error from ServiceMain by cleaning up
;and telling SCM that the service didn't start.
Procedure Terminate(eror.l)
Info("Terminate")
;     Dim result AS DWORD
;if evTerminate has been created, close it.
If evTerminate <> 0 
 CloseHandle_(evTerminate)
EndIf
;Send a message to the scm to tell about stopage
If hStatus <> 0 
 SendStatus(#SERVICE_STOPPED,eror, 0, 0, 0)
EndIf
;Ifthe thread has started kill it off
If hThread <> 0 
 CloseHandle_(hThread)
EndIf
;Do not need to close hStatus
EndProcedure

;ServiceMain is called when the SCM wants to
;start the service. When it returns, the service
;has stopped. It therefore waits on an event
;just before the end of the function, and
;that event gets set when it is time to stop.
;It also returns on any error because the
;service cannot start if there is an error.
Procedure ServiceMain(argc.l,*argv) 
;Argv iss ein stringpointer 
;    LOCAL success AS DWORD
;    LOCAL temp AS DWORD
;    LOCAL errnum AS DWORD
Info("ServiceMain "+ SERVICE_NAME.s)
 
;immediately call Registration function
hStatus = RegisterServiceCtrlHandler_(@SERVICE_NAME.s,@CtrlHandler())
If hStatus = 0  
 errnum = GetLastError_()
 Terminate(errnum)
 ProcedureReturn
EndIf
Info("ServiceMain 2")
;Notify SCM of progress
 SendStatus(#SERVICE_START_PENDING, #NO_ERROR, 0, 1, 5000)
;create the termination event

evTerminate = CreateEvent_(dwNUll, #True, #False,0)
If evTerminate = 0 
 errnum = GetLastError_()
 Terminate(errnum)
 ProcedureReturn
EndIf
Info("ServiceMain 3")

;Notify SCM of progress
SendStatus(#SERVICE_START_PENDING, #NO_ERROR, 0, 2, 1000 )
;Notify SCM of progress
SendStatus(#SERVICE_START_PENDING ,#NO_ERROR, 0, 3, 5000)
;Start the service itself
success = ServiceInit()
Info("ServiceMain 3 "+Str(success))

If success = 0 
 errnum = GetLastError_()
 Terminate(errnum)
 ProcedureReturn
EndIf
;Notify SCM of progress
SendStatus(#SERVICE_RUNNING, #NO_ERROR, 0, 0, 0)
;Wait for stop signal, and then terminate
 WaitForSingleObject_(evTerminate, #INFINITE)
 Terminate(0)
EndProcedure

ProcedureDLL Service(ServiceName.s,AdressofUserFunction) ;The Main ServiceFunction
glbFunction=AdressofUserFunction
 Info("Start service")
;Program Entry Point
SERVICE_NAME.s = ServiceName.s;
;Register with the SCM
sTable.SERVICE_TABLE_ENTRY
sTable\lpServiceProc = @ServiceMain()
sTable\lpServiceName = @SERVICE_NAME
rtrval = StartServiceCtrlDispatcher_(sTable)
If rtrval = 0 
 NTErrorHandler(0)
EndIf
 Info("End starting"+Str(rtval))
End
EndProcedure

ProcedureDLL Service2(ServiceName.s,AdressofUserFunction,AdressofNotifyFunction);The Main ServiceFunction with Notify
glbFunction=AdressofUserFunction
glbNFunction=AdressofNotifyFunction
 Info("Start service")
;Program Entry Point
SERVICE_NAME.s = ServiceName.s;
;Register with the SCM
sTable.SERVICE_TABLE_ENTRY
sTable\lpServiceProc = @ServiceMain()
sTable\lpServiceName = @SERVICE_NAME
rtrval = StartServiceCtrlDispatcher_(sTable)
If rtrval = 0 
 NTErrorHandler(0)
EndIf
 Info("End starting"+Str(rtval))
End
EndProcedure
