/*
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, Or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License For more details. 
 *
 */
#include <windows.h>
#include <commctrl.h>

/*
 *
 * PBOSL declarations
 *
 */
#define PBFUNCTION(a) extern a __stdcall



/* 
 *
 * PBOSL_AnimSprite
 *
 */
typedef struct {
   long SpriteNumber;
   unsigned long Transparent;
   unsigned long Xsize;
   unsigned long Ysize;
   unsigned long AnimCount;
   unsigned long DirectionCount;
   unsigned long currentAnim;
   unsigned long currentDirection;
   unsigned long XclipStart;
   unsigned long YclipStart;
   unsigned long AutoFrameTime;
   unsigned long AutoFrameDirection;
   unsigned long AutoFrameLastTime;
} AnimSprite;


PBFUNCTION(unsigned long) PB_NextAnimFrame(AnimSprite *anim);
PBFUNCTION(unsigned long) PB_PrevAnimFrame(AnimSprite *anim);

PBFUNCTION(AnimSprite*)   PB_CreateAnimSprite(AnimSprite *anim,
                                              long sprite,
                                              unsigned long xsize,
                                              unsigned long ysize);

PBFUNCTION(unsigned long) PB_CollisionAnimSprite2(AnimSprite *anim,
                                                  long x1,
                                                  long y1,
                                                  long sprite,
                                                  long x2,
                                                  long y2,
                                                  unsigned long collisionmode );

PBFUNCTION(unsigned long) PB_CollisionSpriteAnim2(long sprite,
                                                  long x1,
                                                  long y1,
                                                  AnimSprite *anim,
                                                  long x2,
                                                  long y2,
                                                  unsigned long collisionmode );

PBFUNCTION(unsigned long) PB_CollisionAnimAnim2(AnimSprite *anim1,
                                                long x1,
                                                long y1,
                                                AnimSprite *anim2,
                                                long x2,
                                                long y2,
                                                unsigned long collisionmode );

PBFUNCTION(void)          AnimSprite_CalcClipStart(AnimSprite *anim);
PBFUNCTION(void)          AnimSprite_CalcAnimSpriteDisplay(AnimSprite *anim);


/*
 *
 * PBOSL_Timer
 *
 */
extern unsigned long            PBOSL_Timer_Handles[16];
extern void (__stdcall*         PBOSL_Timer_Procedures[16])(void);



/*
 *
 * PBOSL_ToolbarPro
 *
 */
typedef struct {
  unsigned long Number;
  HWND TB;
  HWND TT;
  unsigned long HideFlag;
  unsigned long ButtonSizeX;
  unsigned long ButtonSizeY;
  unsigned long ImageCount;
  HIMAGELIST    hList;
  HIMAGELIST    hList_hot;
  HIMAGELIST    hList_disabled;
} PBOSL_Toolbar_Data;

extern long                PBOSL_TBpro_Handles_Size;
extern PBOSL_Toolbar_Data *PBOSL_TBpro_Handles;
extern PBOSL_Toolbar_Data  PBOSL_TBpro_Current;

PBFUNCTION(void) PB_UpdateTBtooltips (void);
PBFUNCTION(void) PB_UpdateTBtooltips2(unsigned long ToolbarNumber);
PBFUNCTION(long) PB_TBwidth2         (unsigned long ToolbarNumber);
PBFUNCTION(void) PB_FreeTB2          (unsigned long ToolbarNumber);

PBFUNCTION(unsigned long) PB_AddTBbutton(unsigned long buttonID,
                                         unsigned long image_index,
                                         unsigned char style);

PBFUNCTION(unsigned long) PB_SetTBbuttonText(unsigned long  buttonID,
                                             char *text);

PBFUNCTION(unsigned long) PB_SetTBbuttonWidth(unsigned long  buttonID,
                                              unsigned short width);

PBFUNCTION(unsigned long) PB_ChangeTBbuttonImage(unsigned long buttonID,
                                                 unsigned long image_index);

PBFUNCTION(HWND) PB_CreateTB2(unsigned long ToolbarNumber,
                              HWND          Window,
                              unsigned long Xsize,
                              unsigned long Ysize,
                              long flags);



/*
 *
 * extern PureBasic variables
 *
 */
extern char        *PB_StringBase;
extern HINSTANCE    PB_Instance;



/* 
 *
 * imported PureBasic functions
 *
 */

PBFUNCTION(unsigned long) PB_SpriteWidth(long sprite);
PBFUNCTION(unsigned long) PB_SpriteHeight(long sprite);

PBFUNCTION(long) PB_ClipSprite(long sprite,
                               unsigned long xstart,
                               unsigned long ystart,
                               unsigned long width,
                               unsigned long height);

PBFUNCTION(long) PB_DisplayTransparentSprite(long sprite,
                                             long x,
                                             long y);

PBFUNCTION(long) PB_SpritePixelCollision(long sprite1,
                                         long x1,
                                         long y1,
                                         long sprite2,
                                         long x2,
                                         long y2);

PBFUNCTION(long) PB_SpriteCollision(long sprite1,
                                    long x1,
                                    long y1,
                                    long sprite2,
                                    long x2,
                                    long y2);

PBFUNCTION(unsigned long) PB_ElapsedMilliseconds();
