; This is the source for the Screengadgets - Lib
; Coded 2005-2006 by Dostej (Stefan Mahr) released under the LGPL
; version 1.2 for PB 4.0

;/ Preparation
Declare SG_FreeAllGadgets()
Declare SG_ClearGadgetItemList(SG_GadgetID_L.l)
Declare SG_AddGadgetItem(SG_GadgetID_L.l, Position_L.l, Text_S.s)
Declare SG_FillExplorerGadget(SG_GadgetID_L.l, Directory_S.s)
Declare SG_AddGadgetColumn(SG_GadgetID_L.l, Column_L.l, ColumnName_S.s, ColumnWidth_L.l)
Declare SG_Sort_ListIconGadget2(SG_GadgetID_L.l, Column_L.l, Typ_L.l, Options_L.l, Start_L.l, Stop_L.l)


;{ Constants for ScreenGadgets
#SG_FontStandard = 2
#SG_FontSymbol = 1

#Col_Disabled = $808080
#Col_GadgetHeader = $C0C0C0
#Col_StateMark = $0000FF
#Col_Cursor = $808080

Enumeration 1
  #SG_Explorer_Name       ; displays the name of the file/directory
  #SG_Explorer_Size       ; displays the filesize in Kb
  #SG_Explorer_Type       ; displays a string describing the filetype
  #SG_Explorer_Attributes ; displays the Attributes of the file/directory
  #SG_Explorer_Created    ; displays the time the file/directory was created
  #SG_Explorer_Modified   ; displays the time the file/directory was last modified
  #SG_Explorer_Accessed
  
EndEnumeration
;}

; Data for the ScreenGadgets
ProcedureDLL PBOSL_Screengadgets_Init()
  Global SG_MouseX_GL.l ; contains the mouse coord.
  Global SG_MouseY_GL.l
  Global SG_MouseButton_GL.l ; contains the mousebutton state
  Global SG_MouseWheel_GL.l ; contains the mousewheel value
  
  Global SG_StandardColor_GL.l ; the text color of the gadgets
  Global SG_StandardBackground_GL.l ; contains the standard background
  Global SG_StandardBackgroundData_GL.l ; contains the standard background data (color or imagenr)
  Global SG_FontStandard_GL.l ; contais the standard font nummer
  Global SG_StandardHeaderTextColor_GL.l ; the Color values for the header and the Gridlines
  Global SG_StandardHeaderBackColor_GL.l
  Global SG_StandardLineColor_GL.l
  Global SG_StandardDisabled_GL.l
  
  Global SG_EventType_L.l ; type of the event happened
  Global SG_CurrentGadget_GL.l ; the ID of the gadget where the actual event is happened
  Global SG_FocusGadget_GL.l ; The number of the gadget with the Focus or -1 for non
  
  Global SG_Group_GL.l ; actual groupnumber for Optiongadgets or -1, if no actual group exist
  
  Global MoveLIcon_Header_GL.l ; is set to the left header, if between two Header-seqments  << 16 | (Mousebutton)
  
  Structure GadgetBase
    SG_GadgetID_L.l ; The number of the Gadget (given by the user)
    GadgetID_P.l ; the ID of the Gadget = pointer of the element of the correponding list
    GadgetType_L.l ; the typ of the gadget  -> see constants for reference
    AddList_P.l; contains a pointer to the linked element of the typ of the gadget
    X_Pos_L.l ; the xpos of the Gadget
    Y_Pos_L.l ; the ypos of the Gadget
    Width_L.l ; the widht of the Gadget
    Height_L.l ; the height of the Gadget
    Hidden_L.l ; 0 = visible
    Disabled_L.l; 0 = anabled
    TextColor_L.l ; the text color of the Gadget
    DisabledColor_L.l ; text colot for disabled-mode
    BackGround_L.l ; how to handle the background 0 = no Background   1= Color  2 = image
    BackGroundDetail_L.l ; contains the color / imagenumber for the background
  EndStructure
  
  Structure TextGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    Text_S.s ; the text of the Textgadget
    TextFont_L.l
    Flags_L.l ; contains the Display-Flags
    CursorPos_L.l ; at what position ist the cursor
    CursorMode_L.l ; 0 = insert  1 = overwrite
  EndStructure
  Structure EditorGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    ItemMem_P.l ; a pointer to memory, which stores the Pointers to the Structure EditorItems
    SpriteID_L.l ; the ID of the sprite to render to
    ; Text_S.s ; the text of the Textgadget
    Flags_L.l ; contains the Display-Flags
    TextFont_L.l ; the standard font for this gadget
    PageLenghtVertical_L.l ; the virtual size of all the data to show
    ScrollbarVertical_L.l ; 0, if there is no vertical scrollbar, otherwise the pointer to the scrollbar-listelement
    PageLenghtHorizontal_L.l ; the virtual size of all the data to show
    ScrollbarHorizontal_L.l ; 0, if there is no horizontal scrollbar, otherwise the pointer to the scrollbar-listelement
    CursorPos_L.l ; at what position ist the cursor
    CursorMode_L.l ; 0 = insert  1 = overwrite
    CursorLine_L.l ; in what line is the cursor
  EndStructure
  Structure EditorItems
    Item_S.s ; limit the items per list
    ItemState_L.l ; the state of the item
    ItemFont_L.l ; the FontID of the item
    ItemSize_L.l ; the y-size of the text
    RowColor_L.l ; the color of the row or -1 for standard
    RowTextColor_L.l ; the color of the text of the row or -1 for standard
  EndStructure
  Structure ButtonGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    Text_S.s ; the text of the Buttongadget
    TextFont_L.l
    Toggle_L.l ; if 0, just clicks, if 1, Buttons keeps its state
    Toggle_State_L.l ; if it is a toggle-button, it keeps the toggle-state (1 = pressed)
    Flags_L.l ; contains the Display-Flags
  EndStructure
  Structure CheckBoxGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    Text_S.s ; the text of the Checkboxgadget
    TextFont_L.l
    Status_L.l
    Flags_L.l ; contains the Display-Flags
  EndStructure
  Structure ComboBoxGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    ItemMem_P.l ; a pointer to memory, which stores the Pointers to the Structure ComboBoxItems
    TextFont_L.l
    Open_L.l ; = 1, if open
    Status_L.l ; the state of the gadget
    TextHeight_L.l ; stores the real fontheight the ComboBox is drawn
    Flags_L.l ; contains the Display-Flags
    PageLenghtVertical_L.l ; the virtual size of all the data to show
    ScrollbarVertical_L.l ; 0, if there is no vertical scrollbar, otherwise the pointer to the scrollbar-listelement
  EndStructure
  Structure ComboBoxItems
    Item_S.s ; the item text
    ItemFont_L.l ; the FontID of the item
    ItemSize_L.l ; the y-size of the text
    RowColor_L.l ; the color of the row or -1 for standard
    RowTextColor_L.l ; the color of the text of the row or -1 for standard
  EndStructure
  Structure OptionGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    Text_S.s ; the text of the Optiongadget
    Group_L.l ; Number for the Group to which these gadget belongs
    TextFont_L.l
    Status_L.l
    Flags_L.l ; contains the Display-Flags
  EndStructure
  Structure TrackBarGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    Min_L.l
    Max_L.l
    Position_L.l
    Value_L.l
    Flags_L.l ; contains the Display-Flags
  EndStructure
  Structure ListIconGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    ItemMem_P.l ; a pointer to memory, which stores the Pointers to the Structure ListIconItems
    HeaderText_S.s[16] ; the text of the Gadget/Column header
    HeaderWidth.l[16] ; the width of the Gadget/Column header
    HeaderStatus.l[16] ; 1, if the list is sortet by this header (-1 if other direction)
    TextFont_L.l
    HeaderTextColor_L.l ; the Color values for the header and the Gridlines
    HeaderBackColor_L.l
    LineColor_L.l
    
    TextHeight_L.l ; stores the real fontheight the listicon is drawn
    HeaderHeight_L.l ; the height of the Header
    Flags_L.l ; contains the Display-Flags
    ShowImages_L.l ; 1 if there are Images to show, otherwise 0
    PageLenghtVertical_L.l ; the virtual size of all the data to show
    ScrollbarVertical_L.l ; 0, if there is no vertical scrollbar, otherwise the pointer to the scrollbar-listelement
    
    Last_Selected_L.l ; stores the last selected item
    
    ; Some add. Data for the use as ExplorerListGadget
    Directory_S.s
    HeaderType.l[16] ; 0, if without autofunction; 1- ... see the constants #SG_Explorer_Name ...
    ExplorerFlags_L.l ; stores the Flags for the Explorergadget
  EndStructure
  Structure ListIconItems
    Item_S.s ; the item-text
    ItemState_L.l ; the state of the item
    ItemFont_L.l ; the FontID of the item
    ItemSize_L.l ; the y-size of the text
    RowColor_L.l ; the color of the row or -1 for standard
    RowTextColor_L.l ; the color of the text of the row or -1 for standard
    ImageID_L.l ; the number of the image
    
    ; for the ExplorerList gadget
    FileData_L.l ; contains #PB_DirectoryEntry_File or #PB_DirectoryEntry_Directory, depending on the type of entry
  EndStructure
  Structure ScrollBarGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    Min_L.l
    Max_L.l
    PageLenght_L.l
    Value_L.l
    SliderSize_L.l
    Flags_L.l ; contains the Display-Flags
  EndStructure
  Structure ButtonImageGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    Toggle_L.l ; if 0, just clicks, if 1, Buttons keeps its state
    Toggle_State_L.l ; if it is a toggle-button, it keeps the toggle-state (1 = pressed)
    Flags_L.l ; contains the Display-Flags
  EndStructure
  Structure ImageGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    Flags_L.l ; contains the Display-Flags
  EndStructure
  Structure Frame3DGadget
    GadgetID_P.l ; the ID of the Item of the basic gadget list
    Text_S.s ; the text of the Buttongadget
    TextFont_L.l
    Flags_L.l ; contains the Display-Flags
  EndStructure
  
  Global NewList SG_Gadget.GadgetBase() ; Contains all the basic gadget data
  Global NewList SG_Button.ButtonGadget() ; the additional data for Button gadgets
  Global NewList SG_String.TextGadget()
  Global NewList SG_Editor.EditorGadget()
  Global NewList SG_Text.TextGadget() ; the additional data for text gadgets
  Global NewList SG_CheckBox.CheckBoxGadget()
  Global NewList SG_ComboBox.ComboBoxGadget()
  Global NewList SG_Option.OptionGadget()
  Global NewList SG_TrackBar.TrackBarGadget()
  Global NewList SG_ListIcon.ListIconGadget()
  Global NewList SG_ScrollBar.ScrollBarGadget()
  Global NewList SG_ButtonImage.ButtonImageGadget()
  Global NewList SG_Image.ImageGadget()
  Global NewList SG_Frame3D.Frame3DGadget()
  
  Global NewList EditorGdItems.EditorItems()
  Global NewList ListIconGdItems.ListIconItems()
  Global NewList ComboBoxGdItems.ComboBoxItems()
  
  
  Global MaxGadgetNumber_GL.l = 2100
  Global Dim GadgetNumber.l(MaxGadgetNumber_GL) ; contains the pointer to the internal list corresponding to a gadgetnumber
  
  
  StandardFont_S.s = "Standard"
  LoadFont(#SG_FontStandard, StandardFont_S, 9, #PB_Font_Bold)
  LoadFont(#SG_FontSymbol, "Wingdings", 12)
  
  ;{ Set the standard Values
  SG_StandardColor_GL = $000000
  SG_StandardBackground_GL = 1
  SG_StandardBackgroundData_GL = $C0C0C0
  SG_StandardHeaderTextColor_GL = 0
  SG_StandardHeaderBackColor_GL = #Col_GadgetHeader
  SG_StandardLineColor_GL = #Col_GadgetHeader
  SG_StandardDisabled_GL = #Col_Disabled
  SG_FontStandard_GL = #SG_FontStandard
  SG_FocusGadget_GL = -1
  SG_Group_GL = -1
  ;}
  
EndProcedure
  
 
ProcedureDLL PBOSL_Screengadgets_End()
  SG_FreeAllGadgets()
EndProcedure

;{ some basic functions
Procedure Core_Toggle(*val.Long)
  ; Diese Proc ndert den Inhalt der bergebenen Adresse (0 oder 1) (diese Version ist ca. 30% schneller als Peek und Poke)
  If *val\l
    *val\l = 0
  Else
    *val\l = 1
  EndIf
EndProcedure

; Procs for item-handling
Procedure.l ChangeItemMem(Mem_P.l, Change_L.l) ; change the memory-size for the itemhandling - first element = 1
  Back_L.l
  
  If Change_L > 0
    If Mem_P = 0 ; no mem reserved
      Back_L = AllocateMemory(Change_L<<2)
    Else
      Back_L = ReAllocateMemory(Mem_P, MemorySize(Mem_P) + Change_L<<2)
    EndIf
  Else
    If Mem_P > 0 And MemorySize(Mem_P) >= Change_L<<2 ; enough mem reserved
      If MemorySize(Mem_P) < Abs(Change_L*4)
        Change_L = -MemorySize(Mem_P)>>2
      EndIf
      If MemorySize(Mem_P) + Change_L<<2 > 0
        Back_L = ReAllocateMemory(Mem_P, MemorySize(Mem_P) + Change_L<<2)
      Else ; if size 0 -> free the memory
        Back_L = 0
        FreeMemory(Mem_P)
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn Back_L
EndProcedure
Procedure.l DeleteItemMem(Mem_P.l, Start_L.l) ; "delete" the given item
  Back_L.l
  Start_L-1
  If MemorySize(Mem_P) >= Start_L<<2
    ; Debug "memsize: " + Str(MemorySize(Mem_P))
    ; Debug "start: " + Str(Start_L<<2 + 4)
    ; Debug "memcopy: " + Str(MemorySize(Mem_P) - 4 - Start_L<<2)
    CopyMemory(Mem_P + Start_L<<2 + 4, Mem_P + Start_L<<2, MemorySize(Mem_P) - 4 - Start_L<<2)
    Back_L = ChangeItemMem(Mem_P, -1)
  EndIf
  ProcedureReturn Back_L
EndProcedure
Procedure.l AddItemMem(Mem_P.l, ItemNr_L.l) ; "adds" a new item
  Back_L.l = ChangeItemMem(Mem_P, 1) ; add memory for a new item
  
  If Back_L
    Size_L.l = MemorySize(Back_L) >> 2 ; # of items
    If ItemNr_L > Size_L Or ItemNr_L = -1 ; add it at the end
      
    Else ; shuffle down -> make space for the new item
      CopyMemory(Back_L + ItemNr_L<<2, Back_L + ItemNr_L<<2+4, MemorySize(Back_L) - 4 - ItemNr_L<<2)
    EndIf
  EndIf
  
  ProcedureReturn Back_L
EndProcedure
Procedure.l CountGadgetItemMem(Mem_P.l) ; returns the number of Items stored
  Back_L.l 
  If Mem_P
    If MemorySize(Mem_P)
      Back_L = MemorySize(Mem_P) >> 2
    EndIf
  EndIf
  ProcedureReturn Back_L
EndProcedure
Procedure.l ClearGadgetItemMem(Mem_P.l) ; release the memory for the items and returns a zero-pointer
  If MemorySize(Mem_P)
    FreeMemory(Mem_P)
  EndIf
  ProcedureReturn 0
EndProcedure
Procedure.l SG_ItemTextHeight(GadgetType_L.l) ; returns the height of the text of the actual element of EditorGdItems()
  Back_L.l
  If StartDrawing(ScreenOutput())
    Select GadgetType_L
      Case  #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
        If ListIconGdItems()\ItemFont_L <> #PB_Default
          DrawingFont(FontID(ListIconGdItems()\ItemFont_L))
        ElseIf SG_ListIcon()\TextFont_L And SG_ListIcon()\TextFont_L <> #PB_Default
          DrawingFont(FontID(SG_ListIcon()\TextFont_L))
        EndIf
        If ListIconGdItems()\Item_S = ""
          Back_L = TextHeight(" ")
        Else
          Back_L = TextHeight(ListIconGdItems()\Item_S)
        EndIf
        
      Case  #SG_GadgetType_Editor
        If EditorGdItems()\ItemFont_L <> #PB_Default
          DrawingFont(FontID(EditorGdItems()\ItemFont_L))
        ElseIf SG_Editor()\TextFont_L And SG_Editor()\TextFont_L <> #PB_Default
          DrawingFont(FontID(SG_Editor()\TextFont_L))
        EndIf
        If EditorGdItems()\Item_S = ""
          Back_L = TextHeight(" ")
        Else
          Back_L = TextHeight(EditorGdItems()\Item_S)
        EndIf
        
      Case  #SG_GadgetType_Combobox
        If ComboBoxGdItems()\ItemFont_L <> #PB_Default
          DrawingFont(FontID(ComboBoxGdItems()\ItemFont_L))
        ElseIf SG_ComboBox()\TextFont_L And SG_ComboBox()\TextFont_L <> #PB_Default
          DrawingFont(FontID(SG_ComboBox()\TextFont_L))
        EndIf
        If ComboBoxGdItems()\Item_S = ""
          Back_L = TextHeight(" ")
        Else
          Back_L = TextHeight(ComboBoxGdItems()\Item_S)
        EndIf
        
    EndSelect
    StopDrawing()
  EndIf
  ProcedureReturn Back_L
EndProcedure  
;}

Procedure.l SetGadgetNumber(SG_GadgetID_L.l) ; returns the number of the new created gadget
  Back_L.l
  If SG_GadgetID_L = #PB_Any
    For x = 1 To MaxGadgetNumber_GL
      If GadgetNumber(x) = 0
        Back_L = x
        Break
      EndIf
    Next
    If Back_L = 0 ; no free item
      Back_L = MaxGadgetNumber_GL + 1
      MaxGadgetNumber_GL + 50
      ReDim GadgetNumber(MaxGadgetNumber_GL)
    EndIf
    
  ElseIf SG_GadgetID_L > MaxGadgetNumber_GL
    MaxGadgetNumber_GL = SG_GadgetID_L + 50
    ReDim GadgetNumber(MaxGadgetNumber_GL)
    Back_L = SG_GadgetID_L
    
  Else
    Back_L = SG_GadgetID_L
    
  EndIf
  
  ProcedureReturn Back_L
EndProcedure



;/ The Screen Gadget Procedures

;/ Creation - Procedures
Procedure SG_SetGadgetBasics(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l)
  ; this proc write the basic gadget information in the list
  SG_Gadget()\SG_GadgetID_L = SetGadgetNumber(SG_GadgetID_L)
  GadgetNumber(SG_Gadget()\SG_GadgetID_L) = @SG_Gadget()
  SG_Gadget()\GadgetID_P = @SG_Gadget() ;
  SG_Gadget()\X_Pos_L = X_Pos_L ; the xpos of the Gadget
  SG_Gadget()\Y_Pos_L = Y_Pos_L ; the ypos of the Gadget
  SG_Gadget()\Width_L = Width_L; the widht of the Gadget
  SG_Gadget()\Height_L = Height_L  ; the height of the Gadget
  SG_Gadget()\TextColor_L = SG_StandardColor_GL
  SG_Gadget()\DisabledColor_L = SG_StandardDisabled_GL
  SG_Gadget()\BackGround_L = SG_StandardBackground_GL ; standard background: 0 = no Background   1= Color  2 = image
  SG_Gadget()\BackGroundDetail_L = SG_StandardBackgroundData_GL
  
  SG_FocusGadget_GL = SG_GadgetID_L
  
  ; Special settings
  If SG_Gadget()\GadgetType_L <> #SG_GadgetType_Option
    SG_Group_GL = -1
    If SG_Gadget()\GadgetType_L = #SG_GadgetType_ButtonImage Or SG_Gadget()\GadgetType_L = #SG_GadgetType_Image
      SG_Gadget()\BackGround_L = 2 ; always image
    ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Frame3D
      SG_Gadget()\BackGround_L = 0 ; always transparent
    EndIf
  EndIf
EndProcedure
ProcedureDLL.l SG_ButtonGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, GadgetText_S.s, Flags_L.l) ; creates a button gadget
  Back_L.l
  ; this proc creates a Button Buttongadget
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_Button
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_Button()) ; the additional list
  SG_Gadget()\AddList_P = @SG_Button() ; contains a pointer to the linked element of the basic gadget
  SG_Button()\GadgetID_P = @SG_Gadget()
  SG_Button()\Text_S = GadgetText_S
  SG_Button()\TextFont_L = SG_FontStandard_GL
  SG_Button()\Flags_L = Flags_L
  If Flags_L & #PB_Button_Toggle
    SG_Button()\Toggle_L = 1
  EndIf
  
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL.l SG_ButtonGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, GadgetText_S.s) ; creates a button gadget
  ; this proc creates a Button Buttongadget
  ProcedureReturn SG_ButtonGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, GadgetText_S, 0)
EndProcedure
ProcedureDLL.l SG_StringGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, GadgetText_S.s, Flags_L.l) ; creates a string gadget
  Back_L.l
  ; this proc creates a new Stringgadget
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_String
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_String()) ; the additional list
  SG_Gadget()\AddList_P = @SG_String() ; contains a pointer to the linked element of the basic gadget
  SG_String()\GadgetID_P = @SG_Gadget()
  SG_String()\Text_S = GadgetText_S
  SG_String()\TextFont_L = SG_FontStandard_GL
  SG_String()\Flags_L = Flags_L
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_StringGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, GadgetText_S.s) ; creates a string gadget
  ; this proc creates a new Stringgadget
  ProcedureReturn SG_StringGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, GadgetText_S, Flags_L)
EndProcedure
ProcedureDLL.l SG_EditorGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, Flags_L.l) ; creates an editor gadget
  Back_L.l
  ; this proc creates a new Stringgadget
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_Editor
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_Editor()) ; the additional list
  SG_Gadget()\AddList_P = @SG_Editor() ; contains a pointer to the linked element of the basic gadget
  SG_Editor()\GadgetID_P = @SG_Gadget()
  SG_Editor()\TextFont_L = SG_FontStandard_GL
  SG_Editor()\Flags_L = Flags_L
  SG_Editor()\SpriteID_L = CreateSprite(#PB_Any, Width_L+1, Height_L+1)
  
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_EditorGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l) ; creates an editor gadget
  ProcedureReturn SG_EditorGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, 0) ; creates a string gadget
EndProcedure
ProcedureDLL.l SG_TextGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, GadgetText_S.s, Flags_L.l) ; creates a text gadget
  Back_L.l
  ; this proc creates a new textgadget
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_Text
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_Text()) ; the additional list
  SG_Gadget()\AddList_P = @SG_Text() ; contains a pointer to the linked element of the basic gadget
  SG_Text()\GadgetID_P = @SG_Gadget()
  SG_Text()\Text_S = GadgetText_S
  SG_Text()\TextFont_L = SG_FontStandard_GL
  SG_Text()\Flags_L = Flags_L
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_TextGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, GadgetText_S.s) ; creates a text gadget
  ; this proc creates a new textgadget
  ProcedureReturn SG_TextGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, GadgetText_S, 0)
EndProcedure
ProcedureDLL.l SG_CheckBoxGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, GadgetText_S.s) ; creates a checkbox gadget
  Back_L.l
  ; this proc creates a CheckBoxgadget
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_Checkbox
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_CheckBox()) ; the additional list
  SG_Gadget()\AddList_P = @SG_CheckBox() ; contains a pointer to the linked element of the basic gadget
  SG_CheckBox()\GadgetID_P = @SG_Gadget()
  SG_CheckBox()\Text_S = GadgetText_S
  SG_CheckBox()\TextFont_L = SG_FontStandard_GL
  SG_CheckBox()\Flags_L = Flags_L
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_OptionGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, GadgetText_S.s) ; creates a option gadget
  Back_L.l
  ; this proc creates a Optiongadget
  Group_L.l ; var to find the current groupnumber
  
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_Option
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_Option()) ; the additional list
  SG_Gadget()\AddList_P = @SG_Option() ; contains a pointer to the linked element of the basic gadget
  SG_Option()\GadgetID_P = @SG_Gadget()
  SG_Option()\Text_S = GadgetText_S
  SG_Option()\TextFont_L = SG_FontStandard_GL
  SG_Option()\Flags_L = Flags_L
  ; assign a group number
  If CountList(SG_Gadget())
    If SG_Group_GL > -1
      SG_Option()\Group_L = SG_Group_GL
      
    Else ; calc a new Groupnumber
      ResetList(SG_Option()) ; search for the highest Groupnumber
      While NextElement(SG_Option())
        If Group_L < SG_Option()\Group_L
          Group_L = SG_Option()\Group_L
        EndIf
      Wend
      SG_Group_GL = Group_L + 1
      SG_Option()\Group_L = SG_Group_GL
      ; debug "grpounumber: " + Str(SG_Option()\Group_L)
    EndIf
    
  Else ; first gadget
    SG_Option()\Group_L = 1
    SG_Group_GL = 1
  EndIf
  ; Debug "background: " + Str(SG_Gadget()\BackGround_L)
  ; Debug "backgrounddet: " + Str(SG_Gadget()\BackGroundDetail_L)
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_TrackBarGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, StartValue_L.l, EndValue_L.l, Flags_L.l) ; creates a trackbar gadget
  Back_L.l
  ; this proc creates a Trackbargadget
  AddElement(SG_Gadget()) ; the basic list
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  SG_Gadget()\GadgetType_L = #SG_GadgetType_Trackbar
  AddElement(SG_TrackBar()) ; the additional list
  SG_Gadget()\AddList_P = @SG_TrackBar() ; contains a pointer to the linked element of the basic gadget
  SG_TrackBar()\GadgetID_P = @SG_Gadget()
  SG_TrackBar()\Min_L = StartValue_L
  SG_TrackBar()\Max_L = EndValue_L
  SG_TrackBar()\Value_L = StartValue_L
  SG_TrackBar()\Flags_L = Flags_L
  If Flags_L & #PB_TrackBar_Vertical ; change height and width
    t = SG_Gadget()\Width_L 
    SG_Gadget()\Width_L = SG_Gadget()\Height_L
    SG_Gadget()\Height_L = t
  EndIf
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_TrackBarGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, StartValue_L.l, EndValue_L.l) ; creates a trackbar gadget
  ; this proc creates a Trackbargadget
  ProcedureReturn SG_TrackBarGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, StartValue_L, EndValue_L, 0)
EndProcedure
ProcedureDLL.l SG_ListIconGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, ColumnName_S.s, ColumnWidth_L.l, Flags_L) ; creates a listicon gadget
  Back_L.l
  ; this proc creates a new List(...)gadget
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_ListIcon()) ; the additional list
  SG_Gadget()\AddList_P = @SG_ListIcon() ; contains a pointer to the linked element of the basic gadget
  SG_ListIcon()\GadgetID_P = @SG_Gadget()
  SG_ListIcon()\TextFont_L = SG_FontStandard_GL
  
  SG_ListIcon()\HeaderTextColor_L = SG_StandardHeaderTextColor_GL ; the Color values for the header and the Gridlines
  SG_ListIcon()\HeaderBackColor_L = SG_StandardHeaderBackColor_GL
  SG_ListIcon()\LineColor_L = SG_StandardLineColor_GL
  
  SG_ListIcon()\Last_Selected_L = -1
  SG_ListIcon()\Flags_L = Flags_L
  SG_ListIcon()\HeaderWidth[0] = ColumnWidth_L
  SG_ListIcon()\HeaderText_S[0] = ColumnName_S
  For x = 0 To 15
    SG_ListIcon()\HeaderStatus[x] = -1 ; preset
  Next
  SG_Gadget()\BackGroundDetail_L = $FFFFFF ; a white background as standard
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_ListIconGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, ColumnName_S.s, ColumnWidth_L.l) ; creates a listicon gadget
  ; this proc creates a new List(...)gadget
  ProcedureReturn SG_ListIconGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, ColumnName_S, ColumnWidth_L, 0)
EndProcedure
ProcedureDLL.l SG_ExplorerListGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, Directory_S.s, Flags_L.l) ; creates a Explorerlist gadget
  Back_L.l
  TFlags_L.l
  
  ;{ "translate" the flags for the Licon gadget
  If Flags_L & #PB_Explorer_AlwaysShowSelection 
    TFlags_L | #PB_ListIcon_AlwaysShowSelection
  EndIf
  If Flags_L & #PB_Explorer_MultiSelect
    TFlags_L | #PB_ListIcon_MultiSelect
  EndIf
  If Flags_L & #PB_Explorer_GridLines
    TFlags_L | #PB_ListIcon_GridLines
  EndIf
  If Flags_L & #PB_Explorer_FullRowSelect
    TFlags_L | #PB_ListIcon_FullRowSelect
  EndIf
  ;}
  
  Back_L = SG_ListIconGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, "Name", 150, TFlags_L)
  
  ; je nach de ob 
  If SG_GadgetID_L = #PB_Any
    GadgetID_L = Back_L
  Else
    GadgetID_L = SG_GadgetID_L
  EndIf
  
  SG_ListIcon()\ExplorerFlags_L = Flags_L
  SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
  SG_ListIcon()\HeaderType[0] = #SG_Explorer_Name
  
  ; Create additional Columns with autofunction
  SG_AddGadgetColumn(GadgetID_L, 1, #PB_Explorer_Size, 70)
  SG_AddGadgetColumn(GadgetID_L, 2, #PB_Explorer_Type, 50)
  SG_AddGadgetColumn(GadgetID_L, 3, #PB_Explorer_Modified, 100)
  
  ; set the Gadget
  SG_FillExplorerGadget(GadgetID_L, Directory_S)
  
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL.l SG_ExplorerListGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, Directory_S.s) ; creates a Explorerlist gadget
  SG_ExplorerListGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, Directory_S, 0)
EndProcedure
ProcedureDLL.l SG_ScrollBarGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, StartValue_L.l, EndValue_L.l, PageLenght_L.l, Flags_L) ; creates a scrollbar gadget
  Back_L.l
  ; this proc creates a new ScrollBargadget
  Back_L.l
  ; Debug "scbar start : " + Str(StartValue_L) + "   end: " + Str(EndValue_L) + "   page: " + Str(PageLenght_L)
  ; Debug "---------- gadget ID given: " + Str(SG_GadgetID_L)
  ; check For valid values
  If PageLenght_L < 1
    PageLenght_L = 1
  EndIf
  ; Debug "scbar start : " + Str(StartValue_L) + "   end: " + Str(EndValue_L) + "   page: " + Str(PageLenght_L)
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_ScrollBar
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_ScrollBar()) ; the additional list
  SG_Gadget()\AddList_P = @SG_ScrollBar() ; contains a pointer to the linked element of the basic gadget
  SG_ScrollBar()\GadgetID_P = @SG_Gadget()
  SG_ScrollBar()\Min_L = StartValue_L
  SG_ScrollBar()\Max_L = EndValue_L
  SG_ScrollBar()\PageLenght_L = PageLenght_L
  SG_ScrollBar()\Value_L = 0
  
  If Flags_L & #PB_ScrollBar_Vertical
    ; SG_ScrollBar()\SliderSize_L = (PageLenght_L * (Height_L - 20)) / (EndValue_L - StartValue_L - 2)
    SG_ScrollBar()\SliderSize_L = (PageLenght_L * (Height_L - 20)) / (EndValue_L - StartValue_L + 1)
  Else
    ; SG_ScrollBar()\SliderSize_L = (PageLenght_L * (Width_L - 20)) / (EndValue_L - StartValue_L - 2)
    SG_ScrollBar()\SliderSize_L = (PageLenght_L * (Width_L - 20)) / (EndValue_L - StartValue_L + 1)
  EndIf
  ; Debug"slidersize: " + Str(SG_ScrollBar()\SliderSize_L)
  
  SG_ScrollBar()\Flags_L = Flags_L
  
  ; Debug "scbar slider : " + Str(SG_ScrollBar()\SliderSize_L)
  If SG_ScrollBar()\SliderSize_L < 10
    SG_ScrollBar()\SliderSize_L = 10
  Else
    If SG_ScrollBar()\Flags_L & #PB_ScrollBar_Vertical
      If SG_ScrollBar()\SliderSize_L > Height_L - 23
        SG_ScrollBar()\SliderSize_L = Height_L - 23
      EndIf
    Else
      If SG_ScrollBar()\SliderSize_L > Width_L-23
        SG_ScrollBar()\SliderSize_L = Width_L-23
      EndIf
    EndIf
    
  EndIf
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_ScrollBarGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, StartValue_L.l, EndValue_L.l, PageLenght_L.l) ; creates a scrollbar gadget
  ; this proc creates a new ScrollBargadget
  ProcedureReturn SG_ScrollBarGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, StartValue_L, EndValue_L, PageLenght_L, 0)
EndProcedure
ProcedureDLL.l SG_ButtonImageGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, ImageID_L.l, Flags_L.l) ; creates a Imagebutton gadget
  Back_L.l
  ; this proc creates a Imagebuttongadget
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_ButtonImage
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_ButtonImage()) ; the additional list
  SG_Gadget()\AddList_P = @SG_ButtonImage() ; contains a pointer to the linked element of the basic gadget
  SG_ButtonImage()\GadgetID_P = @SG_Gadget()
  SG_Gadget()\BackGroundDetail_L = ImageID_L
  SG_ButtonImage()\Flags_L = Flags_L
  If Flags_L & #PB_Button_Toggle
    SG_ButtonImage()\Toggle_L = 1
  EndIf
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_ButtonImageGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, ImageID_L.l) ; creates a Imagebutton gadget
  ; this proc creates a Imagebuttongadget
  ProcedureReturn SG_ButtonImageGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, ImageID_L, 0)
EndProcedure
ProcedureDLL.l SG_ImageGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, ImageID_L.l, Flags_L.l) ; creates a Image gadget
  Back_L.l
  ; this proc creates a Imagebuttongadget
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_Image
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_Image()) ; the additional list
  SG_Gadget()\AddList_P = @SG_Image() ; contains a pointer to the linked element of the basic gadget
  SG_Image()\GadgetID_P = @SG_Gadget()
  SG_Gadget()\BackGroundDetail_L = ImageID_L
  SG_Image()\Flags_L = Flags_L
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_ImageGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, ImageID_L.l) ; creates a Image gadget
  ; this proc creates a Imagebuttongadget
  ProcedureReturn SG_ImageGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, ImageID_L, 0)
EndProcedure
ProcedureDLL.l SG_Frame3DGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, GadgetText_S.s, Flags_L.l) ; creates a Image gadget
  Back_L.l
  ; this proc creates a Imagebuttongadget
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_Frame3D
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_Frame3D()) ; the additional list
  SG_Gadget()\AddList_P = @SG_Frame3D() ; contains a pointer to the linked element of the basic gadget
  SG_Frame3D()\GadgetID_P = @SG_Gadget()
  SG_Frame3D()\Text_S = GadgetText_S
  SG_Frame3D()\TextFont_L = SG_FontStandard_GL
  SG_Frame3D()\Flags_L = Flags_L
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_Frame3DGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, GadgetText_S.s) ; creates a Image gadget
  ; this proc creates a Imagebuttongadget
  ProcedureReturn SG_Frame3DGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, GadgetText_S, 0)
EndProcedure
ProcedureDLL.l SG_ComboBoxGadget2(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l, Flags_L.l) ; creates a ComboBox gadget
  Back_L.l
  ; this proc creates a new List(...)gadget
  AddElement(SG_Gadget()) ; the basic list
  SG_Gadget()\GadgetType_L = #SG_GadgetType_Combobox
  SG_SetGadgetBasics(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L)
  AddElement(SG_ComboBox()) ; the additional list
  SG_Gadget()\AddList_P = @SG_ComboBox() ; contains a pointer to the linked element of the basic gadget
  SG_ComboBox()\GadgetID_P = @SG_Gadget()
  SG_ComboBox()\TextFont_L = SG_FontStandard_GL
  SG_ComboBox()\Status_L = -1
  SG_ComboBox()\Flags_L = Flags_L
  SG_Gadget()\BackGroundDetail_L = $FFFFFF ; a white background as standard
  If SG_GadgetID_L = #PB_Any
    Back_L = SG_Gadget()\SG_GadgetID_L
  Else
    Back_L = @SG_Gadget()
  EndIf
  ProcedureReturn Back_L
  
EndProcedure
ProcedureDLL.l SG_ComboBoxGadget(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l, Width_L.l, Height_L.l) ; creates a ComboBox gadget
  ProcedureReturn SG_ComboBoxGadget2(SG_GadgetID_L, X_Pos_L, Y_Pos_L, Width_L, Height_L, 0)
EndProcedure



;/ The gadget functionality
ProcedureDLL.l SG_GadgetID(SG_GadgetID_L.l) ; returns the ID (=pointer to the listelement) of that gadget
  Back_L.l
  ; this Proc return the ID (i.e. the pointer to the basic data) of the gadget
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    Back_L = SG_Gadget()\AddList_P
  EndIf
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL.l SG_IsGadget(SG_GadgetID_L.l) ; returns the the ID (=pointer to the listelement) of the specified gagdet, or 0, if it does not exist
  ; this function return the Pointer to the gadget, if it exist otherwise 0
  Back_L.l
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Back_L = SG_Gadget()\GadgetID_P
    EndIf
  EndIf
  
  ProcedureReturn Back_L
EndProcedure

ProcedureDLL.l SG_SetFocusGadget(SG_GadgetID_L.l) ; set the focus to the specified gagdet
  ; This proc sets the Focus to an existing gadget
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      SG_FocusGadget_GL = SG_GadgetID_L
    EndIf
  EndIf
EndProcedure
ProcedureDLL.l SG_GetFocusGadget() ; returns the Number of the gagdet with the current focus, otherwise -1
  ; This Proc will return the GadgetNumber (not the ID/pointer) if the Gadget with the Focus on it or -1 if no gagdget has the Focus.
  ProcedureReturn SG_FocusGadget_GL
EndProcedure

ProcedureDLL SG_DisableGadget(SG_GadgetID_L.l, State_L.l) ; disables the specified gagdet
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      SG_Gadget()\Disabled_L = State_L
    EndIf
  EndIf
EndProcedure

ProcedureDLL SG_HideGadget(SG_GadgetID_L.l, State_L.l) ; hides the specified gagdet
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      SG_Gadget()\Hidden_L = State_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Combobox
        ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
        If SG_ComboBox()\ScrollbarVertical_L
          SG_HideGadget(SG_Gadget()\SG_GadgetID_L + 2000, State_L) ; hide the scrollbar
        EndIf
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Editor
        ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
        If SG_Editor()\ScrollbarVertical_L
          SG_HideGadget(SG_Gadget()\SG_GadgetID_L + 2000, State_L) ; hide the scrollbar
        EndIf
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        If SG_ListIcon()\ScrollbarVertical_L
          SG_HideGadget(SG_Gadget()\SG_GadgetID_L + 2000, State_L) ; hide the scrollbar
        EndIf
        
      EndIf
    EndIf
  EndIf
  
EndProcedure

ProcedureDLL SG_FreeGadget(SG_GadgetID_L.l) ; remove the specified gagdet
  t = @SG_Gadget()
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Text
          ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P)
          DeleteElement(SG_Text())
          
        Case #SG_GadgetType_String
          ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
          DeleteElement(SG_String())
          
        Case #SG_GadgetType_Editor
          SG_ClearGadgetItemList(SG_GadgetID_L)
          ; ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          If SG_Editor()\ScrollbarVertical_L
            SG_FreeGadget(SG_Gadget()\SG_GadgetID_L + 2000)
          EndIf
          DeleteElement(SG_Editor())
          
        Case #SG_GadgetType_Button
          ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
          DeleteElement(SG_Button())
          
        Case #SG_GadgetType_Checkbox
          ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
          DeleteElement(SG_CheckBox())
          
        Case #SG_GadgetType_Combobox
          SG_ClearGadgetItemList(SG_GadgetID_L)
          ; ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
          If SG_ComboBox()\ScrollbarVertical_L
            SG_FreeGadget(SG_Gadget()\SG_GadgetID_L + 2000)
          EndIf
          DeleteElement(SG_ComboBox())
          
        Case #SG_GadgetType_Option
          ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
          DeleteElement(SG_Option())
          
        Case #SG_GadgetType_Trackbar
          ChangeCurrentElement(SG_TrackBar(), SG_Gadget()\AddList_P)
          DeleteElement(SG_TrackBar())
          
        Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
          SG_ClearGadgetItemList(SG_GadgetID_L)
          ; ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          If SG_ListIcon()\ScrollbarVertical_L
            SG_FreeGadget(SG_Gadget()\SG_GadgetID_L + 2000)
          EndIf
          DeleteElement(SG_ListIcon())
          
        Case #SG_GadgetType_ScrollBar
          ChangeCurrentElement(SG_ScrollBar(), SG_Gadget()\AddList_P)
          DeleteElement(SG_ScrollBar())
          
        Case #SG_GadgetType_Image
          ChangeCurrentElement(SG_Image(), SG_Gadget()\AddList_P)
          DeleteElement(SG_Image())
          
        Case #SG_GadgetType_ButtonImage
          ChangeCurrentElement(SG_ButtonImage(), SG_Gadget()\AddList_P)
          DeleteElement(SG_ButtonImage())
          
        Case #SG_GadgetType_Frame3D
          ChangeCurrentElement(SG_Frame3D(), SG_Gadget()\AddList_P)
          DeleteElement(SG_Frame3D())
          
      EndSelect
      GadgetNumber(SG_GadgetID_L) = 0
      DeleteElement(SG_Gadget())
    EndIf
  EndIf
  ChangeCurrentElement(SG_Gadget(), t)
EndProcedure
ProcedureDLL SG_FreeAllGadgets() ; releases all gadgets
  ; this proc frees all ScreenGadgets and restore the standard settings
  ClearList(SG_Gadget()) ; the basic structure
  ClearList(SG_Button()) ; the additional Data for gadgettype
  ClearList(SG_String())
  ClearList(SG_Text())
  ClearList(SG_CheckBox())
  
  ClearList(SG_Option())
  ClearList(SG_TrackBar())
  ClearList(SG_ScrollBar())
  ClearList(SG_ButtonImage())
  ClearList(SG_Image())
  ClearList(SG_Frame3D())
  
  ClearList(EditorGdItems())
  ClearList(ListIconGdItems())
  ClearList(ComboBoxGdItems())
  
  ; release the allocated memory
  ResetList(SG_Editor())
  While NextElement(SG_Editor())
    FreeMemory(SG_Editor()\ItemMem_P)
  Wend
  ResetList(SG_ListIcon())
  While NextElement(SG_ListIcon())
    FreeMemory(SG_ListIcon()\ItemMem_P)
  Wend
  ResetList(SG_ComboBox())
  While NextElement(SG_ComboBox())
    FreeMemory(SG_ComboBox()\ItemMem_P)
  Wend
  ClearList(SG_Editor())
  ClearList(SG_ListIcon())
  ClearList(SG_ComboBox())
  
  SG_StandardColor_GL = $000000
  SG_StandardBackground_GL = 1
  SG_StandardBackgroundData_GL = $C0C0C0
  
  SG_EventType_L = 0
  SG_FocusGadget_GL = 0
  SG_Group_GL = -1
EndProcedure


;/ The gadget content
; whole gadget
ProcedureDLL SG_SetGadgetText(SG_GadgetID_L.l, GadgetText_S.s) ; change the text of the specified gagdet
  s.s
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Frame3D
          ChangeCurrentElement(SG_Frame3D(), SG_Gadget()\AddList_P)
          SG_Frame3D()\Text_S = GadgetText_S
        
        Case #SG_GadgetType_Text
          ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P)
          SG_Text()\Text_S = GadgetText_S
          
        Case #SG_GadgetType_String
          ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
          SG_String()\Text_S = GadgetText_S
          SG_String()\CursorPos_L = Len(GadgetText_S)
          
        Case #SG_GadgetType_Editor ;{
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          SG_ClearGadgetItemList(SG_GadgetID_L) ; first clear the old list
          
          If GadgetText_S
            Count_L = 0
            t = 1
            While GadgetText_S And t
              x = 0
              t = FindString(GadgetText_S, Chr(13), 1)
              If t
                s = Left(GadgetText_S, t-1)
                GadgetText_S = Right(GadgetText_S, Len(GadgetText_S) - t - 1)
                x = 1
                ; Debug "Set txt: " + Str(Count_L) + ": " + s
              Else
                s = GadgetText_S
                x = 1
                ; Debug "Set txt (else): " + Str(Count_L) + ": " + s
              EndIf
              If x
                SG_AddGadgetItem(SG_GadgetID_L, -1, s)
                Count_L + 1
              EndIf
            Wend
            SG_Editor()\CursorPos_L = Len(EditorGdItems()\Item_S)
            SG_Editor()\CursorLine_L = CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
          EndIf
          ;}
          
        Case #SG_GadgetType_Button
          ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
          SG_Button()\Text_S = GadgetText_S
          
        Case #SG_GadgetType_Checkbox
          ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
          SG_CheckBox()\Text_S = GadgetText_S
          
        Case #SG_GadgetType_Option
          ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
          SG_Option()\Text_S = GadgetText_S
          ; Case #SG_GadgetType_Trackbar
          ; ChangeCurrentElement(SG_TrackBar(), SG_Gadget()\AddList_P)
          
        Case #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          SG_ListIcon()\Directory_S = GadgetText_S
          SG_FillExplorerGadget(SG_Gadget()\SG_GadgetID_L, SG_ListIcon()\Directory_S)
          
      EndSelect
    EndIf
  EndIf
EndProcedure
ProcedureDLL.s SG_GetGadgetText(SG_GadgetID_L.l) ; returns the text of the specified gagdet
  *l.Long
  
  Back_S.s
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Frame3D
          ChangeCurrentElement(SG_Frame3D(), SG_Gadget()\AddList_P)
          Back_S = SG_Frame3D()\Text_S
          
        Case #SG_GadgetType_Text
          ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P)
          Back_S = SG_Text()\Text_S
          
        Case #SG_GadgetType_String
          ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
          Back_S = SG_String()\Text_S
          
        Case #SG_GadgetType_Editor
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          For x = 0 To CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
            *l = SG_Editor()\ItemMem_P + x << 2
            ChangeCurrentElement(EditorGdItems(), *l\l)
            Back_S + EditorGdItems()\Item_S + #CRLF$
          Next
          
        Case #SG_GadgetType_Button
          ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
          Back_S = SG_Button()\Text_S
          
        Case #SG_GadgetType_Checkbox
          ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
          Back_S = SG_CheckBox()\Text_S
          
        Case #SG_GadgetType_Combobox
          ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
          *l = SG_ComboBox()\ItemMem_P + SG_ComboBox()\Status_L << 2
          ChangeCurrentElement(ComboBoxGdItems(), *l\l)
          Back_S + ComboBoxGdItems()\Item_S
          
        Case #SG_GadgetType_Option
          ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
          Back_S = SG_Option()\Text_S
          ; Case #SG_GadgetType_Trackbar
          ; ChangeCurrentElement(SG_TrackBar(), SG_Gadget()\AddList_P)
          
        Case #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          Back_S = SG_ListIcon()\Directory_S
          
      EndSelect
    EndIf
  EndIf
  ProcedureReturn Back_S
EndProcedure

; items
ProcedureDLL SG_SetGadgetItemText2(SG_GadgetID_L.l, Position_L.l, GadgetText_S.s, Column_L.l) ; change the text of an item of the specified gagdet
  *l.Long
  s.s
  s1.s
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        If Position_L > -1
          *l = SG_ListIcon()\ItemMem_P + Position_L << 2
          ChangeCurrentElement(ListIconGdItems(), *l\l)
          If Column_L = -1 ;{ change the whole item text
            If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon
              ListIconGdItems()\Item_S = GadgetText_S
              ListIconGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L) ; Set the Text size
            ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
              ; set only the non-auto-function columns
              n = CountString(GadgetText_S, Chr(10))
              If n > 15
                n = 15
              EndIf
              For x = 1 To n+1
                If SG_ListIcon()\HeaderType[x] = 0 ; no autofunction-header
                  s1 = StringField(GadgetText_S, x, Chr(10))
                Else
                  s1 = StringField(ListIconGdItems()\Item_S, x, Chr(10))
                EndIf
                s = s1 + Chr(10)
              Next
              ListIconGdItems()\Item_S = s
              ListIconGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L) ; Set the Text size
            EndIf
            ;}
          Else ;{ Change only a column of the item
            If Column_L > -1 And Column_L < 16
              If SG_ListIcon()\HeaderWidth[Column_L] > 0 And SG_ListIcon()\HeaderType[Column_L] = 0
                s = ""
                For x = 0 To 15
                  If SG_ListIcon()\HeaderWidth[x] > 0
                    If x <> Column_L
                      s + StringField(ListIconGdItems()\Item_S, x+1, Chr(10)) + Chr(10)
                    Else
                      s + GadgetText_S + Chr(10)
                    EndIf
                  EndIf
                Next
                ListIconGdItems()\Item_S = Left(s, Len(s) -1)
              EndIf
            EndIf
            ;}
          EndIf
          
        Else ; set the header
          n = CountString(GadgetText_S, Chr(10))
          For x = 0 To n
            SG_ListIcon()\HeaderText_S[x] = StringField(GadgetText_S, x+1, Chr(10))
          Next
        EndIf
      
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Editor
        ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
        If Position_L > -1
          *l = SG_Editor()\ItemMem_P + Position_L << 2
          ChangeCurrentElement(EditorGdItems(), *l\l)
          EditorGdItems()\Item_S = GadgetText_S
          EditorGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L) ; Set the Text size
        EndIf
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Combobox
        ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
        If Position_L > -1
          *l = SG_ComboBox()\ItemMem_P + Position_L << 2
          ChangeCurrentElement(ComboBoxGdItems(), *l\l)
          ComboBoxGdItems()\Item_S = GadgetText_S
          ComboBoxGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L) ; Set the Text size
        EndIf
      
      EndIf
    EndIf 
  EndIf 
EndProcedure
ProcedureDLL SG_SetGadgetItemText(SG_GadgetID_L.l, Position_L.l, GadgetText_S.s) ; change the text of an item of the specified gagdet
  SG_SetGadgetItemText2(SG_GadgetID_L, Position_L, GadgetText_S, -1)
EndProcedure
ProcedureDLL.s SG_GetGadgetItemText(SG_GadgetID_L.l, Position_L.l) ; returns the item text of the specified gagdet
  *l.Long
  Back_S.s
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        If Position_L > -1
          *l = SG_ListIcon()\ItemMem_P + Position_L << 2
          ChangeCurrentElement(ListIconGdItems(), *l\l)
          Back_S = ListIconGdItems()\Item_S
        Else
          For x = 0 To 15
            If SG_ListIcon()\HeaderWidth[x] > 0
              Back_S = Back_S + SG_ListIcon()\HeaderText_S[x] + Chr(10)
            EndIf
          Next
        EndIf
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Editor
        ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
        If Position_L > -1
          *l = SG_Editor()\ItemMem_P + Position_L << 2
          ChangeCurrentElement(EditorGdItems(), *l\l)
          Back_S = EditorGdItems()\Item_S
        EndIf
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Combobox
        ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
        If Position_L > -1
          *l = SG_ComboBox()\ItemMem_P + Position_L << 2
          ChangeCurrentElement(ComboBoxGdItems(), *l\l)
          Back_S = ComboBoxGdItems()\Item_S
        EndIf
        
      EndIf
    EndIf
  EndIf
  ProcedureReturn Back_S
EndProcedure
ProcedureDLL.s SG_GetGadgetItemText2(SG_GadgetID_L.l, Position_L.l, Column_L.l) ; returns the item text of the specified gagdet
  *l.Long
  Back_S.s
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        If Position_L > -1
          *l = SG_ListIcon()\ItemMem_P + Position_L << 2
          ChangeCurrentElement(ListIconGdItems(), *l\l)
          Back_S = StringField(ListIconGdItems()\Item_S, Column_L+1, Chr(10))
        Else
          If Column_L > -1 And Column_L < 16
            Back_S = SG_ListIcon()\HeaderText_S[Column_L]
          EndIf
        EndIf
        
      EndIf
    EndIf
  EndIf
  ProcedureReturn Back_S
EndProcedure

ProcedureDLL SG_AddGadgetItem2(SG_GadgetID_L.l, Position_L.l, Text_S.s, ImageID_L.l) ; add an item to the specified listicon gagdet
  *l.Long
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    ; Debug "durchsuche nr: " + Str(SG_Gadget()\SG_GadgetID_L) + " / " + Str(SG_GadgetID_L)
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L 
        Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          If Position_L > 0
            If Position_L > CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
              Position_L = -1 ; set at the end of the itemlist
            EndIf
          EndIf
          SG_ListIcon()\ItemMem_P = AddItemMem(SG_ListIcon()\ItemMem_P, Position_L)
          AddElement(ListIconGdItems())
          If Position_L = -1 ; general for end of list -> now the real position
            Position_L = CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
          EndIf
          
          *l = SG_ListIcon()\ItemMem_P + Position_L << 2 ; set the adress of the element with the Item-data into memory
          *l\l = @ListIconGdItems() ; Store the element pointer
          ListIconGdItems()\Item_S = Text_S
          ListIconGdItems()\ItemState_L = 0
          ListIconGdItems()\ItemFont_L = SG_ListIcon()\TextFont_L
          ListIconGdItems()\RowColor_L = #PB_Default
          ListIconGdItems()\RowTextColor_L = #PB_Default
          ListIconGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L) ; Set the Text size
          If ImageID_L And ListIconGdItems()\ItemSize_L < 19
            ListIconGdItems()\ItemSize_L = 19
          EndIf
          ListIconGdItems()\ImageID_L = ImageID_L
          ;}
        Case #SG_GadgetType_Editor ;{
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          
          If Position_L > 0
            If Position_L > CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
              Position_L = -1 ; set at the end of the itemlist
            EndIf
          EndIf
          SG_Editor()\ItemMem_P = AddItemMem(SG_Editor()\ItemMem_P, Position_L)
          AddElement(EditorGdItems())
          If Position_L = -1 ; general for end of list -> now the real position
            Position_L = CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
          EndIf
          
          *l = SG_Editor()\ItemMem_P + Position_L << 2 ; set the adress of the element with the Item-data into memory
          *l\l = @EditorGdItems() ; Store the element pointer
          EditorGdItems()\Item_S = Text_S
          EditorGdItems()\ItemState_L = 0
          EditorGdItems()\ItemFont_L = SG_Editor()\TextFont_L
          EditorGdItems()\RowColor_L = #PB_Default
          EditorGdItems()\RowTextColor_L = #PB_Default
          EditorGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L ) ; Set the Text size
          ;}
        Case #SG_GadgetType_Combobox ;{
          ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
          
          If Position_L > 0
            If Position_L > CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
              Position_L = -1 ; set at the end of the itemlist
            EndIf
          EndIf
          SG_ComboBox()\ItemMem_P = AddItemMem(SG_ComboBox()\ItemMem_P, Position_L)
          AddElement(ComboBoxGdItems())
          If Position_L = -1 ; general for end of list -> now the real position
            Position_L = CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
          EndIf
          
          *l = SG_ComboBox()\ItemMem_P + Position_L << 2 ; set the adress of the element with the Item-data into memory
          *l\l = @ComboBoxGdItems() ; Store the element pointer
          If SG_ComboBox()\Flags_L & #PB_ComboBox_LowerCase
            ComboBoxGdItems()\Item_S = LCase(Text_S)
          ElseIf SG_ComboBox()\Flags_L & #PB_ComboBox_UpperCase
            ComboBoxGdItems()\Item_S = UCase(Text_S)
          Else
            ComboBoxGdItems()\Item_S = Text_S
          EndIf
          ComboBoxGdItems()\ItemFont_L = SG_ComboBox()\TextFont_L
          ComboBoxGdItems()\RowColor_L = #PB_Default
          ComboBoxGdItems()\RowTextColor_L = #PB_Default
          ComboBoxGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L ) ; Set the Text size
          ;}
          
      EndSelect
      ; check if there are any images to display
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        t = 0
        For x = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
          *l = SG_ListIcon()\ItemMem_P + x << 2
          ChangeCurrentElement(ListIconGdItems(), *l\l)
          If ListIconGdItems()\ImageID_L
            t = 1
            Break
          EndIf
        Next
        SG_ListIcon()\ShowImages_L = t ; if there is anything to display (or not)
      EndIf
    EndIf
  EndIf
EndProcedure
ProcedureDLL SG_AddGadgetItem(SG_GadgetID_L.l, Position_L.l, Text_S.s) ; add an item to the specified listicon gagdet
  SG_AddGadgetItem2(SG_GadgetID_L, Position_L, Text_S, 0)
EndProcedure
ProcedureDLL SG_RemoveGadgetItem(SG_GadgetID_L.l, Position_L.l) ; removes the item an the position from the specified listicon gagdet
  *l.Long
  
  If GadgetNumber(SG_GadgetID_L) And Position_L > -1
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        If Position_L < CountGadgetItemMem(SG_ListIcon()\ItemMem_P)
          *l = SG_ListIcon()\ItemMem_P + Position_L << 2 ; write the adress of the element with the Item-data into memory
          ChangeCurrentElement(ListIconGdItems(), *l\l)
          DeleteElement(ListIconGdItems())
          SG_ListIcon()\ItemMem_P = DeleteItemMem(SG_ListIcon()\ItemMem_P, Position_L+1)
          ; set the "image-Display flag
          t = 0
          For x = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
            *l = SG_ListIcon()\ItemMem_P + x << 2
            ChangeCurrentElement(ListIconGdItems(), *l\l)
            If ListIconGdItems()\ImageID_L
              t = 1
              Break
            EndIf
          Next
          SG_ListIcon()\ShowImages_L = t ; if there is anything to display (or not)
        EndIf
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Editor
        ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
        If Position_L < CountGadgetItemMem(SG_Editor()\ItemMem_P)
          *l = SG_Editor()\ItemMem_P + Position_L << 2 ; write the adress of the element with the Item-data into memory
          ChangeCurrentElement(EditorGdItems(), *l\l)
          DeleteElement(EditorGdItems())
          SG_Editor()\ItemMem_P = DeleteItemMem(SG_Editor()\ItemMem_P, Position_L+1)
        EndIf
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Combobox
        ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
        If Position_L < CountGadgetItemMem(SG_ComboBox()\ItemMem_P)
          *l = SG_ComboBox()\ItemMem_P + (Position_L) << 2 ; write the adress of the element with the Item-data into memory
          ChangeCurrentElement(ComboBoxGdItems(), *l\l)
          DeleteElement(ComboBoxGdItems())
          SG_ComboBox()\ItemMem_P = DeleteItemMem(SG_ComboBox()\ItemMem_P, Position_L+1)
        EndIf
        
      EndIf
    EndIf
  EndIf
EndProcedure
ProcedureDLL SG_ClearGadgetItemList(SG_GadgetID_L.l) ; remove all items of the specified listicon gagdet
  *l.Long
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        For x = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
          *l = SG_ListIcon()\ItemMem_P + x << 2
          ChangeCurrentElement(ListIconGdItems(), *l\l)
          DeleteElement(ListIconGdItems())
        Next
        SG_ListIcon()\ItemMem_P = ClearGadgetItemMem(SG_ListIcon()\ItemMem_P)
        SG_ListIcon()\ShowImages_L = 0
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Editor
        ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
        For x = 0 To CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
          *l = SG_Editor()\ItemMem_P + x << 2
          ChangeCurrentElement(EditorGdItems(), *l\l)
          DeleteElement(EditorGdItems())
        Next
        SG_Editor()\ItemMem_P = ClearGadgetItemMem(SG_Editor()\ItemMem_P)
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Combobox
        ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
        For x = 0 To CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
          *l = SG_ComboBox()\ItemMem_P + x << 2
          ChangeCurrentElement(ComboBoxGdItems(), *l\l)
          DeleteElement(ComboBoxGdItems())
        Next
        SG_ComboBox()\ItemMem_P = ClearGadgetItemMem(SG_ComboBox()\ItemMem_P)
        
      EndIf
    EndIf
  EndIf
EndProcedure
ProcedureDLL.l SG_CountGadgetItems(SG_GadgetID_L.l) ; returns the number of items of the specified listicon gagdet
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        Back_L = CountGadgetItemMem(SG_ListIcon()\ItemMem_P)
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Editor
        ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
        Back_L = CountGadgetItemMem(SG_Editor()\ItemMem_P)
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Combobox
        ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
        Back_L = CountGadgetItemMem(SG_ComboBox()\ItemMem_P)
        
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn Back_L
EndProcedure

; columns
ProcedureDLL SG_AddGadgetColumn(SG_GadgetID_L.l, Column_L.l, ColumnName_S.s, ColumnWidth_L.l) ; add a column to the listicon gadget
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        For x = 15 To Column_L + 1 Step -1 ; shift down the other entries
          SG_ListIcon()\HeaderText_S[x] = SG_ListIcon()\HeaderText_S[x-1]
          SG_ListIcon()\HeaderWidth[x] = SG_ListIcon()\HeaderWidth[x-1]
          SG_ListIcon()\HeaderType[x] = SG_ListIcon()\HeaderType[x-1]
        Next
        SG_ListIcon()\HeaderText_S[Column_L] = ColumnName_S
        SG_ListIcon()\HeaderWidth[Column_L] = ColumnWidth_L
        
        If SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList ; maybe change the title and set the auto-function
          Select ColumnName_S
            Case #PB_Explorer_Name       ; displays the name of the file/directory
              SG_ListIcon()\HeaderText_S[Column_L] = "Name"
              SG_ListIcon()\HeaderType[Column_L] = #SG_Explorer_Name
            Case #PB_Explorer_Size       ; displays the filesize in Kb
              SG_ListIcon()\HeaderText_S[Column_L] = "Size"
              SG_ListIcon()\HeaderType[Column_L] =  #SG_Explorer_Size
            Case #PB_Explorer_Type       ; displays a string describing the filetype
              SG_ListIcon()\HeaderText_S[Column_L] = "Type"
              SG_ListIcon()\HeaderType[Column_L] =  #SG_Explorer_Type
            Case #PB_Explorer_Attributes ; displays the Attributes of the file/directory
              SG_ListIcon()\HeaderText_S[Column_L] = "Attributes"
              SG_ListIcon()\HeaderType[Column_L] =  #SG_Explorer_Attributes
            Case #PB_Explorer_Created    ; displays the time the file/directory was created
              SG_ListIcon()\HeaderText_S[Column_L] = "Created"
              SG_ListIcon()\HeaderType[Column_L] =  #SG_Explorer_Created
            Case #PB_Explorer_Modified   ; displays the time the file/directory was last modified
              SG_ListIcon()\HeaderText_S[Column_L] = "Modified"
              SG_ListIcon()\HeaderType[Column_L] =  #SG_Explorer_Modified
            Case #PB_Explorer_Accessed
              SG_ListIcon()\HeaderText_S[Column_L] = "Accessed"
              SG_ListIcon()\HeaderType[Column_L] =  #SG_Explorer_Accessed
          EndSelect
        EndIf
      EndIf
    EndIf
  EndIf
EndProcedure
ProcedureDLL SG_RemoveGadgetColumn(SG_GadgetID_L.l, Column_L.l) ; remove the given Column from the specified gadget
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        For x = Column_L To 14 ; shift down the other entries
          SG_ListIcon()\HeaderText_S[x] = SG_ListIcon()\HeaderText_S[x+1]
          SG_ListIcon()\HeaderWidth[x] = SG_ListIcon()\HeaderWidth[x+1]
          SG_ListIcon()\HeaderType[x] = SG_ListIcon()\HeaderType[x+1]
        Next
        SG_ListIcon()\HeaderText_S[15] = ""
        SG_ListIcon()\HeaderWidth[15] = 0
        SG_ListIcon()\HeaderType[15] = 0
        
        If SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
          SG_FillExplorerGadget(SG_Gadget()\SG_GadgetID_L, SG_ListIcon()\Directory_S) ; re-read the file data
        EndIf
      EndIf
    EndIf
  EndIf
  
EndProcedure


;/ the gadget attribute
; whole gadget
ProcedureDLL SG_SetGadgetAttribute(SG_GadgetID_L.l, Flags_L.l) ; change the flag of the specified gadget
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Text
          ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P)
          SG_Text()\Flags_L = Flags_L
          
        Case #SG_GadgetType_String
          ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
          SG_String()\Flags_L = Flags_L
          
        Case #SG_GadgetType_Editor
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          SG_Editor()\Flags_L = Flags_L
          
        Case #SG_GadgetType_Button
          ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
          SG_Button()\Flags_L = Flags_L
          
        Case #SG_GadgetType_Checkbox
          ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
          SG_CheckBox()\Flags_L = Flags_L
          
        Case #SG_GadgetType_Option
          ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
          SG_Option()\Flags_L = Flags_L
          
        Case #SG_GadgetType_Trackbar
          ChangeCurrentElement(SG_TrackBar(), SG_Gadget()\AddList_P)
          SG_TrackBar()\Flags_L = Flags_L
          
        Case #SG_GadgetType_Listicon
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          SG_ListIcon()\Flags_L = Flags_L
          
        Case #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          SG_ListIcon()\ExplorerFlags_L = Flags_L
          ;{ "translate" the flags for the Licon gadget
          If Flags_L & #PB_Explorer_AlwaysShowSelection 
            TFlags_L | #PB_ListIcon_AlwaysShowSelection
          EndIf
          If Flags_L & #PB_Explorer_MultiSelect
            TFlags_L | #PB_ListIcon_MultiSelect
          EndIf
          If Flags_L & #PB_Explorer_GridLines
            TFlags_L | #PB_ListIcon_GridLines
          EndIf
          If Flags_L & #PB_Explorer_FullRowSelect
            TFlags_L | #PB_ListIcon_FullRowSelect
          EndIf
          SG_ListIcon()\Flags_L = TFlags_L
          SG_FillExplorerGadget(SG_Gadget()\SG_GadgetID_L, SG_ListIcon()\Directory_S)
          ;}
          
        Case #SG_GadgetType_ScrollBar
          ChangeCurrentElement(SG_ScrollBar(), SG_Gadget()\AddList_P)
          SG_ScrollBar()\Flags_L = Flags_L
          
        Case #SG_GadgetType_Image
          ChangeCurrentElement(SG_Image(), SG_Gadget()\AddList_P)
          SG_Image()\Flags_L = Flags_L
          
        Case #SG_GadgetType_ButtonImage
          ChangeCurrentElement(SG_ButtonImage(), SG_Gadget()\AddList_P)
          SG_ButtonImage()\Flags_L = Flags_L
          
        Case #SG_GadgetType_Frame3D
          ChangeCurrentElement(SG_Frame3D(), SG_Gadget()\AddList_P)
          SG_Frame3D()\Flags_L = Flags_L
          
      EndSelect
    EndIf
  EndIf
  
EndProcedure
ProcedureDLL.l SG_GetGadgetAttribute(SG_GadgetID_L.l) ; returns the flags of the specified gadget
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Text
          ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P)
          Back_L = SG_Text()\Flags_L
          
        Case #SG_GadgetType_String, #SG_GadgetType_Editor
          ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
          Back_L = SG_String()\Flags_L
          
        Case #SG_GadgetType_Button
          ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
          Back_L = SG_Button()\Flags_L
          
        Case #SG_GadgetType_Checkbox
          ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
          Back_L = SG_CheckBox()\Flags_L
          
        Case #SG_GadgetType_Option
          ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
          Back_L = SG_Option()\Flags_L
          
        Case #SG_GadgetType_Trackbar
          ChangeCurrentElement(SG_TrackBar(), SG_Gadget()\AddList_P)
          Back_L = SG_TrackBar()\Flags_L
          
        Case #SG_GadgetType_Listicon
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          Back_L = SG_ListIcon()\Flags_L
          
        Case #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          Back_L = SG_ListIcon()\ExplorerFlags_L
          
        Case #SG_GadgetType_ScrollBar
          ChangeCurrentElement(SG_ScrollBar(), SG_Gadget()\AddList_P)
          Back_L = SG_ScrollBar()\Flags_L
          
        Case #SG_GadgetType_Image
          ChangeCurrentElement(SG_Image(), SG_Gadget()\AddList_P)
          Back_L = SG_Image()\Flags_L
          
        Case #SG_GadgetType_ButtonImage
          ChangeCurrentElement(SG_ButtonImage(), SG_Gadget()\AddList_P)
          Back_L = SG_ButtonImage()\Flags_L
          
        Case #SG_GadgetType_Frame3D
          ChangeCurrentElement(SG_Frame3D(), SG_Gadget()\AddList_P)
          Back_L = SG_Frame3D()\Flags_L
          
      EndSelect
    EndIf
  EndIf
  ProcedureReturn Back_L
EndProcedure

; items
ProcedureDLL SG_SetGadgetItemAttribute2(SG_GadgetID_L.l, Item_L.l, Attribute_L.l, Value_L.l, Column_L.l)
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select Attribute_L
        Case #PB_ListIcon_ColumnWidth
          Select SG_Gadget()\GadgetType_L
            Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
              If Column_L > -1 And Column_L < 16
                ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
                SG_ListIcon()\HeaderWidth[Column_L] = Value_L
              EndIf
              ;}
              
          EndSelect
          
      EndSelect
      
    EndIf
    
  EndIf
  
  
  
  
EndProcedure
ProcedureDLL SG_SetGadgetItemAttribute(SG_GadgetID_L.l, Item_L.l, Attribute_L.l, Value_L.l)
  SG_SetGadgetItemAttribute2(SG_GadgetID_L, Item_L, Attribute_L, Value_L, -1)
EndProcedure
ProcedureDLL.l SG_GetGadgetItemAttribute2(SG_GadgetID_L.l, Item_L.l, Attribute_L.l, Column_L.l)
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select Attribute_L
        Case #PB_ListIcon_ColumnWidth
          Select SG_Gadget()\GadgetType_L
            Case #SG_GadgetType_Listicon ;{
              If Column_L > -1 And Column_L < 16
                ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
                Back_L = SG_ListIcon()\HeaderWidth[Column_L]
              EndIf
              ;}
              
          EndSelect
          
      EndSelect
      
    EndIf
    
  EndIf
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL.l SG_GetGadgetItemAttribute(SG_GadgetID_L.l, Item_L.l, Attribute_L.l)
  ProcedureReturn SG_GetGadgetItemAttribute2(SG_GadgetID_L, Item_L, Attribute_L, -1)
EndProcedure 



;/ The gadget state
; whole gadget
ProcedureDLL SG_SetGadgetState(SG_GadgetID_L.l, State_L.l) ; change the state of the specified gagdet
  *l.Long
  
  ; This proc set some states of the identified gadget
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Text
          ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P)
          
        Case #SG_GadgetType_String
          ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
          
        Case #SG_GadgetType_Editor
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          For x = 0 To CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
            *l = SG_Editor()\ItemMem_P + x << 2
            ChangeCurrentElement(EditorGdItems(), *l\l)
            EditorGdItems()\ItemState_L = 0
            If State_L = x
              EditorGdItems()\ItemState_L = 1
            EndIf
          Next
          
        Case #SG_GadgetType_Button ; change togglebutton
          ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
          If SG_Button()\Toggle_L
            SG_Button()\Toggle_State_L = State_L
          EndIf
          
        Case #SG_GadgetType_Checkbox
          ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
          SG_CheckBox()\Status_L = State_L
          
        Case #SG_GadgetType_Combobox
          ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
          SG_ComboBox()\Status_L = State_L
          
        Case #SG_GadgetType_Option
          ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
          SG_Option()\Status_L = State_L
          
        Case #SG_GadgetType_Trackbar
          ChangeCurrentElement(SG_TrackBar(), SG_Gadget()\AddList_P)
          SG_TrackBar()\Value_L = State_L
          If SG_TrackBar()\Value_L < SG_TrackBar()\Min_L
            SG_TrackBar()\Value_L = SG_TrackBar()\Min_L
          EndIf
          If SG_TrackBar()\Value_L > SG_TrackBar()\Max_L
            SG_TrackBar()\Value_L = SG_TrackBar()\Max_L
          EndIf
          ; Set the corresponding Position
          If SG_TrackBar()\Flags_L & #PB_TrackBar_Vertical
            SG_TrackBar()\Position_L = (SG_TrackBar()\Value_L * (SG_Gadget()\Height_L - 20)) / (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L) 
          Else
            SG_TrackBar()\Position_L = (SG_TrackBar()\Value_L * (SG_Gadget()\Width_L - 20)) / (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L) 
          EndIf
          
        Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          For x = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
            *l = SG_ListIcon()\ItemMem_P + x << 2
            ChangeCurrentElement(ListIconGdItems(), *l\l)
            ListIconGdItems()\ItemState_L = 0
            If State_L = x
              ListIconGdItems()\ItemState_L = 1
            EndIf
          Next
          
        Case #SG_GadgetType_ScrollBar
          ChangeCurrentElement(SG_ScrollBar(), SG_Gadget()\AddList_P)
          SG_ScrollBar()\Value_L = State_L
          If SG_ScrollBar()\Value_L < SG_ScrollBar()\Min_L
            SG_ScrollBar()\Value_L = SG_ScrollBar()\Min_L
          EndIf
          If SG_ScrollBar()\Value_L > SG_ScrollBar()\Max_L + 1 - SG_ScrollBar()\PageLenght_L
            SG_ScrollBar()\Value_L = SG_ScrollBar()\Max_L + 1 - SG_ScrollBar()\PageLenght_L
          EndIf
          
        Case #SG_GadgetType_Image
          SG_Gadget()\BackGroundDetail_L = State_L
          ; ChangeCurrentElement(SG_Image(), SG_Gadget()\AddList_P)
          ; SG_Image()\ImageID_L = State_L
          
        Case #SG_GadgetType_ButtonImage
          SG_Gadget()\BackGroundDetail_L = State_L
          ; ChangeCurrentElement(SG_ButtonImage(), SG_Gadget()\AddList_P)
          ; SG_ButtonImage()\ImageID_L = State_L
          
      EndSelect
      
    EndIf
  EndIf
  
EndProcedure
ProcedureDLL.l SG_GetGadgetState(SG_GadgetID_L.l) ; returns the state of the specified gagdet
  *l.Long
  
  Back_L.l = -1
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Button
          ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
          If SG_Button()\Toggle_L
            Back_L = SG_Button()\Toggle_State_L
          EndIf
          
        Case #SG_GadgetType_Editor
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          For x = 0 To CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
            *l = SG_Editor()\ItemMem_P + x << 2
            ChangeCurrentElement(EditorGdItems(), *l\l)
            If EditorGdItems()\ItemState_L
              Back_L = x
              Break
            EndIf
          Next
          
        Case #SG_GadgetType_Checkbox
          ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
          Back_L = SG_CheckBox()\Status_L
          
        Case #SG_GadgetType_Combobox
          ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
          Back_L = SG_ComboBox()\Status_L
          
        Case #SG_GadgetType_Option
          ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
          Back_L = SG_Option()\Status_L
          
        Case #SG_GadgetType_Trackbar
          ChangeCurrentElement(SG_TrackBar(), SG_Gadget()\AddList_P)
          Back_L = SG_TrackBar()\Value_L
          
        Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          For x = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
            *l = SG_ListIcon()\ItemMem_P + x << 2
            ChangeCurrentElement(ListIconGdItems(), *l\l)
            If ListIconGdItems()\ItemState_L
              Back_L = x
              Break
            EndIf
          Next
          
        Case #SG_GadgetType_ScrollBar
          ChangeCurrentElement(SG_ScrollBar(), SG_Gadget()\AddList_P)
          Back_L = SG_ScrollBar()\Value_L
          
        Case #SG_GadgetType_Image
          Back_L = SG_Gadget()\BackGround_L
          ; ChangeCurrentElement(SG_Image(), SG_Gadget()\AddList_P)
          ; Back_L = SG_Image()\ImageID_L
          
        Case #SG_GadgetType_ButtonImage
          Back_L = SG_Gadget()\BackGround_L
          ; ChangeCurrentElement(SG_ButtonImage(), SG_Gadget()\AddList_P)
          ; Back_L = SG_ButtonImage()\ImageID_L
          
      EndSelect
    EndIf
  EndIf
  
  ProcedureReturn Back_L
EndProcedure

ProcedureDLL SG_SetGadgetToggleState(SG_GadgetID_L.l, State_L.l) ;set the toggle - state of the button or Imagebutton
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    Select SG_Gadget()\GadgetType_L
      Case #SG_GadgetType_Button
        ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
        If SG_Button()\Toggle_L
          SG_Button()\Toggle_State_L = State_L
        EndIf
        
      Case #SG_GadgetType_ButtonImage
        ChangeCurrentElement(SG_ButtonImage(), SG_Gadget()\AddList_P)
        If SG_ButtonImage()\Toggle_L
          SG_ButtonImage()\Toggle_State_L = State_L
        EndIf
    EndSelect
  EndIf
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL.l SG_GetGadgetToggleState(SG_GadgetID_L.l) ; returns the toggle - state of the button or Imagebutton
  Back_L.l = -1
  
  If GadgetNumber(SG_GadgetID_L)
    
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    Select SG_Gadget()\GadgetType_L
      Case #SG_GadgetType_Button
        ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
        If SG_Button()\Toggle_L
          Back_L = SG_Button()\Toggle_State_L
        EndIf
        
      Case #SG_GadgetType_ButtonImage
        ChangeCurrentElement(SG_ButtonImage(), SG_Gadget()\AddList_P)
        If SG_ButtonImage()\Toggle_L
          Back_L = SG_ButtonImage()\Toggle_State_L
        EndIf
    EndSelect
  EndIf
  ProcedureReturn Back_L
EndProcedure

; items
ProcedureDLL SG_SetGadgetItemState(SG_GadgetID_L.l, Position_L.l, State_L.l) ; change the state of an item of the specified gagdet
  *l.Long
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        *l = SG_ListIcon()\ItemMem_P + Position_L << 2
        ChangeCurrentElement(ListIconGdItems(), *l\l)
        ListIconGdItems()\ItemState_L = State_L
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Editor
        ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
        *l = SG_Editor()\ItemMem_P + Position_L << 2
        ChangeCurrentElement(EditorGdItems(), *l\l)
        EditorGdItems()\ItemState_L = State_L
      EndIf 
    EndIf
  EndIf
EndProcedure
ProcedureDLL.l SG_GetGadgetItemState(SG_GadgetID_L.l, Position_L.l) ; returns the item state of the specified gagdet
  *l.Long
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon Or SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        *l = SG_ListIcon()\ItemMem_P + Position_L << 2
        ChangeCurrentElement(ListIconGdItems(), *l\l)
        Back_L = ListIconGdItems()\ItemState_L
        
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Editor
        ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
        *l = SG_Editor()\ItemMem_P + Position_L << 2
        ChangeCurrentElement(EditorGdItems(), *l\l)
        Back_L = EditorGdItems()\ItemState_L
        
      EndIf
    EndIf
  EndIf
  ProcedureReturn Back_L
EndProcedure

; header
ProcedureDLL SG_SetHeaderState(SG_GadgetID_L.l, Column_L.l, State_L.l) ; set the state of the header of the colums  1 for down, 0 for up or -1 for none
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          For x = 0 To 15
            SG_ListIcon()\HeaderStatus[Column_L] = -1
          Next
          SG_ListIcon()\HeaderStatus[Column_L] = State_L
          
      EndSelect
    EndIf
  EndIf
  
EndProcedure
ProcedureDLL.l SG_GetHeaderState(SG_GadgetID_L.l, Column_L.l) ; returns the current state of the Listicon header: 1 for down and 0 for up  or -1 for none.
  Back_L.l = -1
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Back_L = SG_ListIcon()\HeaderStatus[Column_L]
    EndIf
  EndIf
  ProcedureReturn Back_L
EndProcedure


;/ Appearance and position of the Gadgets
; Standard values
ProcedureDLL SG_SetColor(Color_L.l) ; set the text color for all gadgets created after that command
  SG_StandardColor_GL = Color_L ; the text color of the gadgets
EndProcedure
ProcedureDLL SG_SetBackground(Mode_L.l) ; set the background type for all gadgets created after that command (0 = none, 1 = color, 2 = image)
  ; this proc changes the actual background of the gadget
  SG_StandardBackground_GL = Mode_L ; how to handle the background: 0 = no Background   1= Color  2 = image
EndProcedure
ProcedureDLL SG_SetBackgroundColor(Color_L.l) ; set the background color for all gadgets created after that command
  ; this proc changes the actual background - color of the Gadget
  SG_StandardBackgroundData_GL = Color_L ; contains the color or the imagenumber for the background
EndProcedure
ProcedureDLL SG_SetBackgroundImage(ImgNr_L.l) ; set the background image for all gadgets created after that command
  ; this proc changes the actual background - image of the Gadget
  SG_StandardBackgroundData_GL = ImgNr_L ; contains the color or the imagenumber for the background
EndProcedure

; Individual settings
ProcedureDLL SG_SetGadgetBackground(SG_GadgetID_L.l, Value_L.l) ; set the background type for the specified gagdet (0 = none, 1 = color, 2 = image)
  ; this proc changes the actual background of the gadget
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      SG_Gadget()\BackGround_L = Value_L; how to handle the background: 0 = no Background   1= Color  2 = image
    EndIf
  EndIf
EndProcedure
ProcedureDLL SG_SetGadgetBackgroundImage(SG_GadgetID_L.l, Value_L.l) ; set the background image for the specified gagdet
  ; this proc changes the actual background - image of the Gadget
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      SG_Gadget()\BackGroundDetail_L = Value_L; contains the color or the imagenumber for the background
    EndIf
  EndIf
EndProcedure
ProcedureDLL SG_SetGadgetColor(SG_GadgetID_L.l, ColorType_L.l, Color_L.l) ; change the color of the specified gagdet
  *l.Long
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select ColorType_L
        Case #PB_Gadget_FrontColor ;{
          Select SG_Gadget()\GadgetType_L
            Case #SG_GadgetType_Editor ;{
              ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
              For x = 0 To CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
                *l = SG_Editor()\ItemMem_P + x << 2
                ChangeCurrentElement(EditorGdItems(), *l\l)
                If Color_L = #PB_Default
                  EditorGdItems()\RowTextColor_L = SG_StandardColor_GL
                Else
                  EditorGdItems()\RowTextColor_L = Color_L
                EndIf
              Next
              ;}
              
            Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
              ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
              For x = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
                *l = SG_ListIcon()\ItemMem_P + x << 2
                ChangeCurrentElement(ListIconGdItems(), *l\l)
                If Color_L = #PB_Default
                  ListIconGdItems()\RowTextColor_L = SG_StandardColor_GL
                Else
                  ListIconGdItems()\RowTextColor_L = Color_L
                EndIf
              Next
              ;}
              
          EndSelect
          
          If Color_L = #PB_Default
            SG_Gadget()\TextColor_L = SG_StandardColor_GL
          Else
            SG_Gadget()\TextColor_L = Color_L
          EndIf
          ;}
          
        Case #PB_Gadget_BackColor
          If Color_L = #PB_Default
            SG_Gadget()\BackGroundDetail_L = SG_StandardBackgroundData_GL
          Else
            SG_Gadget()\BackGroundDetail_L = Color_L
          EndIf
          
        Case #PB_Gadget_GrayTextColor
          If Color_L = #PB_Default
            SG_Gadget()\DisabledColor_L  = SG_StandardDisabled_GL
          Else
            SG_Gadget()\DisabledColor_L = Color_L
          EndIf
          
          
        Case #PB_Gadget_LineColor
          Select SG_Gadget()\GadgetType_L
            Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
              ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
              If Color_L = #PB_Default
                SG_ListIcon()\LineColor_L = SG_StandardLineColor_GL
              Else
                SG_ListIcon()\LineColor_L = Color_L
              EndIf
              ;}
              
          EndSelect
          
        Case #PB_Gadget_TitleFrontColor
          Select SG_Gadget()\GadgetType_L
            Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
              ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
              If Color_L = #PB_Default
                SG_ListIcon()\HeaderTextColor_L = SG_StandardHeaderTextColor_GL
              Else
                SG_ListIcon()\HeaderTextColor_L = Color_L
              EndIf
              
          EndSelect
          ;}
          
        Case #PB_Gadget_TitleBackColor
          Select SG_Gadget()\GadgetType_L
            Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
              ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
              If Color_L = #PB_Default
                SG_ListIcon()\HeaderBackColor_L = SG_StandardHeaderBackColor_GL
              Else
                SG_ListIcon()\HeaderBackColor_L = Color_L
              EndIf
              
          EndSelect
          ;}
          
      EndSelect
      
    EndIf
  EndIf
EndProcedure
ProcedureDLL.l SG_GetGadgetColor(SG_GadgetID_L.l, ColorType_L.l) ; change the color of the specified gagdet
  *l.Long
  Back_L.l = -1
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select ColorType_L
        Case #PB_Gadget_FrontColor ;{
          Back_L = SG_Gadget()\TextColor_L
          ;}
          
        Case #PB_Gadget_BackColor
          Back_L = SG_Gadget()\BackGroundDetail_L
          
        Case #PB_Gadget_GrayTextColor
          Back_L = SG_Gadget()\DisabledColor_L
          
        Case #PB_Gadget_LineColor
          Select SG_Gadget()\GadgetType_L
            Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
              ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
              Back_L = SG_ListIcon()\LineColor_L = SG_StandardLineColor_GL
              ;}
              
          EndSelect
          
        Case #PB_Gadget_TitleFrontColor
          Select SG_Gadget()\GadgetType_L
            Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
              ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
              Back_L = SG_ListIcon()\HeaderTextColor_L
              
          EndSelect
          ;}
          
        Case #PB_Gadget_TitleBackColor
          Select SG_Gadget()\GadgetType_L
            Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
              ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
              Back_L = SG_ListIcon()\HeaderBackColor_L
              
          EndSelect
          ;}
          
      EndSelect
      
    EndIf
  EndIf
  
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL SG_SetGadgetFont(SG_GadgetID_L.l, FontNr_L.l) ; change the text font of the specified gagdet
  *l.Long
  
  If SG_GadgetID_L > -1
    If GadgetNumber(SG_GadgetID_L)
      ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
      If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
        Select SG_Gadget()\GadgetType_L
          Case #SG_GadgetType_Text
            ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P)
            SG_Text()\TextFont_L = FontNr_L
            
          Case #SG_GadgetType_String
            ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
            SG_String()\TextFont_L = FontNr_L
            
          Case #SG_GadgetType_Editor
            ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
            SG_Editor()\TextFont_L = FontNr_L
            For x = 0 To CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
              *l = SG_Editor()\ItemMem_P + x << 2
              ChangeCurrentElement(EditorGdItems(), *l\l)
              EditorGdItems()\ItemFont_L = FontNr_L
            Next
            
          Case #SG_GadgetType_Button
            ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
            SG_Button()\TextFont_L = FontNr_L
            
          Case #SG_GadgetType_Checkbox
            ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
            SG_CheckBox()\TextFont_L = FontNr_L
            
          Case #SG_GadgetType_Option
            ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
            SG_Option()\TextFont_L = FontNr_L
            
          Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
            ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
            SG_ListIcon()\TextFont_L = FontNr_L
            For x = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
              *l = SG_ListIcon()\ItemMem_P + x << 2
              ChangeCurrentElement(ListIconGdItems(), *l\l)
              ListIconGdItems()\ItemFont_L = FontNr_L
              ListIconGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L)
            Next
            
          Case #SG_GadgetType_Combobox
            ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
            SG_ComboBox()\TextFont_L = FontNr_L
            For x = 0 To CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
              *l = SG_ComboBox()\ItemMem_P + x << 2
              ChangeCurrentElement(ComboBoxGdItems(), *l\l)
              ComboBoxGdItems()\ItemFont_L = FontNr_L
              ComboBoxGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L)
            Next
            
        EndSelect
        
      EndIf
    EndIf
    
  Else
    SG_FontStandard_GL = FontNr_L
  EndIf
EndProcedure
ProcedureDLL.l SG_GetGadgetFont(SG_GadgetID_L.l) ; returns the font used by the specified gagdet
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Text
          ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P)
          Back_L = SG_Text()\TextFont_L
          
        Case #SG_GadgetType_String
          ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
          Back_L = SG_String()\TextFont_L
          
        Case #SG_GadgetType_Editor
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          Back_L = SG_Editor()\TextFont_L
          
        Case #SG_GadgetType_Button
          ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
          Back_L = SG_Button()\TextFont_L
          
        Case #SG_GadgetType_Checkbox
          ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
          Back_L = SG_CheckBox()\TextFont_L
          
        Case #SG_GadgetType_Option
          ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
          Back_L = SG_Option()\TextFont_L
          
        Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          Back_L = SG_ListIcon()\TextFont_L
      EndSelect
    EndIf
  EndIf
  ProcedureReturn Back_L
EndProcedure

; Item Settings
ProcedureDLL SG_SetGadgetItemColor(SG_GadgetID_L.l, Row_L.l, ColorType_L.l, Color_L.l) ; Set the color of the specified Row of the Gadget
  *l.Long
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          If Row_L > -1 And Row_L < CountGadgetItemMem(SG_ListIcon()\ItemMem_P)
            *l = SG_ListIcon()\ItemMem_P + Row_L << 2
            ChangeCurrentElement(ListIconGdItems(), *l\l)
            Select ColorType_L
              Case #PB_Gadget_FrontColor
                ListIconGdItems()\RowTextColor_L = Color_L
              Case #PB_Gadget_BackColor
                ListIconGdItems()\RowColor_L = Color_L
            EndSelect
          EndIf
          If Row_L = -1
            For x = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
              *l = SG_ListIcon()\ItemMem_P + x << 2
              ChangeCurrentElement(ListIconGdItems(), *l\l)
              Select ColorType_L
                Case #PB_Gadget_FrontColor
                  ListIconGdItems()\RowTextColor_L = Color_L
                Case #PB_Gadget_BackColor
                  ListIconGdItems()\RowColor_L = Color_L
              EndSelect
            Next
          EndIf
          ;}
          
        Case #SG_GadgetType_Editor ;{
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          If Row_L > -1 And Row_L < CountGadgetItemMem(SG_Editor()\ItemMem_P)
            *l = SG_Editor()\ItemMem_P + Row_L << 2
            ChangeCurrentElement(EditorGdItems(), *l\l)
            Select ColorType_L
              Case #PB_Gadget_FrontColor
                EditorGdItems()\RowTextColor_L = Color_L
              Case #PB_Gadget_BackColor
                EditorGdItems()\RowColor_L = Color_L
            EndSelect
          EndIf
          If Row_L = -1
            For x = 0 To CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
              *l = SG_Editor()\ItemMem_P + x << 2
              ChangeCurrentElement(EditorGdItems(), *l\l)
              Select ColorType_L
                Case #PB_Gadget_FrontColor
                  EditorGdItems()\RowTextColor_L = Color_L
                Case #PB_Gadget_BackColor
                  EditorGdItems()\RowColor_L = Color_L
              EndSelect
            Next
          EndIf
          ;}
          
        Case #SG_GadgetType_Combobox ;{
          ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
          If Row_L > -1 And Row_L < CountGadgetItemMem(SG_ComboBox()\ItemMem_P)
            *l = SG_ComboBox()\ItemMem_P + Row_L << 2
            ChangeCurrentElement(ComboBoxGdItems(), *l\l)
            Select ColorType_L
              Case #PB_Gadget_FrontColor
                ComboBoxGdItems()\RowTextColor_L = Color_L
              Case #PB_Gadget_BackColor
                ComboBoxGdItems()\RowColor_L = Color_L
            EndSelect
          EndIf
          If Row_L = -1
            For x = 0 To CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
              *l = SG_Editor()\ItemMem_P + x << 2
              ChangeCurrentElement(ComboBoxGdItems(), *l\l)
              Select ColorType_L
                Case #PB_Gadget_FrontColor
                  ComboBoxGdItems()\RowTextColor_L = Color_L
                Case #PB_Gadget_BackColor
                  ComboBoxGdItems()\RowColor_L = Color_L
              EndSelect
            Next
          EndIf
          ;}
          
      EndSelect
    EndIf
  EndIf
EndProcedure
ProcedureDLL.l SG_GetGadgetItemColor(SG_GadgetID_L.l, Row_L.l, ColorType_L.l) ; returns the color of that item
  *l.Long
  Back_L.l = -1
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Listicon ;{
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          If Row_L > -1 And Row_L < CountGadgetItemMem(SG_ListIcon()\ItemMem_P)
            *l = SG_ListIcon()\ItemMem_P + Row_L << 2
            ChangeCurrentElement(ListIconGdItems(), *l\l)
            Select ColorType_L
              Case #PB_Gadget_FrontColor
                Back_L = ListIconGdItems()\RowTextColor_L
              Case #PB_Gadget_BackColor
                Back_L = ListIconGdItems()\RowColor_L
            EndSelect
          EndIf
          
          ;}
          
        Case #SG_GadgetType_Editor ;{
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          If Row_L > -1 And Row_L < CountGadgetItemMem(SG_Editor()\ItemMem_P)
            *l = SG_Editor()\ItemMem_P + Row_L << 2
            ChangeCurrentElement(EditorGdItems(), *l\l)
            Select ColorType_L
              Case #PB_Gadget_FrontColor
                Back_L = EditorGdItems()\RowTextColor_L
              Case #PB_Gadget_BackColor
                Back_L = EditorGdItems()\RowColor_L
            EndSelect
          EndIf
          ;}
          
        Case #SG_GadgetType_Combobox ;{
          ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
          If Row_L > -1 And Row_L < CountGadgetItemMem(SG_ComboBox()\ItemMem_P)
            *l = SG_ComboBox()\ItemMem_P + Row_L << 2
            ChangeCurrentElement(ComboBoxGdItems(), *l\l)
            Select ColorType_L
              Case #PB_Gadget_FrontColor
                Back_L = ComboBoxGdItems()\RowTextColor_L
              Case #PB_Gadget_BackColor
                Back_L = ComboBoxGdItems()\RowColor_L
            EndSelect
          EndIf
          ;}
          
      EndSelect
    EndIf
  EndIf
  
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL SG_SetGadgetItemFont(SG_GadgetID_L.l, Position_L.l, FontNr_L.l) ; change the font of an item of the specified gagdet - only EditorGadgets
  *l.Long
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If SG_Gadget()\GadgetType_L = #SG_GadgetType_Editor
        ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
        *l = SG_Editor()\ItemMem_P + Position_L << 2
        ChangeCurrentElement(EditorGdItems(), *l\l)
        EditorGdItems()\ItemFont_L = FontNr_L
        EditorGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L) ; Set the Text size
        
        ; ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Listicon
        ; ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        ; *l = SG_ListIcon()\ItemMem_P + Position_L << 2
        ; ChangeCurrentElement(ListIconGdItems(), *l\l)
        ; ListIconGdItems()\ItemFont_L = FontNr_L
        ; ListIconGdItems()\ItemSize_L = SG_ItemTextHeight(SG_Gadget()\GadgetType_L) ; Set the Text size
      EndIf
    EndIf
  EndIf
EndProcedure
ProcedureDLL.l SG_GetGadgetItemFont(SG_GadgetID_L.l) ; returns the font used by the specified gagdet
  *l.Long
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Editor
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          *l = SG_Editor()\ItemMem_P + Position_L << 2
          ChangeCurrentElement(EditorGdItems(), *l\l)
          Back_L = EditorGdItems()\ItemFont_L
          
        Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          *l = SG_ListIcon()\ItemMem_P + Position_L << 2
          ChangeCurrentElement(ListIconGdItems(), *l\l)
          Back_L = ListIconGdItems()\ItemFont_L
          
      EndSelect
    EndIf
  EndIf
  ProcedureReturn Back_L
EndProcedure

; size and position
ProcedureDLL.l SG_GadgetWidth(SG_GadgetID_L.l) ; returns the width of the specified gagdet
  ; this function return the starting coord (x) of the gadget
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Back_L = SG_Gadget()\Width_L
    EndIf
  EndIf
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL.l SG_GadgetHeight(SG_GadgetID_L.l) ; returns the height of the specified gagdet
  ; this function return the starting coord (x) of the gadget
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Back_L = SG_Gadget()\Height_L
    EndIf
  EndIf
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL.l SG_GadgetX(SG_GadgetID_L.l) ; returns the x position of the specified gagdet
  ; this function return the starting coord (x) of the gadget
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Back_L = SG_Gadget()\X_Pos_L
    EndIf
  EndIf
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL.l SG_GadgetY(SG_GadgetID_L.l) ; returns the y position of the specified gagdet
  ; this function return the starting coord (x) of the gadget
  Back_L.l
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Back_L = SG_Gadget()\Y_Pos_L
    EndIf
  EndIf
  ProcedureReturn Back_L
EndProcedure
ProcedureDLL SG_ResizeGadget(SG_GadgetID_L.l, Width_L.l, Height_L.l) ; change the size of the specified gagdet
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      If Width_L <> #PB_Default
        SG_Gadget()\Width_L = Width_L; the widht of the Gadget
      EndIf
      If Height_L <> #PB_Default
        SG_Gadget()\Height_L = Height_L  ; the height of the Gadget
      EndIf
      
      ; change depended values for some of the gadgets
      Select SG_Gadget()\GadgetType_L
        Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          If SG_ListIcon()\ScrollbarVertical_L
            xPos_L = SG_Gadget()\X_Pos_L
            yPos_L = SG_Gadget()\Y_Pos_L
            SG_ResizeGadget(SG_GadgetID_L + 2000, #PB_Default, Height_L)
            If Width_L <> #PB_Default
              SG_Gadget()\X_Pos_L = xPos_L + Width_L
            EndIf
          EndIf
          
        Case #SG_GadgetType_Editor
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          FreeSprite(SG_Editor()\SpriteID_L)
          SG_Editor()\SpriteID_L = CreateSprite(#PB_Any, Width_L+1, Height_L+1)
          If SG_Editor()\ScrollbarVertical_L
            xPos_L = SG_Gadget()\X_Pos_L
            yPos_L = SG_Gadget()\Y_Pos_L
            SG_ResizeGadget(SG_GadgetID_L + 2000, #PB_Default, Height_L)
            If Width_L <> #PB_Default
              SG_Gadget()\X_Pos_L = xPos_L + Width_L
            EndIf
          EndIf
          
        Case #SG_GadgetType_Combobox
          ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
          If SG_ComboBox()\ScrollbarVertical_L
            xPos_L = SG_Gadget()\X_Pos_L
            yPos_L = SG_Gadget()\Y_Pos_L
            SG_ResizeGadget(SG_GadgetID_L + 2000, #PB_Default, Height_L - SG_ComboBox()\TextHeight_L - 5)
            If Width_L <> #PB_Default
              SG_Gadget()\X_Pos_L = xPos_L + Width_L -14
            EndIf
          EndIf
          
        Case #SG_GadgetType_ScrollBar
          ChangeCurrentElement(SG_ScrollBar(), SG_Gadget()\AddList_P)
          ; recalc Slidersize
          If Flags_L & #PB_ScrollBar_Vertical
            ; SG_ScrollBar()\SliderSize_L = (PageLenght_L * (Height_L - 20)) / (EndValue_L - StartValue_L - 2)
            SG_ScrollBar()\SliderSize_L = (SG_ScrollBar()\PageLenght_L * (SG_Gadget()\Height_L - 20)) / (SG_ScrollBar()\Max_L - SG_ScrollBar()\Min_L + 1)
          Else
            ; SG_ScrollBar()\SliderSize_L = (PageLenght_L * (Width_L - 20)) / (EndValue_L - StartValue_L - 2)
            SG_ScrollBar()\SliderSize_L = (SG_ScrollBar()\PageLenght_L * (SG_Gadget()\Width_L - 20)) / (SG_ScrollBar()\Max_L - SG_ScrollBar()\Min_L + 1)
          EndIf
          
      EndSelect
    EndIf
  EndIf
EndProcedure
ProcedureDLL SG_SetGadgetPos(SG_GadgetID_L.l, X_Pos_L.l, Y_Pos_L.l) ; set the position for this gadget
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      SG_Gadget()\X_Pos_L = X_Pos_L
      SG_Gadget()\Y_Pos_L = Y_Pos_L
    EndIf
    
    Select SG_Gadget()\GadgetType_L
      Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
        ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
        If SG_ListIcon()\ScrollbarVertical_L
          xPos_L = SG_Gadget()\X_Pos_L
          yPos_L = SG_Gadget()\Y_Pos_L
          Width_L = SG_Gadget()\Width_L
          ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L + 2000))
          SG_Gadget()\X_Pos_L = xPos_L + Width_L
          SG_Gadget()\Y_Pos_L = yPos_L
        EndIf
        
      Case #SG_GadgetType_Editor
        ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
        If SG_Editor()\ScrollbarVertical_L
          xPos_L = SG_Gadget()\X_Pos_L
          yPos_L = SG_Gadget()\Y_Pos_L
          Width_L = SG_Gadget()\Width_L
          ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L + 2000))
          SG_Gadget()\X_Pos_L = xPos_L + Width_L
          SG_Gadget()\Y_Pos_L = yPos_L
        EndIf
        
      Case #SG_GadgetType_Combobox
        ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
        If SG_ComboBox()\ScrollbarVertical_L
          xPos_L = SG_Gadget()\X_Pos_L
          yPos_L = SG_Gadget()\Y_Pos_L
          Width_L = SG_Gadget()\Width_L
          
          ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L + 2000))
          SG_Gadget()\X_Pos_L = xPos_L + Width_L - 14
          SG_Gadget()\Y_Pos_L = yPos_L + SG_ComboBox()\TextHeight_L + 5
        EndIf
        
    EndSelect
  EndIf
  
EndProcedure

ProcedureDLL SG_ShowListItem(SG_GadgetID_L.l, Position_L.l) ; makes the item at Position_L visible
  *l.Long
  
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    If SG_Gadget()\SG_GadgetID_L = SG_GadgetID_L
      Select SG_Gadget()\GadgetType_L
        
        Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          If SG_ListIcon()\ScrollbarVertical_L ; only useful, if there an some items not visible
            ChangeCurrentElement(SG_ScrollBar(), SG_ListIcon()\ScrollbarVertical_L)
            ; set the new value
            t = SG_ListIcon()\HeaderHeight_L
            Position_L - 2
            If Position_L < 0
              Position_L = 0
            EndIf
            If Position_L > CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
              Position_L = CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
            EndIf 
            For x = 0 To Position_L
              *l = SG_ListIcon()\ItemMem_P + x << 2
              ChangeCurrentElement(ListIconGdItems(), *l\l)
              t + ListIconGdItems()\ItemSize_L
            Next
            SG_ScrollBar()\Value_L = t - SG_ListIcon()\HeaderHeight_L
          EndIf
          
        Case #SG_GadgetType_Editor
          ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
          If SG_Editor()\ScrollbarVertical_L ; only useful, if there an some items not visible
            ChangeCurrentElement(SG_ScrollBar(), SG_Editor()\ScrollbarVertical_L)
            ; set the new value
            t = 0
            Position_L - 2
            If Position_L < 0
              Position_L = 0
            EndIf
            If Position_L > CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
              Position_L = CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
            EndIf 
            For x = 0 To Position_L
              *l = SG_Editor()\ItemMem_P + x << 2
              ChangeCurrentElement(EditorGdItems(), *l\l)
              t + EditorGdItems()\ItemSize_L
            Next
            SG_ScrollBar()\Value_L = t
          EndIf
      EndSelect
    EndIf
  EndIf
EndProcedure


;/ Procedures for ScreenGadgets handling
ProcedureDLL.l SG_ScreenGadgetEvent() ; checks if an event happened and return the EventID
  ; This Proc checks if an event happened
  Back_L.l
  SG_EventType_L = 0 ; reset Eventtype
  SG_MouseButton_GL = 0 ; reset MouseButton
  SG_CurrentGadget_GL = -1 ; reset
  s.s
  c.l
  OK_L.l
  *l.Long
  *Byt.Byte ; for the inkey string
  Static WaitMouseRelease_SL.l ; remember a mouseclick and waits for the release
  Static MouseDrag_SL.l ; remembers a Mouse drag over sliders
  
  ;{ ExamineMouse
  SG_MouseX_GL = MouseX()
  SG_MouseY_GL = MouseY()
  If MouseButton(1)
    SG_MouseButton_GL = 1
  ElseIf MouseButton(2)
    SG_MouseButton_GL = 2
  Else
    If WaitMouseRelease_SL = 1
      SG_EventType_L = #SG_EventType_LeftRelease
    ElseIf WaitMouseRelease_SL = 2
      SG_EventType_L = #SG_EventType_RightRelease
    EndIf
    WaitMouseRelease_SL = 0
    MouseDrag_SL = 0
  EndIf
  
  ; mouseWheel
  SG_MouseWheel_GL = MouseWheel()
  
  ;}
  ;{ keyboard input
  ExamineKeyboard()
  While WindowEvent() : Wend
  
  If CountList(SG_Gadget())
    If SG_FocusGadget_GL > -1 And SG_Gadget()\Disabled_L = 0 ; if a gadget has the focus and is not disabled
      ; tab -> Focus to next gadget
      
      ResetList(SG_Gadget())
      While NextElement(SG_Gadget())
        If SG_Gadget()\SG_GadgetID_L = SG_FocusGadget_GL 
          Select SG_Gadget()\GadgetType_L
            Case #SG_GadgetType_Text
              ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P)
              
            Case #SG_GadgetType_String ;{
              ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
              If SG_String()\Flags_L & #PB_String_ReadOnly = 0
                ; Backspace
                If KeyboardPushed(#PB_Key_Back) 
                  SG_String()\Text_S = Left(SG_String()\Text_S, SG_String()\CursorPos_L-1) + Right(SG_String()\Text_S, Len(SG_String()\Text_S) - SG_String()\CursorPos_L)
                  SG_String()\CursorPos_L - 1
                  If SG_String()\CursorPos_L < 0
                    SG_String()\CursorPos_L = 0
                  EndIf
                  l + 1
                EndIf
                If KeyboardPushed(#PB_Key_Delete)
                  SG_String()\Text_S = Left(SG_String()\Text_S, SG_String()\CursorPos_L) + Right(SG_String()\Text_S, Len(SG_String()\Text_S) - SG_String()\CursorPos_L-1)
                  l + 1
                EndIf
                
                ; Cursor-keys
                If KeyboardPushed(#PB_Key_Right)
                  SG_String()\CursorPos_L + 1
                  If SG_String()\CursorPos_L > Len(SG_String()\Text_S)
                    SG_String()\CursorPos_L = Len(SG_String()\Text_S)
                  EndIf
                  l + 1
                ElseIf KeyboardPushed(#PB_Key_Left)
                  SG_String()\CursorPos_L - 1
                  If SG_String()\CursorPos_L < 0
                    SG_String()\CursorPos_L = 0
                  EndIf
                  l + 1
                ElseIf KeyboardPushed(#PB_Key_Up) Or KeyboardReleased(#PB_Key_Up)
                  l + 1
                ElseIf KeyboardPushed(#PB_Key_Down) Or KeyboardReleased(#PB_Key_Down)
                  l + 1
                ElseIf KeyboardPushed(#PB_Key_Home)
                  SG_String()\CursorPos_L = 0
                  l + 1
                ElseIf KeyboardPushed(#PB_Key_End)
                  SG_String()\CursorPos_L = Len(SG_String()\Text_S)
                  
                ElseIf KeyboardPushed(#PB_Key_Insert)
                  Core_Toggle(@SG_String()\CursorMode_L)
                  l + 1
                EndIf
                
                ; s = KeyboardInkey()
                If l ; if a key is pushed
                  Delay(50)
                Else
                  s = KeyboardInkey()
                  l = Len(s)
                  Count_L = 0
                  If s
                    Debug "input " + s
                  EndIf
                  While Count_L < l ; process the Keyboard input
                    c = -1
                    *Byt = @s + Count_L
                    Debug *Byt\b
                    ; Check the flags for the input
                    If SG_String()\Flags_L & #PB_String_Numeric
                      If *Byt\b >= 48 And *Byt\b <= 57
                        c = *Byt\b
                      EndIf
                    Else
                      ; check the input for valid data
                      
                      c = *Byt\b
                    EndIf
                    
                    If c > -1
                      If SG_String()\CursorMode_L = 0
                        If SG_String()\CursorPos_L = Len(SG_String()\Text_S) ; am Ende
                          SG_String()\Text_S + Chr(c)
                        Else
                          SG_String()\Text_S = Left(SG_String()\Text_S, SG_String()\CursorPos_L) + Chr(c) + Right(SG_String()\Text_S, Len(SG_String()\Text_S) - SG_String()\CursorPos_L)
                        EndIf
                      Else
                        If SG_String()\CursorPos_L = Len(SG_String()\Text_S) ; am Ende
                          SG_String()\Text_S + Chr(c)
                        Else
                          SG_String()\Text_S = Left(SG_String()\Text_S, SG_String()\CursorPos_L) + Chr(c) + Right(SG_String()\Text_S, Len(SG_String()\Text_S) - SG_String()\CursorPos_L-1)
                        EndIf
                      EndIf
                      SG_String()\CursorPos_L + 1
                    EndIf
                    
                    Count_L + 1
                    *Byt + 1
                  Wend
                  
                EndIf
              EndIf
              ;}
              
            Case #SG_GadgetType_Editor ;{
              ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
              If SG_Editor()\Flags_L & #PB_Editor_ReadOnly = 0
                s = KeyboardInkey()
                l = Len(s)
                Count_L = 0
                ; Debug "input " + s
                While Count_L < l ; process the Keyboard input
                  c = -1
                  *Byt = @s + Count_L
                  ; debug *Byt\b
                  ; Check the flags for the input
                  If SG_Editor()\Flags_L & #PB_String_Numeric
                    If *Byt\b >= 48 And *Byt\b <= 57
                      c = *Byt\b
                    EndIf
                  Else
                    c = *Byt\b
                  EndIf
                  
                  If c > -1
                    *l = SG_Editor()\ItemMem_P + SG_Editor()\CursorLine_L << 2
                    ChangeCurrentElement(EditorGdItems(), *l\l)
                    If SG_Editor()\CursorMode_L = 0
                      If SG_Editor()\CursorPos_L = Len(EditorGdItems()\Item_S) ; am Ende
                        EditorGdItems()\Item_S + Chr(c)
                      Else
                        EditorGdItems()\Item_S = Left(EditorGdItems()\Item_S, SG_Editor()\CursorPos_L) + Chr(c) + Right(EditorGdItems()\Item_S, Len(EditorGdItems()\Item_S) - SG_Editor()\CursorPos_L)
                      EndIf
                    Else
                      If SG_Editor()\CursorPos_L = Len(EditorGdItems()\Item_S) ; am Ende
                        EditorGdItems()\Item_S + Chr(c)
                      Else
                        EditorGdItems()\Item_S = Left(EditorGdItems()\Item_S, SG_Editor()\CursorPos_L) + Chr(c) + Right(EditorGdItems()\Item_S, Len(EditorGdItems()\Item_S) - SG_Editor()\CursorPos_L-1)
                      EndIf
                    EndIf
                    SG_Editor()\CursorPos_L + 1
                  EndIf
                  
                  Count_L + 1
                  *Byt + 1
                Wend
                
                If SG_Editor()\ItemMem_P = 0
                  SG_AddGadgetItem(SG_Gadget()\SG_GadgetID_L, -1, "")
                EndIf
                ; set the line of the cursor as current line
                *l = SG_Editor()\ItemMem_P + SG_Editor()\CursorLine_L << 2
                ChangeCurrentElement(EditorGdItems(), *l\l)
                
                ; Cursor-keys
                If KeyboardPushed(#PB_Key_Back) ; Backspace
                  If SG_Editor()\CursorPos_L = 0 And SG_Editor()\CursorLine_L > 0 ; merge the lines
                    s = EditorGdItems()\Item_S 
                    ; delete the line
                    SG_RemoveGadgetItem(SG_Gadget()\SG_GadgetID_L, SG_Editor()\CursorLine_L+1)
                    
                    ; add the line to the line above
                    SG_Editor()\CursorLine_L-1 ; cursor line up
                    *l = SG_Editor()\ItemMem_P + SG_Editor()\CursorLine_L << 2 ; set the line obove
                    ChangeCurrentElement(EditorGdItems(), *l\l)
                    SG_Editor()\CursorPos_L = Len(EditorGdItems()\Item_S) ; set the new cursor position
                    EditorGdItems()\Item_S + s
                  Else
                    EditorGdItems()\Item_S = Left(EditorGdItems()\Item_S, SG_Editor()\CursorPos_L-1) + Right(EditorGdItems()\Item_S, Len(EditorGdItems()\Item_S) - SG_Editor()\CursorPos_L)
                    SG_Editor()\CursorPos_L - 1
                    If SG_Editor()\CursorPos_L < 0
                      SG_Editor()\CursorPos_L = 0
                    EndIf
                  EndIf
                  l + 1
                  
                ElseIf KeyboardPushed(#PB_Key_Delete)
                  If SG_Editor()\CursorPos_L = Len(EditorGdItems()\Item_S) And SG_Editor()\CursorLine_L < CountGadgetItemMem(SG_Editor()\ItemMem_P)-1 ; last position in line and mor elines
                    *l = SG_Editor()\ItemMem_P + (SG_Editor()\CursorLine_L+1) << 2 ; set the line above
                    ChangeCurrentElement(EditorGdItems(), *l\l)
                    s = EditorGdItems()\Item_S ; get the text of the line
                    ; delete the line
                    SG_RemoveGadgetItem(SG_Gadget()\SG_GadgetID_L, SG_Editor()\CursorLine_L+2)
                    
                    ; add the line to the line above
                    *l = SG_Editor()\ItemMem_P + SG_Editor()\CursorLine_L << 2 ; restore the line
                    ChangeCurrentElement(EditorGdItems(), *l\l)
                    EditorGdItems()\Item_S + s
                  Else
                    EditorGdItems()\Item_S = Left(EditorGdItems()\Item_S, SG_Editor()\CursorPos_L) + Right(EditorGdItems()\Item_S, Len(EditorGdItems()\Item_S) - SG_Editor()\CursorPos_L-1)
                  EndIf
                  l + 1
                  KeyboardPushed(#PB_Key_Right)
                  SG_Editor()\CursorPos_L + 1
                  If SG_Editor()\CursorPos_L > Len(EditorGdItems()\Item_S)
                    SG_Editor()\CursorPos_L = Len(EditorGdItems()\Item_S)
                  EndIf
                  l + 1
                  
                ElseIf KeyboardPushed(#PB_Key_Left)
                  SG_Editor()\CursorPos_L - 1
                  If SG_Editor()\CursorPos_L < 0
                    SG_Editor()\CursorPos_L = 0
                  EndIf
                  l + 1
                  
                ElseIf KeyboardPushed(#PB_Key_Up)
                  SG_Editor()\CursorLine_L - 1
                  If SG_Editor()\CursorLine_L < 0
                    SG_Editor()\CursorLine_L = 0
                  EndIf
                  l + 1
                  
                ElseIf KeyboardPushed(#PB_Key_Home)
                  SG_Editor()\CursorPos_L = 0
                  l + 1
                  
                ElseIf KeyboardPushed(#PB_Key_Return)
                  s = Right(EditorGdItems()\Item_S, Len(EditorGdItems()\Item_S) - SG_Editor()\CursorPos_L) ; the new line
                  EditorGdItems()\Item_S = Left(EditorGdItems()\Item_S, SG_Editor()\CursorPos_L) ; cut the line
                  SG_AddGadgetItem(SG_Gadget()\SG_GadgetID_L, SG_Editor()\CursorLine_L+1, s)
                  SG_Editor()\CursorPos_L = 0 ; cursor to the start
                  SG_Editor()\CursorLine_L + 1 ; of the new line
                  l + 1
                  
                ElseIf  KeyboardPushed(#PB_Key_Right)
                  SG_Editor()\CursorPos_L + 1
                  If SG_Editor()\CursorPos_L > Len(EditorGdItems()\Item_S)
                    SG_Editor()\CursorPos_L = Len(EditorGdItems()\Item_S)
                  EndIf
                  l + 1
                  
                ElseIf KeyboardPushed(#PB_Key_End)
                  SG_Editor()\CursorPos_L = Len(EditorGdItems()\Item_S)
                  
                ElseIf KeyboardPushed(#PB_Key_Down)
                  SG_Editor()\CursorLine_L + 1
                  If SG_Editor()\CursorLine_L > CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
                    SG_Editor()\CursorLine_L = CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
                  EndIf
                  l + 1
                  
                ElseIf KeyboardPushed(#PB_Key_Insert)
                  Core_Toggle(@SG_Editor()\CursorMode_L)
                  l + 1
                  
                EndIf
                
                If l ; only if a key is pushed
                  Delay(50)
                EndIf
              EndIf
              
              ;}
              
            Case #SG_GadgetType_Button
              ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
              
            Case #SG_GadgetType_Checkbox
              ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
              
            Case #SG_GadgetType_Option
              ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
              
            Case #SG_GadgetType_Trackbar
              ChangeCurrentElement(SG_TrackBar(), SG_Gadget()\AddList_P)
              
            Case #SG_GadgetType_Listicon
              ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
              ; mit Pfeiltasten ItemFocus verschieben
          EndSelect
        EndIf
      Wend
    EndIf
  EndIf
  ;}
  ;{ the ScreenGadgets
  ResetList(SG_Gadget())
  While NextElement(SG_Gadget())
    OK_L = 0
    ; Debug "query gadget: " + Str(SG_Gadget()\GadgetType_L)
    If SG_Gadget()\Disabled_L = 0 And SG_Gadget()\Hidden_L = 0 ; not if disabled or hidden
      ;{ is mouse over the gadget?
      If SG_Gadget()\GadgetType_L <> #SG_GadgetType_Frame3D And SG_Gadget()\GadgetType_L <> #SG_GadgetType_Combobox
        If SG_MouseX_GL >= SG_Gadget()\X_Pos_L And SG_MouseX_GL <= SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L
          If SG_MouseY_GL >= SG_Gadget()\Y_Pos_L And SG_MouseY_GL <= SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L
            OK_L = 1
          EndIf
        EndIf
      ElseIf SG_Gadget()\GadgetType_L = #SG_GadgetType_Combobox
        ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
        If SG_ComboBox()\Open_L = 1
          If SG_ComboBox()\ScrollbarVertical_L
            t = 14
          Else
            t = 0
          EndIf
          
          If SG_MouseX_GL >= SG_Gadget()\X_Pos_L And SG_MouseX_GL <= SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L - t
            If SG_MouseY_GL >= SG_Gadget()\Y_Pos_L And SG_MouseY_GL <= SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L
              OK_L = 1
            EndIf
          EndIf
        Else ; not open
          If SG_MouseX_GL >= SG_Gadget()\X_Pos_L And SG_MouseX_GL <= SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L
            If SG_MouseY_GL >= SG_Gadget()\Y_Pos_L And SG_MouseY_GL <= SG_Gadget()\Y_Pos_L + SG_ComboBox()\TextHeight_L
              OK_L = 1
            EndIf
          EndIf
        EndIf
      EndIf
      ;}
      If OK_L
        Back_L = #PB_Event_Gadget
        If SG_EventType_L = 0
          SG_EventType_L = #SG_EventType_MouseOverGadget
        EndIf
        SG_CurrentGadget_GL = SG_Gadget()\SG_GadgetID_L
        If SG_MouseButton_GL ; set the focus by click
          SG_FocusGadget_GL = SG_Gadget()\SG_GadgetID_L
          ; Debug "focus on gadget : " + Str(SG_FocusGadget_GL)
        EndIf
        ; actions for special gadgets
        Select SG_Gadget()\GadgetType_L
          Case #SG_GadgetType_Text
            ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P)
            
          Case #SG_GadgetType_String
            ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
            
          Case #SG_GadgetType_Editor
            ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
            
          Case #SG_GadgetType_Button
            If SG_MouseButton_GL = 1 And WaitMouseRelease_SL = 0 ; leftklick
              ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P)
              If SG_Button()\Toggle_L
                Core_Toggle(@SG_Button()\Toggle_State_L)
              EndIf
            EndIf
            
          Case #SG_GadgetType_ButtonImage
            If SG_MouseButton_GL = 1 And WaitMouseRelease_SL = 0 ; leftklick
              ChangeCurrentElement(SG_ButtonImage(), SG_Gadget()\AddList_P)
              If SG_ButtonImage()\Toggle_L
                Core_Toggle(@SG_ButtonImage()\Toggle_State_L)
              EndIf
            EndIf
            
          Case #SG_GadgetType_Checkbox
            ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
            If SG_MouseButton_GL = 1 And WaitMouseRelease_SL = 0 ; leftklick
              Core_Toggle(@SG_CheckBox()\Status_L)
            EndIf
            
          Case #SG_GadgetType_Combobox ;{
            If SG_ComboBox()\Open_L = 1 ; is the gadget "open"?
              If SG_MouseY_GL > SG_Gadget()\Y_Pos_L;  + SG_ComboBox()\TextHeight_L
                If SG_EventType_L = #SG_EventType_LeftRelease ; leftklick ihn Area
                  ; Click on item
                  
                  ; Startvalue
                  If SG_ComboBox()\ScrollbarVertical_L ; is there a scrollbar
                    ChangeCurrentElement(SG_ScrollBar(), SG_ComboBox()\ScrollbarVertical_L)
                    Start_L = SG_ScrollBar()\Value_L
                  Else
                    Start_L = 0
                  EndIf
                  
                  ; find first element to display (depending from Scrollbar-setting)
                  ; t = 0
                  ; For y = 0 To CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
                  ; *l = SG_ComboBox()\ItemMem_P + y << 2
                  ; ChangeCurrentElement(ComboBoxGdItems(), *l\l)
                  ; t + ComboBoxGdItems()\ItemSize_L
                  ; If t >= Start_L
                  ; Break
                  ; EndIf
                  ; Next
                  y = Start_L
                  
                  OffSetY_L = SG_Gadget()\Y_Pos_L + SG_ComboBox()\TextHeight_L + 4
                  For x = y To CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
                    *l = SG_ComboBox()\ItemMem_P + x << 2
                    ChangeCurrentElement(ComboBoxGdItems(), *l\l)
                    If SG_MouseY_GL > OffSetY_L And SG_MouseY_GL <= OffSetY_L + ComboBoxGdItems()\ItemSize_L
                      SG_ComboBox()\Status_L = x
                      Break
                    EndIf
                    OffSetY_L + ComboBoxGdItems()\ItemSize_L
                  Next
                  ; close the gadget
                  If SG_ComboBox()\ScrollbarVertical_L
                    SG_HideGadget(SG_Gadget()\SG_GadgetID_L + 2000, 1)
                  EndIf
                  Core_Toggle(@SG_ComboBox()\Open_L)
                EndIf
              EndIf
            Else ; close
              If SG_EventType_L = #SG_EventType_LeftRelease ; leftklick
                ; open it
                If SG_ComboBox()\ScrollbarVertical_L
                  SG_HideGadget(SG_Gadget()\SG_GadgetID_L + 2000, 0)
                EndIf
                Core_Toggle(@SG_ComboBox()\Open_L)
              EndIf
            EndIf
            ;}
            
          Case #SG_GadgetType_Option ;{
            ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
            If SG_MouseButton_GL = 1 And WaitMouseRelease_SL = 0 ; leftklick
              t = @SG_Option()
              a = SG_Option()\Status_L
              Group_L = SG_Option()\Group_L
              ; reset all other groupgadgets
              ResetList(SG_Option()) ; search for the highest Groupnumber
              While NextElement(SG_Option())
                If SG_Option()\Group_L = Group_L
                  SG_Option()\Status_L = 0
                EndIf
              Wend
              ChangeCurrentElement(SG_Option(), t)
              Core_Toggle(@a)
              SG_Option()\Status_L = a
            EndIf
            ;}
            
          Case #SG_GadgetType_Trackbar ;{
            ChangeCurrentElement(SG_TrackBar(), SG_Gadget()\AddList_P)
            If SG_MouseButton_GL = 1 ; leftklick
              If SG_TrackBar()\Flags_L & #PB_TrackBar_Vertical
                OffSetY_L = ((SG_Gadget()\Height_L-20) * SG_TrackBar()\Value_L) / SG_TrackBar()\Max_L
                If (SG_MouseY_GL >= SG_Gadget()\Y_Pos_L + 5 + OffSetY_L And SG_MouseY_GL <= SG_Gadget()\Y_Pos_L + 15 + OffSetY_L) Or MouseDrag_SL
                  
                  SG_TrackBar()\Position_L = SG_MouseY_GL - SG_Gadget()\Y_Pos_L - 10
                  SG_TrackBar()\Value_L = (SG_TrackBar()\Position_L * (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)) / (SG_Gadget()\Height_L - 20)
                  ;SG_TrackBar()\Value_L = SG_TrackBar()\Min_L + ((SG_MouseX_GL - SG_Gadget()\X_Pos_L - 10) * (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)) / (SG_Gadget()\Width_L - 20)
                  MouseDrag_SL = 1
                  ; Debug "mouse over slider " + Str(SG_TrackBar()\Value_L) + " / " + Str(SG_TrackBar()\Position_L)
                Else
                  ; Debug "mouse over bar "
                  If WaitMouseRelease_SL = 0
                    If SG_MouseY_GL < SG_Gadget()\Y_Pos_L + 5 + OffSetY_L
                      SG_TrackBar()\Value_L = SG_TrackBar()\Value_L - (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)/5
                      ; Debug "sub"
                    Else
                      SG_TrackBar()\Value_L = SG_TrackBar()\Value_L + (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)/5
                      ; Debug "add"
                    EndIf
                    SG_TrackBar()\Position_L = (SG_TrackBar()\Value_L * (SG_Gadget()\Height_L-20)) / (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)
                  EndIf
                EndIf
                ; check the position max
                If SG_TrackBar()\Position_L > SG_Gadget()\Height_L-20
                  SG_TrackBar()\Position_L = SG_Gadget()\Height_L-20
                EndIf
              Else
                OffSetX_L = ((SG_Gadget()\Width_L-20) * SG_TrackBar()\Value_L) / SG_TrackBar()\Max_L
                If (SG_MouseX_GL >= SG_Gadget()\X_Pos_L + 5 + OffSetX_L And SG_MouseX_GL <= SG_Gadget()\X_Pos_L + 15 + OffSetX_L) Or MouseDrag_SL
                  
                  SG_TrackBar()\Position_L = SG_MouseX_GL - SG_Gadget()\X_Pos_L - 10
                  SG_TrackBar()\Value_L = (SG_TrackBar()\Position_L * (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)) / (SG_Gadget()\Width_L - 20)
                  ;SG_TrackBar()\Value_L = SG_TrackBar()\Min_L + ((SG_MouseX_GL - SG_Gadget()\X_Pos_L - 10) * (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)) / (SG_Gadget()\Width_L - 20)
                  MouseDrag_SL = 1
                  ; Debug "mouse over slider " + Str(SG_TrackBar()\Value_L) + " / " + Str(SG_TrackBar()\Position_L)
                Else
                  ; Debug "mouse over bar "
                  If WaitMouseRelease_SL = 0
                    If SG_MouseX_GL < SG_Gadget()\X_Pos_L + 5 + OffSetX_L
                      SG_TrackBar()\Value_L = SG_TrackBar()\Value_L - (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)/5
                    Else
                      SG_TrackBar()\Value_L = SG_TrackBar()\Value_L + (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)/5
                    EndIf
                    SG_TrackBar()\Position_L = (SG_TrackBar()\Value_L * (SG_Gadget()\Width_L-20)) / (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)
                  EndIf
                EndIf
                ; check the position max
                If SG_TrackBar()\Position_L > SG_Gadget()\Width_L-20
                  SG_TrackBar()\Position_L = SG_Gadget()\Width_L-20
                EndIf
              EndIf
              
              ; and check the new values
              If SG_TrackBar()\Value_L < SG_TrackBar()\Min_L
                SG_TrackBar()\Value_L = SG_TrackBar()\Min_L
              EndIf
              If SG_TrackBar()\Value_L > SG_TrackBar()\Max_L
                SG_TrackBar()\Value_L = SG_TrackBar()\Max_L
              EndIf
              ; position min
              If SG_TrackBar()\Position_L < 0
                SG_TrackBar()\Position_L = 0
              EndIf
            EndIf
            ;}
            
          Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
            ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
            If SG_ListIcon()\ShowImages_L
              ImageOffSet_L = 20
            EndIf
            
            If MoveLIcon_Header_GL & %11
              If SG_MouseButton_GL
                ; Debug "move header " + Str(MoveLIcon_Header_GL>>24) + " / " + Str((MoveLIcon_Header_GL>>8)& %111111)
                t = SG_Gadget()\X_Pos_L - ImageOffSet_L
                For x = 0 To MoveLIcon_Header_GL>>24 - 1
                  t + SG_ListIcon()\HeaderWidth[x]
                Next
                SG_ListIcon()\HeaderWidth[MoveLIcon_Header_GL>>24] = SG_MouseX_GL - t - (MoveLIcon_Header_GL>>8)& %111111
                If SG_ListIcon()\HeaderWidth[MoveLIcon_Header_GL>>24] < 5
                  SG_ListIcon()\HeaderWidth[MoveLIcon_Header_GL>>24] = 5
                EndIf
              Else
                MoveLIcon_Header_GL = 0
              EndIf
            Else
              If SG_MouseY_GL <= SG_Gadget()\Y_Pos_L + SG_ListIcon()\HeaderHeight_L  ;{ over header
                t = SG_Gadget()\X_Pos_L + ImageOffSet_L ; which column
                For x = 0 To 15
                  If Abs(SG_MouseX_GL - t) < 5
                    If x > 0
                      ; Debug "over header: " + Str(x-1) + " / " + Str(SG_MouseX_GL-t+SG_ListIcon()\HeaderWidth[x-1]) + " / " + Str(t-SG_Gadget()\X_Pos_L-ImageOffSet_L)
                      If SG_MouseButton_GL = 1
                        MoveLIcon_Header_GL = (x-1)<<24 | ((SG_MouseX_GL-t+SG_ListIcon()\HeaderWidth[x-1]))<<8 | SG_MouseButton_GL
                      Else
                        MoveLIcon_Header_GL = 1<<16 ; just for SG_MoveLiconHeader()
                      EndIf
                      Break
                    EndIf
                  Else
                    MoveLIcon_Header_GL = 0
                  EndIf
                  t + SG_ListIcon()\HeaderWidth[x]
                Next
              Else
                MoveLIcon_Header_GL = 0
              EndIf
              ;}
            EndIf
            
            If SG_EventType_L = #SG_EventType_LeftRelease Or SG_EventType_L = #SG_EventType_RightRelease ; left- or rightklick
              If MoveLIcon_Header_GL = 0
                If SG_ListIcon()\ScrollbarVertical_L
                  ChangeCurrentElement(SG_ScrollBar(), SG_ListIcon()\ScrollbarVertical_L)
                  Start_L = SG_ScrollBar()\Value_L
                Else
                  Start_L = 0
                EndIf
                
                ;{ find first element to display (depending from Scrollbar-setting)
                ; t = 0
                ; For y = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
                ; *l = SG_ListIcon()\ItemMem_P + y << 2
                ; ChangeCurrentElement(ListIconGdItems(), *l\l)
                ; t + ListIconGdItems()\ItemSize_L
                ; If t >= Start_L
                ; Break
                ; EndIf
                ; Next
                y = Start_L
                ;}
                
                ; calc the row-position of the mouse
                If SG_MouseY_GL <= SG_Gadget()\Y_Pos_L + SG_ListIcon()\HeaderHeight_L 
                  ; Debug "click in header"
                  ;{ over header
                  t = SG_Gadget()\X_Pos_L + ImageOffSet_L ; which column
                  For x = 0 To 15
                    t + SG_ListIcon()\HeaderWidth[x]
                    If SG_MouseX_GL < t
                      h = SG_ListIcon()\HeaderStatus[x]
                      For y = 0 To 15
                        SG_ListIcon()\HeaderStatus[y] = -1 ; reset all states
                      Next 
                      Select h
                        Case -1 ; set the new state
                          SG_ListIcon()\HeaderStatus[x] = 1
                        Case 1
                          SG_ListIcon()\HeaderStatus[x] = 0
                        Case 0
                          SG_ListIcon()\HeaderStatus[x] = -1
                      EndSelect
                      
                      If SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
                        If SG_ListIcon()\ExplorerFlags_L & #PB_Explorer_NoSort = 0
                          If SG_ListIcon()\HeaderStatus[x] <> -1 ; is it set in one direction
                            Count_L = 1
                            z = SG_CountGadgetItems(SG_Gadget()\SG_GadgetID_L) ; count Directories in this list
                            For y = 1 To z - 1
                              *l = SG_ListIcon()\ItemMem_P + y << 2
                              ChangeCurrentElement(ListIconGdItems(), *l\l)
                              If ListIconGdItems()\FileData_L = #PB_DirectoryEntry_Directory
                                Count_L + 1
                              EndIf
                            Next
                            
                            If SG_ListIcon()\HeaderType[x] <> 0 ; auto-function column
                              g = #PB_Sort_String
                              If SG_ListIcon()\HeaderType[x] = #SG_Explorer_Size ; select type of Column
                                g = #PB_Sort_Long
                              EndIf
                              If g <> #PB_Sort_Long
                                SG_Sort_ListIconGadget2(SG_Gadget()\SG_GadgetID_L, x+1, g, SG_ListIcon()\HeaderStatus[x], 1, Count_L)
                              EndIf
                              SG_Sort_ListIconGadget2(SG_Gadget()\SG_GadgetID_L, x+1, g, SG_ListIcon()\HeaderStatus[x], Count_L, z)
                            Else
                              SG_Sort_ListIconGadget2(SG_Gadget()\SG_GadgetID_L, x+1, #PB_Sort_String, SG_ListIcon()\HeaderStatus[x], 1, Count_L)
                              SG_Sort_ListIconGadget2(SG_Gadget()\SG_GadgetID_L, x+1, #PB_Sort_String, SG_ListIcon()\HeaderStatus[x], Count_L, z)
                            EndIf
                          EndIf
                        EndIf
                      EndIf
                      Break
                    EndIf
                  Next
                  ;}
                Else
                  ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
                  t = SG_Gadget()\Y_Pos_L + SG_ListIcon()\HeaderHeight_L
                  For x = y To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
                    *l = SG_ListIcon()\ItemMem_P + x << 2
                    ChangeCurrentElement(ListIconGdItems(), *l\l)
                    t + ListIconGdItems()\ItemSize_L
                    If t >= SG_MouseY_GL
                      ; Debug "clicked: " + Str(x) + " With Value " + Str(Value_L)
                      
                      ;{ internal handling of user action for #SG_GadgetType_ExplorerList
                      If SG_Gadget()\GadgetType_L = #SG_GadgetType_ExplorerList
                        If SG_EventType_L = #SG_EventType_LeftRelease
                          If ListIconGdItems()\ItemState_L = 1
                            If SG_ListIcon()\ExplorerFlags_L & #PB_Explorer_NoDirectoryChange = 0 ; if Dirchange is allowed
                              SG_FillExplorerGadget(SG_Gadget()\SG_GadgetID_L, SG_ListIcon()\Directory_S)
                            EndIf
                            z = 0
                          Else
                            z = 1
                          EndIf
                        Else
                          z = 1
                        EndIf
                      Else 
                        z = 1
                      EndIf
                      ;}
                      
                      If (KeyboardPushed(#PB_Key_LeftShift) Or KeyboardPushed(#PB_Key_RightShift)) And SG_ListIcon()\Flags_L & #PB_ListIcon_MultiSelect 
                        If SG_ListIcon()\Last_Selected_L <> - 1
                          If x > SG_ListIcon()\Last_Selected_L
                            For z = SG_ListIcon()\Last_Selected_L To x
                              *l = SG_ListIcon()\ItemMem_P + z << 2
                              ChangeCurrentElement(ListIconGdItems(), *l\l)
                              ListIconGdItems()\ItemState_L = 1
                            Next
                          Else
                            For z = x To SG_ListIcon()\Last_Selected_L
                              *l = SG_ListIcon()\ItemMem_P + z << 2
                              ChangeCurrentElement(ListIconGdItems(), *l\l)
                              ListIconGdItems()\ItemState_L = 1
                            Next
                          EndIf
                          SG_ListIcon()\Last_Selected_L = x
                          z = 0
                        EndIf
                        
                      ElseIf (KeyboardPushed(#PB_Key_LeftControl) Or KeyboardPushed(#PB_Key_RightControl)) And SG_ListIcon()\Flags_L & #PB_ListIcon_MultiSelect
                        Core_Toggle(@ ListIconGdItems()\ItemState_L)
                        SG_ListIcon()\Last_Selected_L = x
                        z = 0
                        
                      EndIf
                      
                      If z
                        SG_SetGadgetState(SG_Gadget()\SG_GadgetID_L, -1) ; set all itemstates to 0
                        ChangeCurrentElement(ListIconGdItems(), *l\l)
                        ListIconGdItems()\ItemState_L = 1
                        SG_ListIcon()\Last_Selected_L = x
                      EndIf
                      Break
                    EndIf
                  Next
                  
                  If SG_MouseY_GL > t ; if klick in List without Item -> reset all states
                    For x = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
                      *l = SG_ListIcon()\ItemMem_P + x << 2
                      ChangeCurrentElement(ListIconGdItems(), *l\l)
                      ListIconGdItems()\ItemState_L = 0
                    Next
                  EndIf
                  
                EndIf
              EndIf
            EndIf
            ;}
            
          Case #SG_GadgetType_ScrollBar ;{
            ChangeCurrentElement(SG_ScrollBar(), SG_Gadget()\AddList_P)
            ; query the arrowbuttons
            If SG_MouseButton_GL = 1
              If SG_ScrollBar()\Flags_L & #PB_ScrollBar_Vertical
                ; debug "sb abfrage"
                ; left arrow
                If MouseDrag_SL = 0 And (SG_MouseY_GL >= SG_Gadget()\Y_Pos_L And SG_MouseY_GL <= SG_Gadget()\Y_Pos_L + 10)
                  SG_ScrollBar()\Value_L - 1
                  ; debug "sb left"
                ElseIf MouseDrag_SL = 0 And (SG_MouseY_GL >= SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L - 10 And SG_MouseY_GL <= SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L)
                  ; right arrow
                  SG_ScrollBar()\Value_L + 1
                  ; debug "sb right"
                ElseIf MouseDrag_SL Or (WaitMouseRelease_SL = 0 And (SG_MouseY_GL >= SG_Gadget()\Y_Pos_L + 10 And SG_MouseY_GL <= SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L - 10))
                  ; Inside the bar
                  
                  t = ((SG_ScrollBar()\Value_L - SG_ScrollBar()\Min_L) * (SG_Gadget()\Height_L-22 - SG_ScrollBar()\SliderSize_L)) / (SG_ScrollBar()\Max_L- SG_ScrollBar()\Min_L)  ; sliderstart
                  ; debug "pos: " + Str(t)
                  
                  If MouseDrag_SL = 0 And (SG_MouseY_GL <= SG_Gadget()\Y_Pos_L + 10 + t) ; vor dem Slider
                    ; debug "vor dem Slider"
                    If WaitMouseRelease_SL = 0
                      SG_ScrollBar()\Value_L -1 ; = SG_ScrollBar()\Min_L + ((t - SG_ScrollBar()\SliderSize_L) * (SG_ScrollBar()\Max_L- SG_ScrollBar()\Min_L))/ (SG_Gadget()\Height_L-22 - SG_ScrollBar()\SliderSize_L)
                    EndIf
                    
                  ElseIf MouseDrag_SL = 0 And (SG_MouseY_GL > SG_Gadget()\Y_Pos_L + 10 + t + SG_ScrollBar()\SliderSize_L) ; vor dem Slider
                    ; Debug "hinter dem Slider"
                    If WaitMouseRelease_SL = 0
                      SG_ScrollBar()\Value_L +1 ; = SG_ScrollBar()\Min_L + ((t + SG_ScrollBar()\SliderSize_L) * (SG_ScrollBar()\Max_L- SG_ScrollBar()\Min_L))/ (SG_Gadget()\Height_L-22 - SG_ScrollBar()\SliderSize_L)
                    EndIf
                    
                  Else
                    If MouseDrag_SL = 0
                      MouseDrag_SL = SG_Gadget()\Y_Pos_L + 10 + t - SG_MouseY_GL
                    EndIf
                    x = SG_MouseY_GL - SG_Gadget()\Y_Pos_L - 11 + MouseDrag_SL
                    SG_ScrollBar()\Value_L = SG_ScrollBar()\Min_L + (x * (SG_ScrollBar()\Max_L- SG_ScrollBar()\Min_L))/ (SG_Gadget()\Height_L-22 - SG_ScrollBar()\SliderSize_L)
                    ; debug "auf dem Slider " + Str(t) + " / " + Str(MouseDrag_SL) + " / " + Str(SG_ScrollBar()\Value_L)
                  EndIf
                  
                EndIf
              Else
                ; left arrow
                If MouseDrag_SL = 0 And (SG_MouseX_GL >= SG_Gadget()\X_Pos_L And SG_MouseX_GL <= SG_Gadget()\X_Pos_L + 10)
                  SG_ScrollBar()\Value_L - 1
                  
                ElseIf MouseDrag_SL = 0 And (SG_MouseX_GL >= SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L - 10 And SG_MouseX_GL <= SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L)
                  ; right arrow
                  SG_ScrollBar()\Value_L + 1
                  
                ElseIf MouseDrag_SL Or (SG_MouseX_GL >= SG_Gadget()\X_Pos_L + 10 And SG_MouseX_GL <= SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L - 10)
                  ; Inside the bar
                  t = ((SG_ScrollBar()\Value_L - SG_ScrollBar()\Min_L) * (SG_Gadget()\Width_L-22 - SG_ScrollBar()\SliderSize_L)) / (SG_ScrollBar()\Max_L- SG_ScrollBar()\Min_L)  ; sliderstart
                  ; debug "pos: " + Str(t)
                  
                  If MouseDrag_SL = 0 And (SG_MouseX_GL <= SG_Gadget()\X_Pos_L + 10 + t) ; vor dem Slider
                    ; debug "vor dem Slider"
                    If WaitMouseRelease_SL = 0
                      SG_ScrollBar()\Value_L - 1 
                    EndIf
                    
                  ElseIf MouseDrag_SL = 0 And (SG_MouseX_GL > SG_Gadget()\X_Pos_L + 10 + t + SG_ScrollBar()\SliderSize_L) ; vor dem Slider
                    ; debug "hinter dem Slider"
                    If WaitMouseRelease_SL = 0
                      SG_ScrollBar()\Value_L +1 
                    EndIf
                    
                  Else
                    If MouseDrag_SL = 0
                      MouseDrag_SL = SG_Gadget()\X_Pos_L + 10 + t - SG_MouseX_GL
                    EndIf
                    x = SG_MouseX_GL - SG_Gadget()\X_Pos_L - 11 + MouseDrag_SL
                    SG_ScrollBar()\Value_L = SG_ScrollBar()\Min_L + (x * (SG_ScrollBar()\Max_L- SG_ScrollBar()\Min_L))/ (SG_Gadget()\Width_L-22 - SG_ScrollBar()\SliderSize_L)
                    ; debug "auf dem Slider " + Str(t) + " / " + Str(MouseDrag_SL) + " / " + Str(SG_ScrollBar()\Value_L)
                  EndIf
                EndIf
              EndIf
              ; check for min and max
              If SG_ScrollBar()\Value_L < SG_ScrollBar()\Min_L
                SG_ScrollBar()\Value_L = SG_ScrollBar()\Min_L
              EndIf
              If SG_ScrollBar()\Value_L > SG_ScrollBar()\Max_L + 1 - SG_ScrollBar()\PageLenght_L
                SG_ScrollBar()\Value_L = SG_ScrollBar()\Max_L + 1 - SG_ScrollBar()\PageLenght_L
              EndIf
            EndIf
            ;}
            
        EndSelect
        
        Break
      EndIf
    EndIf
  Wend
  ;}
  ;{ MouseEvents?
  
  If SG_MouseButton_GL And SG_EventType_L = 0 ; if click outside of gadgets - reset Focus
    SG_FocusGadget_GL = -1
    ; Debug "reset fokus"
  EndIf
  If SG_MouseButton_GL = 1
    SG_EventType_L = #SG_EventType_LeftClick
    WaitMouseRelease_SL = 1
  ElseIf SG_MouseButton_GL = 2
    SG_EventType_L = #SG_EventType_RightClick
    WaitMouseRelease_SL = 2
  ElseIf SG_MouseWheel_GL
    SG_EventType_L = #SG_EventType_Wheel
  EndIf
  ;}
  
  ProcedureReturn Back_L
EndProcedure

ProcedureDLL.l SG_EventScreenGadgetID() ; returns the number of the gadget, where the event happened
  ; this Proc returns the current GadgetID oder -1, if no Gadget has the Focus
  ProcedureReturn SG_CurrentGadget_GL
EndProcedure
ProcedureDLL.l SG_EventType() ; returns the eventID, of the event happened
  ; Just for compatibility reasons - its easier to use the var "SG_EventType_L" directly
  ProcedureReturn SG_EventType_L
EndProcedure


;/ Additional Procs
; ListIcon Sorting
; - the compare-functions
Procedure.l CpmLongUp(*a.Long, *b.Long, Offset_L.l)
  n.l
  v1.l
  v2.l
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  ; search Seperator
  *ab.Byte = *c\l
  t = 0
  n = *ab ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *ab+1 ; set to new position
      EndIf
    EndIf
    *ab + 1
  Until t >= Offset_L
  v1 = Val(PeekS(n, *ab - n - 1))
  
  *bb.Byte = *d\l
  t = 0
  n = *bb ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *bb+1 ; set to new position
      EndIf
    EndIf
    *bb + 1
  Until t >= Offset_L
  v2 = Val(PeekS(n, *bb - n - 1))
  
  If v1 < v2
    Back_L = -1
  ElseIf v1 > v2
    Back_L = 1
  EndIf
  ProcedureReturn Back_L 
EndProcedure
Procedure.l CpmLongDown(*a.Long, *b.Long, Offset_L.l)
  n.l
  v1.l
  v2.l
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  ; search Seperator
  *ab.Byte = *c\l
  t = 0
  n = *ab ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *ab+1 ; set to new position
      EndIf
    EndIf
    *ab + 1
  Until t >= Offset_L
  v1 = Val(PeekS(n, *ab - n - 1))
  
  *bb.Byte = *d\l
  t = 0
  n = *bb ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *bb+1 ; set to new position
      EndIf
    EndIf
    *bb + 1
  Until t >= Offset_L
  v2 = Val(PeekS(n, *bb - n - 1))
  
  If v1 < v2
    Back_L = 1
  ElseIf v1 > v2
    Back_L = -1
  EndIf
  ProcedureReturn Back_L 
EndProcedure
Procedure.l CpmFloatUp(*a.Long, *b.Long, Offset_L.l)
  n.l
  v1.f
  v2.f
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  ; search Seperator
  *ab.Byte = *c\l
  t = 0
  n = *ab ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *ab+1 ; set to new position
      EndIf
    EndIf
    *ab + 1
  Until t >= Offset_L
  v1 = ValF(PeekS(n, *ab - n - 1))
  
  *bb.Byte = *d\l
  t = 0
  n = *bb ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *bb+1 ; set to new position
      EndIf
    EndIf
    *bb + 1
  Until t >= Offset_L
  v2 = ValF(PeekS(n, *bb - n - 1))
  
  If v1 < v2
    Back_L = -1
  ElseIf v1 > v2
    Back_L = 1
  EndIf
  ProcedureReturn Back_L 
EndProcedure
Procedure.l CpmFloatDown(*a.Long, *b.Long, Offset_L.l)
  n.l
  v1.f
  v2.f
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  ; search Seperator
  *ab.Byte = *c\l
  t = 0
  n = *ab ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *ab+1 ; set to new position
      EndIf
    EndIf
    *ab + 1
  Until t >= Offset_L
  v1 = ValF(PeekS(n, *ab - n - 1))
  
  *bb.Byte = *d\l
  t = 0
  n = *bb ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *bb+1 ; set to new position
      EndIf
    EndIf
    *bb + 1
  Until t >= Offset_L
  v2 = ValF(PeekS(n, *bb - n - 1))
  
  If v1 < v2
    Back_L = 1
  ElseIf v1 > v2
    Back_L = -1
  EndIf
  ProcedureReturn Back_L 
EndProcedure
Procedure.l CpmDoubleUp(*a.Long, *b.Long, Offset_L.l)
  n.l
  v1.d
  v2.d
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  ; search Seperator
  *ab.Byte = *c\l
  t = 0
  n = *ab ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *ab+1 ; set to new position
      EndIf
    EndIf
    *ab + 1
  Until t >= Offset_L
  v1 = ValD(PeekS(n, *ab - n - 1))
  
  *bb.Byte = *d\l
  t = 0
  n = *bb ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *bb+1 ; set to new position
      EndIf
    EndIf
    *bb + 1
  Until t >= Offset_L
  v2 = ValD(PeekS(n, *bb - n - 1))
  
  If v1 < v2
    Back_L = -1
  ElseIf v1 > v2
    Back_L = 1
  EndIf
  ProcedureReturn Back_L 
EndProcedure
Procedure.l CpmDoubleDown(*a.Long, *b.Long, Offset_L.l)
  n.l
  v1.d
  v2.d
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  ; search Seperator
  *ab.Byte = *c\l
  t = 0
  n = *ab ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *ab+1 ; set to new position
      EndIf
    EndIf
    *ab + 1
  Until t >= Offset_L
  v1 = ValD(PeekS(n, *ab - n - 1))
  
  *bb.Byte = *d\l
  t = 0
  n = *bb ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *bb+1 ; set to new position
      EndIf
    EndIf
    *bb + 1
  Until t >= Offset_L
  v2 = ValD(PeekS(n, *bb - n - 1))
  
  If v1 < v2
    Back_L = 1
  ElseIf v1 > v2
    Back_L = -1
  EndIf
  ProcedureReturn Back_L 
EndProcedure
Procedure.l CpmQuadUp(*a.Long, *b.Long, Offset_L.l)
  n.l
  v1.q
  v2.d
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  ; search Seperator
  *ab.Byte = *c\l
  t = 0
  n = *ab ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *ab+1 ; set to new position
      EndIf
    EndIf
    *ab + 1
  Until t >= Offset_L
  v1 = ValQ(PeekS(n, *ab - n - 1))
  
  *bb.Byte = *d\l
  t = 0
  n = *bb ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *bb+1 ; set to new position
      EndIf
    EndIf
    *bb + 1
  Until t >= Offset_L
  v2 = ValQ(PeekS(n, *bb - n - 1))
  
  If v1 < v2
    Back_L = -1
  ElseIf v1 > v2
    Back_L = 1
  EndIf
  ProcedureReturn Back_L 
EndProcedure
Procedure.l CpmQuadDown(*a.Long, *b.Long, Offset_L.l)
  n.l
  v1.q
  v2.q
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  ; search Seperator
  *ab.Byte = *c\l
  t = 0
  n = *ab ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *ab+1 ; set to new position
      EndIf
    EndIf
    *ab + 1
  Until t >= Offset_L
  v1 = ValQ(PeekS(n, *ab - n - 1))
  
  *bb.Byte = *d\l
  t = 0
  n = *bb ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *bb+1 ; set to new position
      EndIf
    EndIf
    *bb + 1
  Until t >= Offset_L
  v2 = ValQ(PeekS(n, *bb - n - 1))
  
  If v1 < v2
    Back_L = 1
  ElseIf v1 > v2
    Back_L = -1
  EndIf
  ProcedureReturn Back_L 
EndProcedure
Procedure.l CpmCharUp(*a.Long, *b.Long, Offset_L.l)
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  *ab.Byte = *c\l
  t = 0
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
    EndIf
    *ab + 1
  Until t >= Offset_L
  *ab - 2
  
  *bb.Byte = *d\l
  t = 0
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
    EndIf
    *bb + 1
  Until t >= Offset_L
  *bb - 2
  
  Repeat
    If *ab\b < *bb\b
      Back_L = -1
      Break
    ElseIf *ab\b > *bb\b
      Back_L = 1
      Break
    EndIf
    *ab + 1
    *bb + 1
  Until *ab\b = 0 Or *bb\b = 0 Or *ab\b = 10 Or *bb\b = 10
  ProcedureReturn Back_L
EndProcedure
Procedure.l CpmCharDown(*a.Long, *b.Long, Offset_L.l)
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  *ab.Byte = *c\l
  t = 0
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
    EndIf
    *ab + 1
  Until t >= Offset_L
  *ab - 2
  
  *bb.Byte = *d\l
  t = 0
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
    EndIf
    *bb + 1
  Until t >= Offset_L
  *bb - 2
  
  Repeat
    If *ab\b < *bb\b
      Back_L = 1
      Break
    ElseIf *ab\b > *bb\b
      Back_L = -1
      Break
    EndIf
    *ab + 1
    *bb + 1
  Until *ab\b = 0 Or *bb\b = 0 Or *ab\b = 10 Or *bb\b = 10
  ProcedureReturn Back_L
EndProcedure
Procedure.l CpmStringUp(*a.Long, *b.Long, Offset_L.l)
  n.l
  
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  ; search Seperator
  *ab.Byte = *c\l
  t = 0
  n = *ab ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *ab+1 ; set to new position
      EndIf
    EndIf
    *ab + 1
  Until t >= Offset_L
  *ab = n ; hier dann den merker setzen
  
  *bb.Byte = *d\l
  t = 0
  n = *bb ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *bb+1 ; set to new position
      EndIf
    EndIf
    *bb + 1
  Until t >= Offset_L
  *bb  = n
  
  Repeat
    If *ab\b < *bb\b
      Back_L = -1
      Break
    ElseIf *ab\b > *bb\b
      Back_L = 1
      Break
    EndIf
    *ab + 1
    *bb + 1
  Until *ab\b = 0 Or *bb\b = 0 Or *ab\b = 10 Or *bb\b = 10
  ProcedureReturn Back_L 
EndProcedure
Procedure.l CpmStringDown(*a.Long, *b.Long, Offset_L.l)
  n.l
  
  *c.Long = *a\l ; adress of the string
  *d.Long = *b\l
  
  ; search Seperator
  *ab.Byte = *c\l
  t = 0
  n = *ab ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *ab\b = 10 Or *ab\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *ab+1 ; set to new position
      EndIf
    EndIf
    *ab + 1
  Until t >= Offset_L
  *ab = n ; hier dann den merker setzen
  
  *bb.Byte = *d\l
  t = 0
  n = *bb ; merker setzen, um beginn letzen Strings merken
  Repeat
    If *bb\b = 10 Or *bb\b = 0
      t + 1
      If t < Offset_L ; not the right column
        n = *bb+1 ; set to new position
      EndIf
    EndIf
    *bb + 1
  Until t >= Offset_L
  *bb  = n
  
  Repeat
    If *ab\b < *bb\b
      Back_L = 1
      Break
    ElseIf *ab\b > *bb\b
      Back_L = -1
      Break
    EndIf
    *ab + 1
    *bb + 1
  Until *ab\b = 0 Or *bb\b = 0 Or *ab\b = 10 Or *bb\b = 10
  ProcedureReturn Back_L 
EndProcedure

Procedure quicksort(g.l, d.l, Offset_L.l, compare_function)
  v.l
  If g < d
    i = g-1
    j = d
    
    Repeat
      Repeat
        i=i+1
      Until CallFunctionFast(compare_function, SG_ListIcon()\ItemMem_P + i << 2, SG_ListIcon()\ItemMem_P + d << 2, Offset_L) >= 0 ; a(i) >= a(d)
      
      ok = 0
      Repeat
        If j>0
          j=j-1
        Else
          ok=1
        EndIf
        
        If CallFunctionFast(compare_function, SG_ListIcon()\ItemMem_P + j << 2, SG_ListIcon()\ItemMem_P + d << 2, Offset_L) <= 0 ; a(j) <= a(d)
          ok=1
        EndIf
      Until ok<>0
      
      ; Swap a(i), a(j)
      *l.Long = SG_ListIcon()\ItemMem_P + i << 2
      v = *l\l
      CopyMemory(SG_ListIcon()\ItemMem_P + j << 2, *l, 4)
      *l = SG_ListIcon()\ItemMem_P + j << 2
      *l\l= v
      
    Until j <= i
    
    
    ; CopyMemory(@a(j), @dummy, 4)
    ; CopyMemory(@a(i), @a(j), 4)
    ; CopyMemory(@a(d), @a(i), 4)
    ; CopyMemory(@dummy, @a(d), 4)
    
    
    *l.Long = SG_ListIcon()\ItemMem_P + j << 2
    v = *l\l
    CopyMemory(SG_ListIcon()\ItemMem_P + i << 2, *l, 4)
    *l = SG_ListIcon()\ItemMem_P + i << 2
    CopyMemory(SG_ListIcon()\ItemMem_P + d << 2, *l, 4)
    *l = SG_ListIcon()\ItemMem_P + d << 2
    *l\l= v
    
    
    ; v = a(j)
    ; a(j) = a(i)
    ; a(i) = a(d)
    ; a(d) = v
    
    quicksort(g, i-1, Offset_L, compare_function)
    quicksort(i+1, d, Offset_L, compare_function)
  EndIf
  
EndProcedure

ProcedureDLL SG_Sort_ListIconGadget2(SG_GadgetID_L.l, Column_L.l, Typ_L.l, Options_L.l, Start_L.l, Stop_L.l)
  Items_L.l
  CompareFnkt_P.l
  MaxColumns_L.l
  
  ; Options
  ; 0: Sortiert die Liste in aufsteigender Richtung (kleine Zahlen zuerst) 
  ; 1: Sortiert die Liste in absteigender Richtung (groe Zahlen zuerst) 
  
  ; Typ
  ; #PB_Sort_Byte     : Das Strukturfeld, nach dem sortiert werden soll, ist vom Typ Byte (.b)
  ; #PB_Sort_Word     : Das Strukturfeld, nach dem sortiert werden soll, ist vom Typ Word (.w)
  ; #PB_Sort_Long     : Das Strukturfeld, nach dem sortiert werden soll, ist vom Typ Long (.l)
  ; #PB_Sort_String   : Das Strukturfeld, nach dem sortiert werden soll, ist vom Typ String (.s oder $)
  ; #PB_Sort_Float    : Das Strukturfeld, nach dem sortiert werden soll, ist vom Typ Float (.f)
  ; #PB_Sort_Double   : Das Strukturfeld, nach dem sortiert werden soll, ist vom Typ Double (.d)
  ; #PB_Sort_Quad     : Das Strukturfeld, nach dem sortiert werden soll, ist vom Typ Quad (.q)
  ; #PB_Sort_Character: Das Strukturfeld, nach dem sortiert werden soll, ist vom Typ Character (.c)
  
  ; Set the Licon-Gadget
  If GadgetNumber(SG_GadgetID_L)
    ChangeCurrentElement(SG_Gadget(), GadgetNumber(SG_GadgetID_L))
    ; how many items
    Items_L = CountGadgetItemMem(SG_ListIcon()\ItemMem_P)
    
    ;{ Check for Limits
    If Start_L < 0
      Start_L = 0
    ElseIf Start_L > Items_L
      Start_L = Items_L
    EndIf
    If Stop_L < 0
      Stop_L = Items_L
    ElseIf Stop_L > Items_L
      Stop_L = Items_L
    EndIf
    For z = 0 To 15
      If SG_ListIcon()\HeaderWidth[z] > 0
        MaxColumns_L + 1
      Else
        Break
      EndIf
    Next
    If Column_L < 1
      Column_L = 1
    ElseIf Column_L > MaxColumns_L
      Column_L = MaxColumns_L
    EndIf
    
    ;}
    
    ;{ set the proper Compare-function
    Select Options_L
      Case 0 ; ascending
        Select Typ_L
          Case #PB_Sort_Byte
            CompareFnkt_P = @CpmLongUp()
          Case #PB_Sort_Word
            CompareFnkt_P = @CpmLongUp()
          Case #PB_Sort_Long
            CompareFnkt_P = @CpmLongUp()
          Case #PB_Sort_String
            CompareFnkt_P = @CpmStringUp()
          Case #PB_Sort_Float
            CompareFnkt_P = @CpmFloatUp()
          Case #PB_Sort_Double
            CompareFnkt_P = @CpmDoubleUp()
          Case #PB_Sort_Quad
            CompareFnkt_P = @CpmQuadUp()
          Case #PB_Sort_Character
            CompareFnkt_P = @CpmCharUp()
        EndSelect
      Case 1 ; descanding
        Select Typ_L
          Case #PB_Sort_Byte
            CompareFnkt_P = @CpmLongDown()
          Case #PB_Sort_Word
            CompareFnkt_P = @CpmLongDown()
          Case #PB_Sort_Long
            CompareFnkt_P = @CpmLongDown()
          Case #PB_Sort_String
            CompareFnkt_P = @CpmStringDown()
          Case #PB_Sort_Float
            CompareFnkt_P = @CpmFloatDown()
          Case #PB_Sort_Double
            CompareFnkt_P = @CpmDoubleDown()
          Case #PB_Sort_Quad
            CompareFnkt_P = @CpmQuadDown()
          Case #PB_Sort_Character
            CompareFnkt_P = @CpmCharDown()
        EndSelect
        
    EndSelect
    ;}
    
    ; run the sort
    quicksort(Start_L, Stop_L-1, Column_L, CompareFnkt_P) ; Column start with 0
    
  EndIf
  
EndProcedure
ProcedureDLL SG_Sort_ListIconGadget(SG_GadgetID_L.l, Column_L.l, Typ_L.l, Options_L.l)
  SG_Sort_ListIconGadget2(SG_GadgetID_L, Column_L, Typ_L, Options_L, -1, -1)
EndProcedure
  
ProcedureDLL.l SG_MoveLiconHeader() ; returns 1, if the Mouse of over a Licon header gap
  Back_L.l
  If MoveLIcon_Header_GL <> 0
    Back_L = 1
  EndIf
  ProcedureReturn Back_L
EndProcedure
  

; ExplorerGadget
Procedure SG_FillExplorerGadget(SG_GadgetID_L.l, Directory_S.s) ; fills the ExplorerListgadget items
  Path_S.s
  s.s
  
  NewList Strng.s()
  
  ;{ get path and pattern 
  Path_S = GetPathPart(StringField(Directory_S, 1, ";"))
  
  s = GetFilePart(StringField(Directory_S, 1, ";"))
  If s
    AddElement(Strng())
    Strng() = GetExtensionPart(s)
  EndIf
  
  ; are there other patterns 
  n = CountString(Directory_S, ";")+1
  For x = 2 To n
    s = StringField(Directory_S, x, ";")
    AddElement(Strng())
    Strng() = LCase(GetExtensionPart(s))
  Next
  
  If Path_S = ""
    Path_S = "C:\"; cos driver listing is not natively possible
  EndIf
  
  ;}
  
  ;{ process user action -> set path and pattern
  If SG_ListIcon()\ExplorerFlags_L & #PB_Explorer_NoDirectoryChange = 0
    If SG_CountGadgetItems(SG_GadgetID_L) > 0
      If ListIconGdItems()\ItemState_L ; if the current element is selected
        s = StringField(ListIconGdItems()\Item_S, 1, Chr(10))
        If s = ".." ; one level up
          Path_S = GetPathPart(Left(Path_S, Len(Path_S)-1)) ; cut the last "\"
          
        Else
          If ListIconGdItems()\FileData_L = #PB_DirectoryEntry_Directory ; if a dir is selected
            Path_S = GetPathPart(Path_S) + s + "\"
            
          EndIf
        EndIf
      EndIf
    EndIf
  EndIf
  
  If CountList(Strng()) = 0
    AddElement(Strng())
    Strng() = "*"
  EndIf
  
  ; create the new path and pattern string
  s = ""
  ResetList(Strng())
  
  While NextElement(Strng())
    If ListIndex(Strng()) = 0 ; only with the first pattern
      SG_ListIcon()\Directory_S = Path_S + "*." + Strng()
    Else
      s = s + ";*." + Strng()
    EndIf
  Wend
  SG_ListIcon()\Directory_S + s
  ;}
  
  SG_ClearGadgetItemList(SG_GadgetID_L)
  
  
  
  If Path_S = "" ;{ If no drive is given 
    ; show the drives
    
    ; #PB_Explorer_NoDriveRequester    : Es wird kein 'Legen Sie bitte einen Datentrger in Laufwerk X: ein' angezeigt.
    
    ;}
  Else ;{ only, if at least a drive is given
    For y = 0 To 1
      If y = 0
        z = 305
      Else 
        z = 13
      EndIf
      t = ExamineDirectory(#PB_Any, Path_S, "*.*")
      If t
        While NextDirectoryEntry(t)
          ; first all directories, then all files
          If (y = 0 And DirectoryEntryType(t) = #PB_DirectoryEntry_Directory) Or (y = 1 And DirectoryEntryType(t) = #PB_DirectoryEntry_File)
            n = 1 ;{ decide, what to display
            ; CallDebugger
            ; user setting
            If DirectoryEntryName(t) = "." ; do not show this item
              n = 0
            EndIf
            If DirectoryEntryName(t) = ".." And SG_ListIcon()\ExplorerFlags_L & #PB_Explorer_NoParentFolder
              n = 0
            EndIf
            If DirectoryEntryType(t) = #PB_DirectoryEntry_File And SG_ListIcon()\ExplorerFlags_L & #PB_Explorer_NoFiles
              n = 0
            EndIf
            If DirectoryEntryType(t) = #PB_DirectoryEntry_Directory And SG_ListIcon()\ExplorerFlags_L & #PB_Explorer_NoFolders
              n = 0
            EndIf
            
            ; pattern
            If DirectoryEntryType(t) = #PB_DirectoryEntry_File And n 
              s = LCase(GetExtensionPart(DirectoryEntryName(t)))
              n = 0
              ForEach Strng()
                If Strng() = s Or Strng() = "*" ; one of the given extensions?
                  n = 1
                  Break
                EndIf
              Next
            EndIf
            ;}
            
            If n
              ;{ create the entry depending on the auto-function columns
              s = ""
              For x = 0 To 15
                If SG_ListIcon()\HeaderWidth[x] > 0 ; if this Column is active
                  If SG_ListIcon()\HeaderType[x] > 0 ; if this column is an autofunction column
                    Select SG_ListIcon()\HeaderType[x]
                      Case #SG_Explorer_Name       ; displays the name of the file/directory
                        s = s + DirectoryEntryName(t) + Chr(10)
                        
                      Case #SG_Explorer_Size       ; displays the filesize
                        s = s + Str(DirectoryEntrySize(t) / 1024) + " kB" + Chr(10)
                        
                      Case #SG_Explorer_Type       ; displays a string describing the filetype
                        If DirectoryEntryType(t) = #PB_DirectoryEntry_File
                          s = s + GetExtensionPart(DirectoryEntryName(t)) + Chr(10)
                        Else
                          s = s + "DIR" + Chr(10)
                        EndIf
                        
                      Case #SG_Explorer_Attributes ; displays the Attributes of the file/directory
                        If DirectoryEntryAttributes(t)& #PB_FileSystem_ReadOnly
                          s + "R"
                        EndIf
                        If DirectoryEntryAttributes(t)& #PB_FileSystem_Hidden
                          s + "H"
                        EndIf
                        If DirectoryEntryAttributes(t)& #PB_FileSystem_System
                          s + "S"
                        EndIf
                        If DirectoryEntryAttributes(t)& #PB_FileSystem_Archive
                          s + "A"
                        EndIf
                        If DirectoryEntryAttributes(t)& #PB_FileSystem_Compressed
                          s + "C"
                        EndIf
                        If DirectoryEntryAttributes(t)& #PB_FileSystem_Normal
                          s + "N"
                        EndIf
                        s + Chr(10)
                        
                      Case #SG_Explorer_Created    ; displays the time the file/directory was created
                        s = s + FormatDate("%yyyy.%mm.%dd %hh:%ii", DirectoryEntryDate(t, #PB_Date_Created))  + Chr(10)
                        
                      Case #SG_Explorer_Modified   ; displays the time the file/directory was last modified
                        s = s + FormatDate("%yyyy.%mm.%dd %hh:%ii", DirectoryEntryDate(t, #PB_Date_Modified)) + Chr(10)
                        
                      Case #SG_Explorer_Accessed
                        s = s + FormatDate("%yyyy.%mm.%dd %hh:%ii", DirectoryEntryDate(t, #PB_Date_Accessed)) + Chr(10)
                        
                      Default
                        s + Chr(10)
                    EndSelect
                  EndIf
                EndIf
              Next
              
              ;}
              
              SG_AddGadgetItem(SG_GadgetID_L, -1, s); , z)
              LastElement(ListIconGdItems())
              ListIconGdItems()\FileData_L = DirectoryEntryType(t)
            EndIf
          EndIf
        Wend
        
        FinishDirectory(t)
        
        If SG_ListIcon()\ExplorerFlags_L & #PB_Explorer_AutoSort
          ; gadget header durchsuchen, welcher gesetzt ist
          ; wenn dieser dann auto-function hat...
          
          
          If y = 0 ; only the dirs
            h = SG_CountGadgetItems(SG_GadgetID_L)
            SG_Sort_ListIconGadget2(SG_GadgetID_L, 0, #PB_Sort_String, 0, 1, h)
          Else
            SG_Sort_ListIconGadget2(SG_GadgetID_L, 0, #PB_Sort_String, 0, h, SG_CountGadgetItems(SG_GadgetID_L))
          EndIf
        EndIf
      EndIf
    Next
    ;}
  EndIf
  
EndProcedure


;/ Draw the gadgets
Procedure DrawBox(x.l, y.l, w.l, h.l, Mode_L.l)
  ; draws a colored box for the gadgets
  ; modes: 0 single lined, light dark
  ; modes: 1 single lined, dark light
  ; modes: 2 single line, black (flat)
  ; modes: 3 double lined, dark light (deeper)
  ; modes: 4 double lined, light dark (deeper)
  ; modes: 5 double lined, dark light (like standard frame)
  If Mode_L = 0
    Line(x, y, w, 0, $FFFFFF)
    Line(x, y, 0, h, $FFFFFF)
    Line(x+w, y, 0, h, $808080)
    Line(x, y+h, w+1, 0, $808080)
  ElseIf Mode_L = 1
    Line(x, y, w, 0, $808080)
    Line(x, y, 0, h, $808080)
    Line(x+w, y, 0, h, $FFFFFF)
    Line(x, y+h, w+1, 0, $FFFFFF)
  ElseIf Mode_L = 2
    DrawingMode(4)
    Box(x, y, w, h, $000000)
    DrawingMode(1)
  ElseIf Mode_L = 3
    Line(x, y, w, 0, $909FA4)
    Line(x, y, 0, h, $909FA4)
    Line(x+w, y, 0, h+1, $FFFFFF)
    Line(x, y+h, w, 0, $FFFFFF)
    
    Line(x+1, y+1, w-1, 0, $626466)
    Line(x+1, y+1, 0, h-1, $626466)
    Line(x+w-1, y+1, 0, h-2, $E5EDEF)
    Line(x+2, y+h-1, w-2, 0, $E5EDEF)
  ElseIf Mode_L = 4
    Line(x, y, w, 0, $FFFFFF)
    Line(x, y, 0, h, $FFFFFF)
    Line(x+w, y, 0, h+1, $E5EDEF)
    Line(x, y+h, w, 0, $E5EDEF)
    
    Line(x+1, y+1, w-1, 0, $626466)
    Line(x+1, y+1, 0, h-1, $626466)
    Line(x+w-1, y+1, 0, h-2, $909FA4)
    Line(x+2, y+h-1, w-2, 0, $909FA4)
  ElseIf Mode_L = 5
    DrawingMode(4)
    Box(x+1, y+1, w, h, $FFFFFF)
    Box(x, y, w, h, $909FA4)
    DrawingMode(1)
  EndIf
  
EndProcedure
Procedure DrawBoxX(x.l, y.l, w.l, h.l, Mode_L.l)
  ; draws a colored box for the gadgets
  ; modes: 0 single lined, light dark
  ; modes: 1 single lined, dark light
  ; modes: 2 single line, black (flat)
  ; modes: 3 double lined, dark light (deeper)
  ; modes: 4 double lined, light dark (deeper)
  ; modes: 5 double lined, dark light (like standard frame)
  If Mode_L = 0
    Line(x, y, w-10, 0, $FFFFFF)
    Line(x, y, 0, h-10, $FFFFFF)
    Line(x, y+h-10, 10, 10, $FFFFFF)
    Line(x+w, y+10, 0, h-10, $808080)
    Line(x+10, y+h, w-9, 0, $808080)
    Line(x + w - 10, y, 10, 10, $808080)
  ElseIf Mode_L = 1
    Line(x, y, w-10, 0, $808080)
    Line(x, y, 0, h-10, $808080)
    Line(x, y+h-10, 10, 10, $808080)
    Line(x+w, y+10, 0, h-10, $FFFFFF)
    Line(x+10, y+h, w-9, 0, $FFFFFF)
    Line(x + w - 10, y, 10, 10, $FFFFFF)
  ElseIf Mode_L = 2
    Line(x, y, w-10, 0, $FFFFFF)
    Line(x, y, 0, h-10, $FFFFFF)
    Line(x, y+h-10, 10, 10, $FFFFFF)
    Line(x+w, y+10, 0, h-10, $FFFFFF)
    Line(x+10, y+h, w-9, 0, $FFFFFF)
    Line(x + w - 10, y, 10, 10, $FFFFFF)
  ElseIf Mode_L = 3
    Line(x, y, w-10, 0, $909FA4)
    Line(x, y, 0, h-10, $909FA4)
    Line(x, y+h-10, 10, 10, $909FA4)
    Line(x+w, y+10, 0, h-10, $FFFFFF)
    Line(x+10, y+h, w-9, 0, $FFFFFF)
    Line(x + w - 10, y, 10, 10, $FFFFFF)
    
    Line(x+1, y+1, w-11, 0, $626466)
    Line(x+1, y+1, 0, h-9, $626466)
    Line(x+1, y+h-10, 9, 9, $626466)
    Line(x+w-1, y+10, 0, h-10, $E5EDEF)
    Line(x+10, y+h-1, w-10, 0, $E5EDEF)
    Line(x + w - 10, y+1, 9, 9, $E5EDEF)
  ElseIf Mode_L = 4
    Line(x, y, w-10, 0, $E5EDEF)
    Line(x, y, 0, h-10, $E5EDEF)
    Line(x, y+h-10, 10, 10, $E5EDEF)
    Line(x+w, y+10, 0, h-10, $626466)
    Line(x+10, y+h, w-9, 0, $626466)
    Line(x + w - 10, y, 10, 10, $626466)
    
    Line(x+1, y+1, w-11, 0, $FFFFFF)
    Line(x+1, y+1, 0, h-9, $FFFFFF)
    Line(x+1, y+h-10, 9, 9, $FFFFFF)
    Line(x+w-1, y+10, 0, h-10, $909FA4)
    Line(x+10, y+h-1, w-10, 0, $909FA4)
    Line(x + w - 10, y+1, 9, 9, $909FA4)
  ElseIf Mode_L = 5
    Line(x+1, y+1, w-10, 0, $FFFFFF)
    Line(x+1, y+1, 0, h-10, $FFFFFF)
    Line(x+1, y+h-9, 10, 10, $FFFFFF)
    Line(x+w+1, y+11, 0, h-10, $FFFFFF)
    Line(x+11, y+h, w-9, 0, $FFFFFF)
    Line(x + w - 9, y+1, 10, 10, $FFFFFF)
    
    Line(x, y, w-10, 0, $909FA4)
    Line(x, y, 0, h-10, $909FA4)
    Line(x, y+h-9, 10, 10, $909FA4)
    Line(x+w, y+11, 0, h-11, $909FA4)
    Line(x+10, y+h-1, w-9, 0, $909FA4)
    Line(x + w - 10, y+1, 10, 10, $909FA4)
  EndIf
  
EndProcedure
Procedure DrawBox3D(x.l, y.l, w.l, h.l, Mode_L.l, TextLenght_L.l)
  ; draws a colored box for the Frame 3D - gadget
  ; modes: 0 single lined, light dark
  ; modes: 1 single lined, dark light
  ; modes: 2 single line, black (flat)
  ; modes: 3 double lined, dark light (deeper)
  ; modes: 4 double lined, light dark (deeper)
  ; modes: 5 double lined, dark light (like standard frame)
  Rest_L.l ; calc the rest of the header line
  If TextLenght_L > 0
    Rest_L = w - 20 - TextLenght_L
    If Rest_L < 0
      Rest_L = 0
    EndIf
  EndIf
  If Mode_L = 0
    Line(x, y, 5, 0, $FFFFFF)
    Line(x+ TextLenght_L + 10, y, Rest_L, 0, $FFFFFF)
    Line(x, y, 0, h-9, $FFFFFF)
    Line(x, y+h-10, 10, 10, $FFFFFF)
    Line(x+w, y+10, 0, h-10, $808080)
    Line(x+10, y+h, w-9, 0, $808080)
    Line(x + w - 10, y, 10, 10, $808080)
  ElseIf Mode_L = 1
    Line(x, y, 5, 0, $808080)
    Line(x+ TextLenght_L + 10, y, Rest_L, 0, $808080)
    Line(x, y, 0, h-9, $808080)
    Line(x, y+h-10, 10, 10, $808080)
    Line(x+w, y+10, 0, h-10, $FFFFFF)
    Line(x+10, y+h, w-9, 0, $FFFFFF)
    Line(x + w - 10, y, 10, 10, $FFFFFF)
  ElseIf Mode_L = 2
    Line(x, y, 5, 0, $FFFFFF)
    Line(x+ TextLenght_L + 10, y, Rest_L, 0, $FFFFFF)
    Line(x, y, 0, h-9, $FFFFFF)
    Line(x, y+h-10, 10, 10, $FFFFFF)
    Line(x+w, y+10, 0, h-10, $FFFFFF)
    Line(x+10, y+h, w-9, 0, $FFFFFF)
    Line(x + w - 10, y, 10, 10, $FFFFFF)
  ElseIf Mode_L = 3
    Line(x, y, 5, 0, $909FA4)
    Line(x+ TextLenght_L + 10, y, Rest_L, 0, $909FA4)
    Line(x, y, 0, h-9, $909FA4)
    Line(x, y+h-10, 10, 10, $909FA4)
    Line(x+w, y+10, 0, h-10, $FFFFFF)
    Line(x+10, y+h, w-9, 0, $FFFFFF)
    Line(x + w - 10, y, 10, 10, $FFFFFF)
    
    Line(x+1, y+1, 5, 0, $626466)
    Line(x+ TextLenght_L + 11, y+1, Rest_L-1, 0, $626466)
    Line(x+1, y+1, 0, h-9, $626466)
    Line(x+1, y+h-10, 9, 9, $626466)
    Line(x+w-1, y+10, 0, h-10, $E5EDEF)
    Line(x+10, y+h-1, w-10, 0, $E5EDEF)
    Line(x + w - 10, y+1, 9, 9, $E5EDEF)
  ElseIf Mode_L = 4
    Line(x, y, 5, 0, $E5EDEF)
    Line(x+ TextLenght_L + 10, y, Rest_L, 0, $E5EDEF)
    Line(x, y, 0, h-9, $E5EDEF)
    Line(x, y+h-10, 10, 10, $E5EDEF)
    Line(x+w, y+10, 0, h-10, $626466)
    Line(x+10, y+h, w-9, 0, $626466)
    Line(x + w - 10, y, 10, 10, $626466)
    
    Line(x+1, y+1, 5, 0, $FFFFFF)
    Line(x+ TextLenght_L + 11, y+1, Rest_L-1, 0, $FFFFFF)
    Line(x+1, y+1, 0, h-9, $FFFFFF)
    Line(x+1, y+h-10, 9, 9, $FFFFFF)
    Line(x+w-1, y+10, 0, h-10, $909FA4)
    Line(x+10, y+h-1, w-10, 0, $909FA4)
    Line(x + w - 10, y+1, 9, 9, $909FA4)
  ElseIf Mode_L = 5
    Line(x+1, y+1, 5, 0, $FFFFFF)
    Line(x+ TextLenght_L + 11, y+1, Rest_L-1, 0, $FFFFFF)
    Line(x+1, y+1, 0, h-9, $FFFFFF)
    Line(x+1, y+h-9, 10, 10, $FFFFFF)
    Line(x+w+1, y+11, 0, h-10, $FFFFFF)
    Line(x+11, y+h, w-9, 0, $FFFFFF)
    Line(x + w - 9, y+1, 10, 10, $FFFFFF)
    
    Line(x, y, 5, 0, $909FA4)
    Line(x+ TextLenght_L + 10, y, Rest_L, 0, $909FA4)
    Line(x, y, 0, h-9, $909FA4)
    Line(x, y+h-9, 10, 10, $909FA4)
    Line(x+w, y+11, 0, h-11, $909FA4)
    Line(x+10, y+h-1, w-9, 0, $909FA4)
    Line(x + w - 10, y+1, 10, 10, $909FA4)
  EndIf
  
EndProcedure
;{ - die Standardversion fr SG-Lib
; Procedure DrawBox3D(x.l, y.l, w.l, h.l, Mode_L.l, TextLenght_L.l)
  ; ; draws a colored box for the Frame 3D - gadget
  ; ; modes: 0 single lined, light dark
  ; ; modes: 1 single lined, dark light
  ; ; modes: 2 single line, black (flat)
  ; ; modes: 3 double lined, dark light (deeper)
  ; ; modes: 4 double lined, light dark (deeper)
  ; ; modes: 5 double lined, dark light (like standard frame)
  ; Rest_L.l ; calc the rest of the header line
  ; If TextLenght_L > 0
    ; Rest_L = w - 9 - TextLenght_L
    ; If Rest_L < 5
      ; Rest_L = 5
    ; EndIf
  ; EndIf
  ; If Mode_L = 0
    ; Line(x, y, 5, 0, $FFFFFF)
    ; Line(x+w-Rest_L, y, Rest_L, 0, $FFFFFF)
    ; Line(x, y, 0, h, $FFFFFF)
    ; Line(x+w, y, 0, h, $808080)
    ; Line(x, y+h, w+1, 0, $808080)
  ; ElseIf Mode_L = 1
    ; Line(x, y, 5, 0, $808080)
    ; Line(x+w-Rest_L, y, Rest_L, 0, $808080)
    ; Line(x, y, 0, h, $808080)
    ; Line(x+w, y, 0, h, $FFFFFF)
    ; Line(x, y+h, w+1, 0, $FFFFFF)
  ; ElseIf Mode_L = 2
    ; Line(x, y, 5, 0, $000000)
    ; Line(x+w-Rest_L, y, Rest_L, 0, $000000)
    ; Line(x, y, 0, h, $000000)
    ; Line(x+w, y, 0, h, $000000)
    ; Line(x, y+h, w+1, 0, $000000)
  ; ElseIf Mode_L = 3
    ; Line(x, y, 5, 0, $909FA4)
    ; Line(x+w-Rest_L, y, Rest_L, 0, $909FA4)
    ; Line(x, y, 0, h, $909FA4)
    ; Line(x+w, y, 0, h+1, $FFFFFF)
    ; Line(x, y+h, w, 0, $FFFFFF)
    ; 
    ; Line(x+1, y+1, 4, 0, $626466)
    ; Line(x+w-Rest_L+1, y+1, Rest_L-1, 0, $626466)
    ; Line(x+1, y+1, 0, h-1, $626466)
    ; Line(x+w-1, y+1, 0, h-2, $E5EDEF)
    ; Line(x+2, y+h-1, w-2, 0, $E5EDEF)
  ; ElseIf Mode_L = 4
    ; Line(x, y, 5, 0, $FFFFFF)
    ; Line(x+w-Rest_L, y, Rest_L, 0, $FFFFFF)
    ; Line(x, y, 0, h, $FFFFFF)
    ; Line(x+w, y, 0, h+1, $E5EDEF)
    ; Line(x, y+h, w, 0, $E5EDEF)
    ; 
    ; Line(x+1, y+1, 4, 0, $626466)
    ; Line(x+w-Rest_L+1, y+1, Rest_L-1, 0, $626466)
    ; Line(x+1, y+1, 0, h-1, $626466)
    ; Line(x+w-1, y+1, 0, h-2, $909FA4)
    ; Line(x+2, y+h-1, w-2, 0, $909FA4)
  ; ElseIf Mode_L = 5
    ; Line(x+1, y+1, 5, 0, $FFFFFF)
    ; Line(x+w-Rest_L+1, y+1, Rest_L, 0, $FFFFFF)
    ; Line(x+1, y+1, 0, h, $FFFFFF)
    ; Line(x+w+1, y+1, 0, h, $FFFFFF)
    ; Line(x+1, y+h+1, w+1, 0, $FFFFFF)
    ; 
    ; Line(x, y, 5, 0, $909FA4)
    ; Line(x+w-Rest_L, y, Rest_L, 0, $909FA4)
    ; Line(x, y, 0, h, $909FA4)
    ; Line(x+w, y, 0, h, $909FA4)
    ; Line(x, y+h, w+1, 0, $909FA4)
  ; EndIf
  ; 
; EndProcedure
;}
Procedure Draw_Triangle(x1.l, y1.l, x2.l, y2.l, x3.l, y3.l, Color_L.l)
  ; draws a triangle to the currently open drawing device
  LineXY(x1, y1, x2, y2, Color_L)
  LineXY(x2, y2, x3, y3, Color_L)
  LineXY(x3, y3, x1, y1, Color_L)
EndProcedure


Procedure SG_DrawGadgetsReal() ; draws the current Gadget to the screen
  ; this Proc draws the current gadgets to the actual screen
  OffSetX_L.l
  OffSetY_L.l
  Start_L.l
  Page_L.l
  s.s
  s1.s
  *l.Long
  
  ; If StartDrawing(ScreenOutput())
  ; ResetList(SG_Gadget())
  ; While NextElement(SG_Gadget())
  ; ; draw all gadgets, or only some ; but then draw dependent scrollbars with them
  ; If StartGadget_L = -1 Or (SG_Gadget()\SG_GadgetID_L >= StartGadget_L And SG_Gadget()\SG_GadgetID_L <= EndGadget_L ) Or (SG_Gadget()\SG_GadgetID_L-2000 >= StartGadget_L And SG_Gadget()\SG_GadgetID_L-2000 <= EndGadget_L )
  ; If SG_Gadget()\Hidden_L = 0 ; not hidden
  OffSetX_L = 0
  OffSetY_L = 0
  
  ;{ draw the background
  If SG_Gadget()\BackGround_L = 1 ; Color
    If SG_Gadget()\Disabled_L
      Box(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, #Col_Disabled)
    Else
      If SG_Gadget()\GadgetType_L <> #SG_GadgetType_Combobox
        Box(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, SG_Gadget()\BackGroundDetail_L)
      Else
        ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
        If SG_ComboBox()\Open_L = 0
          Box(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_ComboBox()\TextHeight_L+5, SG_Gadget()\BackGroundDetail_L)
        Else
          Box(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, SG_Gadget()\BackGroundDetail_L)
        EndIf
      EndIf
    EndIf
  ElseIf SG_Gadget()\BackGround_L = 2 ;  image
    If SG_Gadget()\GadgetType_L = #SG_GadgetType_Combobox
      ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
      If SG_ComboBox()\Open_L = 0
        DrawImage(SG_Gadget()\BackGroundDetail_L, SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_ComboBox()\TextHeight_L+5)
      Else
        DrawImage(SG_Gadget()\BackGroundDetail_L, SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L)
      EndIf
    ElseIf SG_Gadget()\GadgetType_L <> #SG_GadgetType_ButtonImage ; draw them seperatly - if not an exeption
      DrawImage(SG_Gadget()\BackGroundDetail_L, SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L)
    EndIf
  EndIf
  ;}
  
  Select SG_Gadget()\GadgetType_L
    Case #SG_GadgetType_Text ;{
      ChangeCurrentElement(SG_Text(), SG_Gadget()\AddList_P) ; set corr-list
      DrawingMode(1)
      ; Set the Text font
      If SG_Text()\TextFont_L And SG_Text()\TextFont_L <> #PB_Default
        DrawingFont(FontID(SG_Text()\TextFont_L))
      EndIf
      ; resolve the Flags
      If SG_Text()\Flags_L & #PB_Text_Center
        OffSetX_L = (SG_Gadget()\Width_L - TextWidth(SG_Text()\Text_S))>>1
        OffSetY_L = (SG_Gadget()\Height_L - TextHeight(SG_Text()\Text_S)) >> 1
      ElseIf SG_Text()\Flags_L & #PB_Text_Right
        OffSetX_L = (SG_Gadget()\Width_L - TextWidth(SG_Text()\Text_S)-5)
      EndIf
      If SG_Text()\Flags_L & #PB_Text_Border
        DrawBoxX(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 1)
      EndIf
      
      ; Set the Textcolor
      If SG_Gadget()\Disabled_L
        FrontColor(SG_Gadget()\DisabledColor_L)
      Else
        FrontColor(SG_Gadget()\TextColor_L)
      EndIf
      
      DrawText(SG_Gadget()\X_Pos_L + 5 + OffSetX_L, SG_Gadget()\Y_Pos_L + OffSetY_L + 2, SG_Text()\Text_S)
      ;}
      
    Case #SG_GadgetType_String ;{
      ChangeCurrentElement(SG_String(), SG_Gadget()\AddList_P)
      DrawingMode(#PB_2DDrawing_Transparent)
      ; Set the Text font
      If SG_String()\TextFont_L And SG_String()\TextFont_L <> #PB_Default
        DrawingFont(FontID(SG_String()\TextFont_L))
      EndIf
      ; Set the Textcolor
      If SG_Gadget()\Disabled_L
        FrontColor(SG_Gadget()\DisabledColor_L)
      Else
        FrontColor(SG_Gadget()\TextColor_L)
      EndIf
      ; Focus and Readonly
      If SG_Gadget()\BackGround_L = 1
        If (SG_String()\Flags_L & #PB_String_ReadOnly = 0 And SG_Gadget()\SG_GadgetID_L = SG_FocusGadget_GL)
          Box(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, $FFFFFF)
        EndIf
      EndIf
      ; resolve the Flags for Borderappearance
      If SG_String()\Flags_L & #PB_String_BorderLess = 0
        DrawBoxX(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 1)
      EndIf
      
      ; resolve the Flags for the text
      If SG_String()\Flags_L & #PB_Text_Center
        OffSetX_L = (SG_Gadget()\Width_L - TextWidth(SG_String()\Text_S))>>1
        OffSetY_L = (SG_Gadget()\Height_L - TextHeight(SG_String()\Text_S)) >> 1
      ElseIf SG_String()\Flags_L & #PB_Text_Right
        OffSetX_L = (SG_Gadget()\Width_L - TextWidth(SG_Text()\Text_S)- 5)
      EndIf
      
      If SG_String()\Flags_L & #PB_String_Password
        s = Space(Len(SG_String()\Text_S))
        For x = 0 To Len(SG_String()\Text_S)-1
          PokeB(@s+x, 42)
        Next
        DrawText(SG_Gadget()\X_Pos_L + 5 + OffSetX_L, SG_Gadget()\Y_Pos_L + OffSetY_L + 2,s)
        
      ElseIf SG_String()\Flags_L & #PB_String_LowerCase ; All characters are converted To lower Case automatically.
        DrawText(SG_Gadget()\X_Pos_L + 5 + OffSetX_L, SG_Gadget()\Y_Pos_L + OffSetY_L + 2,LCase(SG_String()\Text_S))
        
      ElseIf SG_String()\Flags_L & #PB_String_UpperCase ; All characters are converted To upper Case automatically.
        DrawText(SG_Gadget()\X_Pos_L + 5 + OffSetX_L, SG_Gadget()\Y_Pos_L + OffSetY_L + 2,UCase(SG_String()\Text_S))
        
      Else
        DrawText(SG_Gadget()\X_Pos_L + 5 + OffSetX_L, SG_Gadget()\Y_Pos_L + OffSetY_L + 2,SG_String()\Text_S)
      EndIf
      
      ; draw the cursor
      If SG_Gadget()\SG_GadgetID_L = SG_FocusGadget_GL And SG_String()\Flags_L & #PB_String_ReadOnly = 0 ; has this agdget the focus
        If SG_String()\CursorMode_L = 0 ; insert
          Line(SG_Gadget()\X_Pos_L + 5 + OffSetX_L + TextWidth(Left(SG_String()\Text_S, SG_String()\CursorPos_L)), SG_Gadget()\Y_Pos_L + OffSetY_L - 2, 0, TextHeight(SG_String()\Text_S) + 4, #Col_Cursor)
        Else ; overwrite
          Line(SG_Gadget()\X_Pos_L + 5 + OffSetX_L + TextWidth(Left(SG_String()\Text_S, SG_String()\CursorPos_L)), SG_Gadget()\Y_Pos_L + OffSetY_L + TextHeight(SG_String()\Text_S) + 2, 10, 0, #Col_Cursor)
        EndIf
      EndIf
      ;}
      
    Case #SG_GadgetType_Editor ;{
      ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
      StopDrawing()
      
      If StartDrawing(SpriteOutput(SG_Editor()\SpriteID_L))
        Box(0, 0, SG_Gadget()\Width_L, SG_Gadget()\Height_L, $000000)
        DrawingMode(#PB_2DDrawing_Transparent)
        
        ; resolve the Flags for Borderappearance
        If SG_Editor()\Flags_L & #PB_String_BorderLess = 0
          DrawBoxX(0, 0, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 1)
        EndIf
        
        ;{ calc the size of the text
        t = 0
        For x = 0 To CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
          *l = SG_Editor()\ItemMem_P + x << 2
          ChangeCurrentElement(EditorGdItems(), *l\l)
          t + EditorGdItems()\ItemSize_L
        Next
        SG_Editor()\PageLenghtVertical_L = t
        
        ;}
        
        ;{ maybe create scrollbar
        If SG_Editor()\PageLenghtVertical_L > SG_Gadget()\Height_L - 2
          ; Debug "make scrollbar"
          If SG_Editor()\ScrollbarVertical_L = 0
            p = @SG_Gadget()
            ; SG_ListIcon()\ScrollbarVertical_L = SG_ScrollBarGadget2(SG_Gadget()\SG_GadgetID_L + 2000, SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L, SG_Gadget()\Y_Pos_L, 14, SG_Gadget()\Height_L, 0, t - (SG_Gadget()\Height_L - 3 - OffSetHeader_L) / OffSetY_L, t, #PB_ScrollBar_Vertical)
            
            a = SG_ScrollBarGadget2(SG_Gadget()\SG_GadgetID_L + 2000, SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L, SG_Gadget()\Y_Pos_L, 14, SG_Gadget()\Height_L, 0, t, SG_Gadget()\Height_L, #PB_ScrollBar_Vertical)
            SG_Editor()\ScrollbarVertical_L = PeekL(a + 12) ; get the pointer to the Scrollbarstructure
            ChangeCurrentElement(SG_Gadget(), p)
          EndIf ; has the pagelength changed?
          If SG_Editor()\ScrollbarVertical_L ; only useful, if there an some items not visible
            ChangeCurrentElement(SG_ScrollBar(), SG_Editor()\ScrollbarVertical_L)
            If SG_ScrollBar()\PageLenght_L <> SG_Gadget()\Height_L - 2 Or SG_ScrollBar()\Max_L <> SG_Editor()\PageLenghtVertical_L
              SG_ScrollBar()\PageLenght_L = SG_Gadget()\Height_L - 2
              Debug "pagelngth changed " + Str(SG_ScrollBar()\PageLenght_L)
              
              ; set and check the scrollbar slider size
              ChangeCurrentElement(SG_Gadget(), SG_ScrollBar()\GadgetID_P) ; set the gadget of the scrollbar
              SG_ScrollBar()\Min_L = 0
              SG_ScrollBar()\Max_L = SG_Editor()\PageLenghtVertical_L
              SG_ScrollBar()\SliderSize_L = (SG_ScrollBar()\PageLenght_L * (SG_Gadget()\Height_L - 22)) / (SG_ScrollBar()\Max_L - SG_ScrollBar()\Min_L + 1)
              Debug "slidersize changed " + Str(SG_ScrollBar()\SliderSize_L)
              ; Debug"max changed " + Str(SG_ScrollBar()\Max_L)
              
              If SG_ScrollBar()\Value_L > SG_ScrollBar()\Max_L + 1 - SG_ScrollBar()\PageLenght_L
                SG_ScrollBar()\Value_L = SG_ScrollBar()\Max_L + 1 - SG_ScrollBar()\PageLenght_L
              EndIf
              
              ; Debug "scbar slider : " + Str(SG_ScrollBar()\SliderSize_L)
              If SG_ScrollBar()\SliderSize_L < 10
                SG_ScrollBar()\SliderSize_L = 10
              Else
                If SG_ScrollBar()\SliderSize_L > SG_Gadget()\Height_L - 20
                  SG_ScrollBar()\SliderSize_L = SG_Gadget()\Height_L - 20
                EndIf
              EndIf
              
              ChangeCurrentElement(SG_Gadget(), SG_Editor()\GadgetID_P) ; set the gadget of the editor
            EndIf
          EndIf
        Else
          If SG_Editor()\ScrollbarVertical_L
            ChangeCurrentElement(SG_Editor(), SG_Gadget()\AddList_P)
            SG_Editor()\ScrollbarVertical_L = 0
            SG_FreeGadget(SG_Gadget()\SG_GadgetID_L + 2000)
          EndIf
        EndIf
        ;}
        
        ;{ Draw the text
        ; search the start line
        
        If SG_Editor()\ScrollbarVertical_L
          ChangeCurrentElement(SG_ScrollBar(), SG_Editor()\ScrollbarVertical_L)
          Start_L = SG_ScrollBar()\Value_L
        Else
          Start_L = 0
        EndIf
        
        t = 0
        For y = 0 To CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
          *l = SG_Editor()\ItemMem_P + y << 2
          ChangeCurrentElement(EditorGdItems(), *l\l)
          t + EditorGdItems()\ItemSize_L
          If t >= Start_L
            Break
          EndIf
        Next
        
        Page_L = 0
        If CountList(EditorGdItems())
          OffSetY_L = t - Start_L - EditorGdItems()\ItemSize_L
          For x = y To CountGadgetItemMem(SG_Editor()\ItemMem_P)-1
            *l = SG_Editor()\ItemMem_P + x << 2
            ChangeCurrentElement(EditorGdItems(), *l\l)
            
            ; Set the Text font
            If EditorGdItems()\ItemFont_L <> #PB_Default
              DrawingFont(FontID(EditorGdItems()\ItemFont_L))
            ElseIf SG_Editor()\TextFont_L And SG_Editor()\TextFont_L <> #PB_Default
              DrawingFont(FontID(SG_Editor()\TextFont_L))
            EndIf
            
            If Page_L <= SG_Gadget()\Height_L + 20 ; is the bottom reached?
              ; Set the Textcolor
              If SG_Gadget()\Disabled_L
                FrontColor(SG_Gadget()\DisabledColor_L)
              Else
                If EditorGdItems()\RowTextColor_L <> -1
                  FrontColor(EditorGdItems()\RowTextColor_L)
                Else
                  FrontColor(SG_Gadget()\TextColor_L)
                EndIf
              EndIf
              
              ; Draw the backgroundcolor
              If EditorGdItems()\RowColor_L <> -1
                Box(0, OffSetY_L, SG_Gadget()\Width_L, EditorGdItems()\ItemSize_L, EditorGdItems()\RowColor_L)
              EndIf
              
              ; draw the cursor
              If SG_Gadget()\SG_GadgetID_L = SG_FocusGadget_GL And SG_Editor()\Flags_L & #PB_Editor_ReadOnly = 0 ; has this gadget the focus
                If x = SG_Editor()\CursorLine_L ; the line with the cursor
                  If SG_Editor()\CursorMode_L = 0 ; insert
                    Line(5 + OffSetX_L + TextWidth(Left(EditorGdItems()\Item_S, SG_Editor()\CursorPos_L)), OffSetY_L - 2, 0, TextHeight(EditorGdItems()\Item_S) + 4, #Col_Cursor)
                  Else ; overwrite
                    Line(5 + OffSetX_L + TextWidth(Left(EditorGdItems()\Item_S, SG_Editor()\CursorPos_L)), OffSetY_L + TextHeight(EditorGdItems()\Item_S) + 2, 10, 0, #Col_Cursor)
                  EndIf
                EndIf
              EndIf
              
              ; Debug EditorGdItems()\Item_S
              DrawText(5 + OffSetX_L, OffSetY_L, EditorGdItems()\Item_S)
              OffSetY_L + EditorGdItems()\ItemSize_L
            Else
              Break ; no more lines
            EndIf
            Page_L + EditorGdItems()\ItemSize_L
            
          Next
        EndIf
        ;}
        StopDrawing()
      EndIf
      DisplayTransparentSprite(SG_Editor()\SpriteID_L, SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L)
      StartDrawing(ScreenOutput())
      
      ;}
      
    Case #SG_GadgetType_Button ;{
      ChangeCurrentElement(SG_Button(), SG_Gadget()\AddList_P) ; set corr-list
      DrawingMode(1)
      ; Set the Text font
      If SG_Button()\TextFont_L And SG_Button()\TextFont_L <> #PB_Default
        DrawingFont(FontID(SG_Button()\TextFont_L))
      EndIf
      OffSetX_L = (SG_Gadget()\Width_L - TextWidth(SG_Button()\Text_S))>>1
      
      ; resolve the Flags
      If SG_Button()\Flags_L & #PB_Button_MultiLine
        OffSetY_L = 0
      Else
        OffSetY_L = (SG_Gadget()\Height_L - TextHeight(SG_Button()\Text_S)) >> 1
        
      EndIf
      If SG_Button()\Flags_L & #PB_Button_Right
        OffSetX_L = (SG_Gadget()\Width_L - TextWidth(SG_Button()\Text_S))
      ElseIf SG_Button()\Flags_L & #PB_Button_Left
        OffSetX_L = 0
      Else ; center as standard
        OffSetX_L = (SG_Gadget()\Width_L - TextWidth(SG_Button()\Text_S))>>1
      EndIf
      
      If ((SG_Button()\Toggle_L And SG_Button()\Toggle_State_L)) Or (SG_Gadget()\SG_GadgetID_L = SG_CurrentGadget_GL And SG_EventType_L = #SG_EventType_LeftClick)
        DrawBoxX(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 1)
      Else
        DrawBoxX(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 0)
      EndIf
      
      ; Set the Textcolor
      If SG_Gadget()\Disabled_L
        FrontColor(SG_Gadget()\DisabledColor_L)
      Else
        FrontColor(SG_Gadget()\TextColor_L)
      EndIf
      
      DrawText(SG_Gadget()\X_Pos_L + OffSetX_L, SG_Gadget()\Y_Pos_L + OffSetY_L,SG_Button()\Text_S)
      ;}
      
    Case #SG_GadgetType_Checkbox ;{
      ChangeCurrentElement(SG_CheckBox(), SG_Gadget()\AddList_P)
      DrawingMode(1)
      ; Set the Text font
      If SG_CheckBox()\TextFont_L And SG_CheckBox()\TextFont_L <> #PB_Default
        DrawingFont(FontID(SG_CheckBox()\TextFont_L))
      EndIf
      ; draw the box
      Box(SG_Gadget()\X_Pos_L + 4, SG_Gadget()\Y_Pos_L + 4, SG_Gadget()\Height_L-10, SG_Gadget()\Height_L-10, $FFFFFF)
      DrawBox(SG_Gadget()\X_Pos_L+3, SG_Gadget()\Y_Pos_L+3, SG_Gadget()\Height_L-7, SG_Gadget()\Height_L-7, 1)
      ; Set the Textcolor
      If SG_Gadget()\Disabled_L
        FrontColor(SG_Gadget()\DisabledColor_L)
      Else
        FrontColor(SG_Gadget()\TextColor_L)
      EndIf
      If SG_CheckBox()\Status_L
        DrawingFont(FontID(#SG_FontSymbol))
        DrawText(SG_Gadget()\X_Pos_L + 3, SG_Gadget()\Y_Pos_L + 3,Chr($FC), 0)
        DrawingFont(FontID(#SG_FontStandard))
      EndIf
      ; resolve the Flags
      If SG_CheckBox()\Flags_L & #PB_CheckBox_Center
        OffSetX_L = (SG_Gadget()\Width_L - TextWidth(SG_CheckBox()\Text_S))>>1
      ElseIf SG_CheckBox()\Flags_L & #PB_CheckBox_Right
        OffSetX_L = (SG_Gadget()\Width_L - TextWidth(SG_CheckBox()\Text_S))
      EndIf
      OffSetX_L + SG_Gadget()\Height_L
      OffSetY_L = (SG_Gadget()\Height_L - TextHeight(SG_CheckBox()\Text_S)) >> 1
      
      If SG_CheckBox()\Flags_L & #PB_Text_Border
        DrawBox(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 0)
      EndIf
      ; Set the Textcolor
      
      DrawText(SG_Gadget()\X_Pos_L + OffSetX_L, SG_Gadget()\Y_Pos_L + OffSetY_L,SG_CheckBox()\Text_S)
      
      ;}
      
    Case #SG_GadgetType_Combobox ;{
      ; check if this gadget has the focus
      ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
      If SG_Gadget()\SG_GadgetID_L <> SG_FocusGadget_GL
        SG_ComboBox()\Open_L = 0
        If SG_ComboBox()\ScrollbarVertical_L
          a = @SG_Gadget()
          SG_HideGadget(SG_Gadget()\SG_GadgetID_L + 2000, 1)
          ChangeCurrentElement(SG_Gadget(), a)
        EndIf
      EndIf
      
      ; spter die Textart des aktuell aktiven Eintrags
      DrawingFont(FontID(SG_ComboBox()\TextFont_L))
      h = TextHeight(" ")
      SG_ComboBox()\TextHeight_L = h
      OffSetY_L = h + 5
      
      ;{ calc the size of the text
      t = 0
      For x = 0 To CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
        *l = SG_ComboBox()\ItemMem_P + x << 2
        ChangeCurrentElement(ComboBoxGdItems(), *l\l)
        t + ComboBoxGdItems()\ItemSize_L
      Next
      SG_ComboBox()\PageLenghtVertical_L = t
      ;}
      
      ;{ maybe create scrollbar
      ; Debug "height: " + Str(SG_Gadget()\Height_L)
      ; Debug "workaerea: " + Str(SG_Gadget()\Height_L - OffSetY_L - 2)
      ; Debug "work data: " + Str(t * OffSetY_L)
      ; Debug "pagesize licon: " + Str(SG_ComboBox()\PageLenghtVertical_L) + " - " +Str(OffSetY_L) + " - " +Str(t)
      ; Debug "----------"
      If SG_ComboBox()\PageLenghtVertical_L > SG_Gadget()\Height_L - OffSetY_L
        ; Debug "make scrollbar"
        If SG_ComboBox()\ScrollbarVertical_L = 0
          p = @SG_Gadget()
          ; SG_ComboBox()\ScrollbarVertical_L = SG_ScrollBarGadget2(SG_Gadget()\SG_GadgetID_L + 2000, SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L, SG_Gadget()\Y_Pos_L, 14, SG_Gadget()\Height_L, 0, t - (SG_Gadget()\Height_L - 3 - OffSetHeader_L) / OffSetY_L, t, #PB_ScrollBar_Vertical)
          ; Debug "licon SC data: " + Str(t - (SG_Gadget()\Height_L - 3 - OffSetHeader_L) / OffSetY_L) + " - " + Str(t)
          a = SG_ScrollBarGadget2(SG_Gadget()\SG_GadgetID_L + 2000, SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L-14, SG_Gadget()\Y_Pos_L+OffSetY_L, 14, SG_Gadget()\Height_L-OffSetY_L, 0, SG_ComboBox()\PageLenghtVertical_L, SG_Gadget()\Height_L - 3 - OffSetY_L, #PB_ScrollBar_Vertical)
          SG_ComboBox()\ScrollbarVertical_L = PeekL(a + 12) ; get the pointer to the Scrollbarstructure
          
          ChangeCurrentElement(SG_Gadget(), p)
          SG_HideGadget(SG_Gadget()\SG_GadgetID_L + 2000, 1) ; hide it
        EndIf ; has the pagelength changed?
        If SG_ComboBox()\ScrollbarVertical_L ; only useful, if there an some items not visible
          ChangeCurrentElement(SG_ScrollBar(), SG_ComboBox()\ScrollbarVertical_L)
          If SG_ScrollBar()\PageLenght_L <> Round((SG_Gadget()\Height_L - OffSetY_L) / ComboBoxGdItems()\ItemSize_L, 0) Or SG_ScrollBar()\Max_L <> CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
            SG_ScrollBar()\PageLenght_L = Round((SG_Gadget()\Height_L - OffSetY_L) / ComboBoxGdItems()\ItemSize_L, 0)
            SG_ScrollBar()\Min_L = 0
            SG_ScrollBar()\Max_L = CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
            
            ; set and check the scrollbar slider size
            ChangeCurrentElement(SG_Gadget(), SG_ScrollBar()\GadgetID_P) ; set the gadget of the scrollbar
            SG_ScrollBar()\SliderSize_L = (SG_ScrollBar()\PageLenght_L * (SG_Gadget()\Height_L - 20)) / (SG_ScrollBar()\Max_L - SG_ScrollBar()\Min_L + 1)
            If SG_ScrollBar()\Value_L > SG_ScrollBar()\Max_L + 1 - SG_ScrollBar()\PageLenght_L
              SG_ScrollBar()\Value_L = SG_ScrollBar()\Max_L + 1 - SG_ScrollBar()\PageLenght_L
            EndIf
            
            ; Debug "scbar slider : " + Str(SG_ScrollBar()\SliderSize_L)
            If SG_ScrollBar()\SliderSize_L < 10
              SG_ScrollBar()\SliderSize_L = 10
            Else
              If SG_ScrollBar()\SliderSize_L > SG_Gadget()\Height_L - 20
                SG_ScrollBar()\SliderSize_L = SG_Gadget()\Height_L - 20
              EndIf
            EndIf
            ChangeCurrentElement(SG_Gadget(), SG_ComboBox()\GadgetID_P) ; set the gadget of the ComboBox
          EndIf
        EndIf
      Else
        If SG_ComboBox()\ScrollbarVertical_L
          ; Debug"free scbar"
          ChangeCurrentElement(SG_ComboBox(), SG_Gadget()\AddList_P)
          SG_ComboBox()\ScrollbarVertical_L = 0
          SG_FreeGadget(SG_Gadget()\SG_GadgetID_L + 2000)
        EndIf
      EndIf
      ;}
      
      DrawingMode(#PB_2DDrawing_Transparent)
      
      ;{ the selected item
      DrawBox(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, h + 4, 1)
      DrawBox(SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L - h - 2, SG_Gadget()\Y_Pos_L + 1, h+3, h+3, 0)
      Box(SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L - h - 1, SG_Gadget()\Y_Pos_L + 2, h+1, h+2, $C0C0C0)
      t = SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L - h
      Draw_Triangle(t + 2, SG_Gadget()\Y_Pos_L + 7, t + 10, SG_Gadget()\Y_Pos_L + 7, t + 6, SG_Gadget()\Y_Pos_L + 12, $000000)
      
      If SG_ComboBox()\Status_L <> -1 ; is there a item selected -> draw the text
        *l = SG_ComboBox()\ItemMem_P + SG_ComboBox()\Status_L << 2
        ChangeCurrentElement(ComboBoxGdItems(), *l\l)
        
        If ComboBoxGdItems()\RowTextColor_L <> -1
          FrontColor(ComboBoxGdItems()\RowTextColor_L)
        Else
          FrontColor(SG_Gadget()\TextColor_L)
        EndIf
        
        If ComboBoxGdItems()\RowColor_L <> -1
          Box(SG_Gadget()\X_Pos_L+1, SG_Gadget()\Y_Pos_L + 1, SG_Gadget()\Width_L-h-3, h+4, ComboBoxGdItems()\RowColor_L)
        Else
          ; je nach Hintergrund -> wenn farbe, diese setzen
          ; Box(SG_Gadget()\X_Pos_L+1, SG_Gadget()\Y_Pos_L + 1, SG_Gadget()\Width_L-h-3, h+4, $C0C0C0)
        EndIf
        
        DrawText(SG_Gadget()\X_Pos_L + 5, SG_Gadget()\Y_Pos_L + 2, ComboBoxGdItems()\Item_S)
        
      EndIf
      ;}
      
      ;{ Draw the current listitems
      If SG_ComboBox()\Open_L = 1
        DrawBox(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L + h + 5, SG_Gadget()\Width_L, SG_Gadget()\Height_L - h - 5, 1)
        ;{ Startvalue and first item
        If SG_ComboBox()\ScrollbarVertical_L ; is there a scrollbar
          ChangeCurrentElement(SG_ScrollBar(), SG_ComboBox()\ScrollbarVertical_L)
          Start_L = SG_ScrollBar()\Value_L
        Else
          Start_L = 0
        EndIf
        
        ; find first element to display (depending from Scrollbar-setting)
        ; t = 0
        ; For y = 0 To CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
        ; *l = SG_ComboBox()\ItemMem_P + y << 2
        ; ChangeCurrentElement(ComboBoxGdItems(), *l\l)
        ; t + ComboBoxGdItems()\ItemSize_L
        ; If t >= Start_L
        ; Break
        ; EndIf
        ; Next
        y = Start_L
        ;}
        ; Debug"Combo"
        ; Debug"start: "+ Str(y)
        For x = y To CountGadgetItemMem(SG_ComboBox()\ItemMem_P)-1
          *l = SG_ComboBox()\ItemMem_P + x << 2
          ChangeCurrentElement(ComboBoxGdItems(), *l\l)
          
          ; Set the Textcolor
          If SG_Gadget()\Disabled_L
            FrontColor(SG_Gadget()\DisabledColor_L)
          Else 
            If ComboBoxGdItems()\RowTextColor_L <> -1
              FrontColor(ComboBoxGdItems()\RowTextColor_L)
            Else
              FrontColor(SG_Gadget()\TextColor_L)
            EndIf
          EndIf
          
          If ComboBoxGdItems()\RowColor_L <> -1
            If SG_ComboBox()\ScrollbarVertical_L
              Box(SG_Gadget()\X_Pos_L+1, SG_Gadget()\Y_Pos_L + OffSetY_L, SG_Gadget()\Width_L-14, ComboBoxGdItems()\ItemSize_L, ComboBoxGdItems()\RowColor_L)
            Else
              Box(SG_Gadget()\X_Pos_L+1, SG_Gadget()\Y_Pos_L + OffSetY_L, SG_Gadget()\Width_L-1, ComboBoxGdItems()\ItemSize_L, ComboBoxGdItems()\RowColor_L)
            EndIf
          EndIf
          DrawText(SG_Gadget()\X_Pos_L + 5, SG_Gadget()\Y_Pos_L + OffSetY_L, ComboBoxGdItems()\Item_S)
          OffSetY_L + ComboBoxGdItems()\ItemSize_L
          If OffSetY_L > SG_Gadget()\Height_L - h
            Break
          EndIf
        Next
        
      EndIf
      ;}
      ;}
      
    Case #SG_GadgetType_Option ;{
      ChangeCurrentElement(SG_Option(), SG_Gadget()\AddList_P)
      DrawingMode(1)
      ; Set the Text font
      If SG_Option()\TextFont_L And SG_Option()\TextFont_L <> #PB_Default
        DrawingFont(FontID(SG_Option()\TextFont_L))
      EndIf
      ; draw the circle
      Circle(SG_Gadget()\X_Pos_L + SG_Gadget()\Height_L>>1, SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L>>1, SG_Gadget()\Height_L>>1 - 3, $000000)
      Circle(SG_Gadget()\X_Pos_L + SG_Gadget()\Height_L>>1, SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L>>1, SG_Gadget()\Height_L>>1 - 4, $FFFFFF)
      
      ; Set the Textcolor
      If SG_Gadget()\Disabled_L
        FrontColor(SG_Gadget()\DisabledColor_L)
      Else
        FrontColor(SG_Gadget()\TextColor_L)
      EndIf
      
      If SG_Option()\Status_L
        Circle(SG_Gadget()\X_Pos_L + SG_Gadget()\Height_L>>1, SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L>>1, SG_Gadget()\Height_L>>1 - 5, $000000)
        Circle(SG_Gadget()\X_Pos_L + SG_Gadget()\Height_L>>1, SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L>>1, SG_Gadget()\Height_L>>1 - 6, $202020)
        Circle(SG_Gadget()\X_Pos_L + SG_Gadget()\Height_L>>1, SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L>>1, SG_Gadget()\Height_L>>1 - 7, $505050)
      EndIf
      OffSetX_L + SG_Gadget()\Height_L
      OffSetY_L = (SG_Gadget()\Height_L - TextHeight(SG_Option()\Text_S)) >> 1
      
      ; Set the Textcolor
      If SG_Gadget()\Disabled_L
        DrawText(SG_Gadget()\X_Pos_L + OffSetX_L, SG_Gadget()\Y_Pos_L + OffSetY_L, SG_Option()\Text_S, SG_Gadget()\DisabledColor_L)
      Else
        DrawText(SG_Gadget()\X_Pos_L + OffSetX_L, SG_Gadget()\Y_Pos_L + OffSetY_L, SG_Option()\Text_S, SG_Gadget()\TextColor_L)
      EndIf
      ;}
      
    Case #SG_GadgetType_Trackbar ;{
      ChangeCurrentElement(SG_TrackBar(), SG_Gadget()\AddList_P)
      ; resolve the Flags
      If SG_TrackBar()\Flags_L & #PB_TrackBar_Vertical
        ; the gadget
        OffSetX_L = SG_Gadget()\Width_L>>1
        Box(SG_Gadget()\X_Pos_L + OffSetX_L-3, SG_Gadget()\Y_Pos_L + 10, 6, SG_Gadget()\Height_L-20, $C0C0C0)
        DrawingMode(#PB_2DDrawing_Outlined)
        If SG_Gadget()\Disabled_L
          Box(SG_Gadget()\X_Pos_L + OffSetX_L-3, SG_Gadget()\Y_Pos_L + 10, 6, SG_Gadget()\Height_L-20, $808080)
        Else
          Box(SG_Gadget()\X_Pos_L + OffSetX_L-3, SG_Gadget()\Y_Pos_L + 10, 6, SG_Gadget()\Height_L-20, $000000)
        EndIf
        
        ; Ticks
        If SG_TrackBar()\Flags_L & #PB_TrackBar_Ticks
          f.f = (SG_Gadget()\Height_L-20) / (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)
          For x = 0 To SG_TrackBar()\Max_L - SG_TrackBar()\Min_L
            Line(SG_Gadget()\X_Pos_L + 2, SG_Gadget()\Y_Pos_L + 10 + x * f, 4, 0, SG_Gadget()\TextColor_L)
          Next
        EndIf
        
        ; Slider
        DrawingMode(#PB_2DDrawing_Transparent)
        Box(SG_Gadget()\X_Pos_L + 2, SG_Gadget()\Y_Pos_L + 5 + SG_TrackBar()\Position_L, SG_Gadget()\Width_L - 4, 10, $C0C0C0)
        DrawingMode(4)
        If SG_Gadget()\Disabled_L
          Box(SG_Gadget()\X_Pos_L + 2, SG_Gadget()\Y_Pos_L + 5 + SG_TrackBar()\Position_L, SG_Gadget()\Width_L - 4, 10, SG_Gadget()\DisabledColor_L)
        Else
          Box(SG_Gadget()\X_Pos_L + 2, SG_Gadget()\Y_Pos_L + 5 + SG_TrackBar()\Position_L, SG_Gadget()\Width_L - 4, 10, $000000)
        EndIf
        DrawingMode(#PB_2DDrawing_Transparent)
      Else
        ; the gadget
        OffSetY_L = SG_Gadget()\Height_L>>1
        Box(SG_Gadget()\X_Pos_L + 10, SG_Gadget()\Y_Pos_L + OffSetY_L - 3, SG_Gadget()\Width_L-20, 6, $C0C0C0)
        DrawingMode(#PB_2DDrawing_Outlined)
        If SG_Gadget()\Disabled_L
          Box(SG_Gadget()\X_Pos_L + 10, SG_Gadget()\Y_Pos_L + OffSetY_L - 3, SG_Gadget()\Width_L-20, 6, SG_Gadget()\DisabledColor_L)
        Else
          Box(SG_Gadget()\X_Pos_L + 10, SG_Gadget()\Y_Pos_L + OffSetY_L - 3, SG_Gadget()\Width_L-20, 6, $000000)
        EndIf
        
        ; Ticks
        If SG_TrackBar()\Flags_L & #PB_TrackBar_Ticks
          f.f = (SG_Gadget()\Width_L-20) / (SG_TrackBar()\Max_L - SG_TrackBar()\Min_L)
          For x = 0 To SG_TrackBar()\Max_L - SG_TrackBar()\Min_L
            Line(SG_Gadget()\X_Pos_L + 10 + x * f, SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L - 6, 0, 4, SG_Gadget()\TextColor_L)
          Next
        EndIf
        
        ; Slider
        DrawingMode(#PB_2DDrawing_Transparent)
        Box(SG_Gadget()\X_Pos_L + 5 + SG_TrackBar()\Position_L, SG_Gadget()\Y_Pos_L + 2, 10, SG_Gadget()\Height_L - 4, $C0C0C0)
        DrawingMode(#PB_2DDrawing_Outlined)
        If SG_Gadget()\Disabled_L
          Box(SG_Gadget()\X_Pos_L + 5 + SG_TrackBar()\Position_L, SG_Gadget()\Y_Pos_L + 2, 10, SG_Gadget()\Height_L - 4, SG_Gadget()\DisabledColor_L)
        Else
          Box(SG_Gadget()\X_Pos_L + 5 + SG_TrackBar()\Position_L, SG_Gadget()\Y_Pos_L + 2, 10, SG_Gadget()\Height_L - 4, $000000)
        EndIf
        DrawingMode(#PB_2DDrawing_Transparent)
      EndIf
      ;}
      
    Case #SG_GadgetType_Listicon, #SG_GadgetType_ExplorerList ;{
      ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
      ;{ the basic shape
      DrawBox(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 1)
      
      DrawingFont(FontID(SG_ListIcon()\TextFont_L))
      OffSetHeader_L = TextHeight(SG_ListIcon()\HeaderText_S[0])
      SG_ListIcon()\HeaderHeight_L = OffSetHeader_L
      OffSetY_L = OffSetHeader_L
      
      If SG_Gadget()\Disabled_L
        FrontColor(SG_Gadget()\DisabledColor_L)
      Else
        FrontColor(SG_Gadget()\TextColor_L)
      EndIf
      ; draw the working area
      If SG_Gadget()\BackGround_L = 1 ; Color
        Box(SG_Gadget()\X_Pos_L + OffSetX_L, SG_Gadget()\Y_Pos_L + 2 + OffSetHeader_L, SG_Gadget()\Width_L-2, SG_Gadget()\Height_L - 3 - OffSetHeader_L, SG_Gadget()\BackGroundDetail_L)
      EndIf
      ;}
      
      ;{ draw the header
      Box(SG_Gadget()\X_Pos_L + 1, SG_Gadget()\Y_Pos_L + 1, SG_Gadget()\Width_L, OffSetHeader_L+1, SG_ListIcon()\HeaderBackColor_L)
      If SG_ListIcon()\ShowImages_L ; if there are Images to show
        Box(SG_Gadget()\X_Pos_L + OffSetX_L, SG_Gadget()\Y_Pos_L + 1, 19, OffSetHeader_L, SG_ListIcon()\HeaderBackColor_L)
        DrawBox(SG_Gadget()\X_Pos_L + OffSetX_L, SG_Gadget()\Y_Pos_L + 1, 19, OffSetHeader_L, 0)
        ; If SG_ListIcon()\Flags_L & #PB_ListIcon_GridLines ; show the gridline if there are Images to show
        ; Line(SG_Gadget()\X_Pos_L + OffSetX_L, SG_Gadget()\Y_Pos_L + 2 + OffSetHeader_L, 0, SG_Gadget()\Height_L - 3 - OffSetHeader_L, $F0F0F0)
        ; EndIf
        ImageOffSet_L = 20
        
        ; Draw the grid?
        If SG_ListIcon()\Flags_L & #PB_ListIcon_GridLines
          Line(SG_Gadget()\X_Pos_L + OffSetX_L + ImageOffSet_L, SG_Gadget()\Y_Pos_L + 2 + OffSetHeader_L, 0, SG_Gadget()\Height_L - 3 - OffSetHeader_L, SG_ListIcon()\LineColor_L)
        EndIf
      Else
        ImageOffSet_L = 1
      EndIf
      
      Column_L = 0
      OffSetX_L = 0
      For z = 0 To 15
        If SG_ListIcon()\HeaderWidth[z] > 0
          Box(SG_Gadget()\X_Pos_L + OffSetX_L + ImageOffSet_L, SG_Gadget()\Y_Pos_L + 1, SG_ListIcon()\HeaderWidth[z], OffSetHeader_L, SG_ListIcon()\HeaderBackColor_L)
          DrawBox(SG_Gadget()\X_Pos_L + OffSetX_L + ImageOffSet_L, SG_Gadget()\Y_Pos_L + 1, SG_ListIcon()\HeaderWidth[z], OffSetHeader_L, 0)
          DrawingMode(1)
          DrawText(SG_Gadget()\X_Pos_L + OffSetX_L + ImageOffSet_L + (SG_ListIcon()\HeaderWidth[z] - TextWidth(SG_ListIcon()\HeaderText_S[z]))>>1, SG_Gadget()\Y_Pos_L + 1, SG_ListIcon()\HeaderText_S[z], SG_ListIcon()\HeaderTextColor_L)
          
          ; evtl. das Sortierdreieck einzeichnen
          If SG_ListIcon()\HeaderStatus[z] = 0
            x = SG_Gadget()\X_Pos_L + OffSetX_L + ImageOffSet_L + 1
            y = SG_Gadget()\Y_Pos_L + OffSetHeader_L>>1-1
            Draw_Triangle(x, y, x + 6, y, x + 3, y + 3, $000000)
          ElseIf SG_ListIcon()\HeaderStatus[z] = 1
            x = SG_Gadget()\X_Pos_L + OffSetX_L + ImageOffSet_L + 1
            y = SG_Gadget()\Y_Pos_L + OffSetHeader_L>>1 + OffSetHeader_L>>2 -2
            Draw_Triangle(x, y, x + 7, y, x + 3, y - 4, $000000)
          EndIf
          
          OffSetX_L + SG_ListIcon()\HeaderWidth[z]
          Column_L + 1
          
          ; Draw the grid?
          If SG_ListIcon()\Flags_L & #PB_ListIcon_GridLines
            Line(SG_Gadget()\X_Pos_L + OffSetX_L + ImageOffSet_L, SG_Gadget()\Y_Pos_L + 2 + OffSetHeader_L, 0, SG_Gadget()\Height_L - 3 - OffSetHeader_L, SG_ListIcon()\LineColor_L)
          EndIf
        EndIf
      Next
      ; Debug "colums:; " + Str(Column_L)
      ;}
      
      ;{ calc the size of the text
      t = 0
      For x = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
        *l = SG_ListIcon()\ItemMem_P + x << 2
        ChangeCurrentElement(ListIconGdItems(), *l\l)
        t + ListIconGdItems()\ItemSize_L
      Next
      SG_ListIcon()\PageLenghtVertical_L = t
      ;}
      
      ;{ maybe create scrollbar
      ; Debug "height: " + Str(SG_Gadget()\Height_L)
      ; Debug "workaerea: " + Str(SG_Gadget()\Height_L - OffSetY_L - 2)
      ; Debug "work data: " + Str(t * OffSetY_L)
      ; Debug "pagesize licon: " + Str(SG_ListIcon()\PageLenghtVertical_L) + " - " +Str(OffSetY_L) + " - " +Str(t)
      ; Debug "----------"
      If SG_ListIcon()\PageLenghtVertical_L > SG_Gadget()\Height_L - OffSetHeader_L - 2
        ; Debug "make scrollbar"
        If SG_ListIcon()\ScrollbarVertical_L = 0
          p = @SG_Gadget()
          ; SG_ListIcon()\ScrollbarVertical_L = SG_ScrollBarGadget2(SG_Gadget()\SG_GadgetID_L + 2000, SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L, SG_Gadget()\Y_Pos_L, 14, SG_Gadget()\Height_L, 0, t - (SG_Gadget()\Height_L - 3 - OffSetHeader_L) / OffSetY_L, t, #PB_ScrollBar_Vertical)
          ; Debug "licon SC data: " + Str(t - (SG_Gadget()\Height_L - 3 - OffSetHeader_L) / OffSetY_L) + " - " + Str(t)
          a = SG_ScrollBarGadget2(SG_Gadget()\SG_GadgetID_L + 2000, SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L, SG_Gadget()\Y_Pos_L, 14, SG_Gadget()\Height_L, 0, SG_ListIcon()\PageLenghtVertical_L, SG_Gadget()\Height_L - 3 - OffSetHeader_L, #PB_ScrollBar_Vertical)
          SG_ListIcon()\ScrollbarVertical_L = PeekL(a + 12) ; get the pointer to the Scrollbarstructure
          ChangeCurrentElement(SG_Gadget(), p)
        EndIf
        If SG_ListIcon()\ScrollbarVertical_L ; only useful, if there an some items not visible
          ChangeCurrentElement(SG_ScrollBar(), SG_ListIcon()\ScrollbarVertical_L)
          If SG_ScrollBar()\PageLenght_L <> (SG_Gadget()\Height_L - OffSetHeader_L) / ListIconGdItems()\ItemSize_L Or SG_ScrollBar()\Max_L <> CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1; SG_ListIcon()\PageLenghtVertical_L
            ; Debug"itemsize: " + Str(ListIconGdItems()\ItemSize_L)
            ; Debug SG_Gadget()\Height_L - OffSetHeader_L
            ; Debug"calc pl: "+ Str((SG_Gadget()\Height_L - OffSetHeader_L) / ListIconGdItems()\ItemSize_L)
            SG_ScrollBar()\PageLenght_L = (SG_Gadget()\Height_L - OffSetHeader_L) / ListIconGdItems()\ItemSize_L  ; SG_ListIcon()\PageLenghtVertical_L
            SG_ScrollBar()\Max_L = SG_ListIcon()\PageLenghtVertical_L - (SG_Gadget()\Height_L - 3 - OffSetHeader_L)
            SG_ScrollBar()\Min_L = 0
            SG_ScrollBar()\Max_L = CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
            ; Debug"pagelength: " + Str(SG_ScrollBar()\PageLenght_L)
            ; Debug"max: "+ Str(SG_ScrollBar()\Max_L)
            
            ; set and check the scrollbar slider size
            ChangeCurrentElement(SG_Gadget(), SG_ScrollBar()\GadgetID_P) ; set the gadget of the scrollbar
            SG_ScrollBar()\SliderSize_L = (SG_ScrollBar()\PageLenght_L * (SG_Gadget()\Height_L - 20)) / (SG_ScrollBar()\Max_L - SG_ScrollBar()\Min_L + 1)
            ; Debug"scbar slider : " + Str(SG_ScrollBar()\SliderSize_L)
            
            
            If SG_ScrollBar()\Value_L > SG_ScrollBar()\Max_L + 1 - SG_ScrollBar()\PageLenght_L
              SG_ScrollBar()\Value_L = SG_ScrollBar()\Max_L + 1 - SG_ScrollBar()\PageLenght_L
            EndIf
            
            
            If SG_ScrollBar()\SliderSize_L < 10
              SG_ScrollBar()\SliderSize_L = 10
            Else
              If SG_ScrollBar()\Flags_L & #PB_ScrollBar_Vertical
                If SG_ScrollBar()\SliderSize_L > SG_Gadget()\Height_L-20
                  SG_ScrollBar()\SliderSize_L = SG_Gadget()\Height_L-20
                EndIf
              EndIf
            EndIf
            ChangeCurrentElement(SG_Gadget(), SG_ListIcon()\GadgetID_P) ; set the gadget of the listicon
          EndIf
        EndIf
        
      Else
        If SG_ListIcon()\ScrollbarVertical_L
          ChangeCurrentElement(SG_ListIcon(), SG_Gadget()\AddList_P)
          SG_ListIcon()\ScrollbarVertical_L = 0
          SG_FreeGadget(SG_Gadget()\SG_GadgetID_L + 2000)
        EndIf
      EndIf
      ;}
      
      ;{ write the data to the gadget
      ;{ Startvalue 
      If SG_ListIcon()\ScrollbarVertical_L ; is there a scrollbar
        ChangeCurrentElement(SG_ScrollBar(), SG_ListIcon()\ScrollbarVertical_L)
        Start_L = SG_ScrollBar()\Value_L
        Lenght_L = SG_ScrollBar()\PageLenght_L
      Else
        Start_L = 0
        Lenght_L = CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
      EndIf
      ;}
      
      ;{ find first element to display (depending from Scrollbar-setting)
      ; t = 0
      ; For y = 0 To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
      ; *l = SG_ListIcon()\ItemMem_P + y << 2
      ; ChangeCurrentElement(ListIconGdItems(), *l\l)
      ; t + ListIconGdItems()\ItemSize_L
      ; If t >= Start_L
      ; Break
      ; EndIf
      ; Next
      ;}
      
      Page_L = OffSetHeader_L
      If CountGadgetItemMem(SG_ListIcon()\ItemMem_P)
        For x = Start_L To CountGadgetItemMem(SG_ListIcon()\ItemMem_P)-1
          ; Debug "item : " + Str(x)
          *l = SG_ListIcon()\ItemMem_P + x << 2
          ChangeCurrentElement(ListIconGdItems(), *l\l)
          ; Debug ListIconGdItems()\Item_S
          ;{ Set the Text font
          If ListIconGdItems()\ItemFont_L <> #PB_Default
            DrawingFont(FontID(ListIconGdItems()\ItemFont_L))
          ElseIf SG_ListIcon()\TextFont_L And SG_ListIcon()\TextFont_L <> #PB_Default
            DrawingFont(FontID(SG_ListIcon()\TextFont_L))
          EndIf
          ;}
          If Page_L + ListIconGdItems()\ItemSize_L <= SG_Gadget()\Height_L
            ;If x <= Start_L + Lenght_L ; Page_L <= SG_Gadget()\Height_L - SG_ListIcon()\HeaderHeight_L ; is the bottom reached?
            ;{ Draw the grid? ; horizontal
            If SG_ListIcon()\Flags_L & #PB_ListIcon_GridLines
              Line(SG_Gadget()\X_Pos_L + 1, SG_Gadget()\Y_Pos_L + Page_L + ListIconGdItems()\ItemSize_L, SG_Gadget()\Width_L-2, 0, SG_ListIcon()\LineColor_L)
            EndIf
            ;}
            
            ;{ Set the Textcolor
            ; CallDebugger
            If SG_Gadget()\Disabled_L
              FrontColor(SG_Gadget()\DisabledColor_L)
            Else
              If ListIconGdItems()\RowTextColor_L <> -1
                FrontColor(ListIconGdItems()\RowTextColor_L)
              Else
                FrontColor(SG_Gadget()\TextColor_L)
              EndIf
            EndIf
            ;}
            
            ;{ Draw the item-state-marks and backgroundcolor
            If ListIconGdItems()\RowColor_L <> -1
              Box(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L + Page_L, SG_Gadget()\Width_L, ListIconGdItems()\ItemSize_L, ListIconGdItems()\RowColor_L)
            EndIf
            If ListIconGdItems()\ItemState_L And (SG_ListIcon()\Flags_L & #PB_ListIcon_AlwaysShowSelection Or SG_FocusGadget_GL = SG_Gadget()\SG_GadgetID_L)
              ; Debug "selected: "+ Str(x)
              If SG_ListIcon()\Flags_L & #PB_ListIcon_FullRowSelect
                Width_L = SG_Gadget()\Width_L-2- ImageOffSet_L
              Else
                Width_L = SG_ListIcon()\HeaderWidth[0]
              EndIf
              Box(SG_Gadget()\X_Pos_L + ImageOffSet_L, SG_Gadget()\Y_Pos_L + Page_L + 2, Width_L, ListIconGdItems()\ItemSize_L, #Col_StateMark)
            EndIf
            ;}
            
            ;{ Draw an image
            If ListIconGdItems()\ImageID_L ; if there is an image to show
              If ListIconGdItems()\ItemSize_L > 19 ; min size for images
                y = (ListIconGdItems()\ItemSize_L - 19) >>1
              Else 
                y = 0
              EndIf
              DrawImage(ListIconGdItems()\ImageID_L, SG_Gadget()\X_Pos_L + 3, SG_Gadget()\Y_Pos_L + y + 2 + Page_L)
            EndIf
            ;}
            
            ;{ Draw the text
            OffSetX_L = 0
            n = CountString(ListIconGdItems()\Item_S, Chr(10))
            For z = 0 To n
              s = StringField(ListIconGdItems()\Item_S, z+1, Chr(10))
              DrawText(SG_Gadget()\X_Pos_L + OffSetX_L + ImageOffSet_L + 4, SG_Gadget()\Y_Pos_L + 2 + Page_L, s)
              OffSetX_L + SG_ListIcon()\HeaderWidth[z]
            Next
            ;}
            
          Else
            Break ; no more lines
          EndIf
          Page_L + ListIconGdItems()\ItemSize_L
        Next
      EndIf
      ;}
      
      ; #PB_ListIcon_CheckBoxes          ; Zeigt Checkboxen in der ersten spalte.
      ; #PB_ListIcon_MultiSelect         ; Schaltet die Mehrfach-Selektion ein.
      ; #PB_ListIcon_AlwaysShowSelection
      
      ;}
      
    Case #SG_GadgetType_ScrollBar ;{
      ChangeCurrentElement(SG_ScrollBar(), SG_Gadget()\AddList_P)
      DrawBox(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 1)
      
      ; Debug "--------------"
      ; Debug "slider gr: " + Str(SG_ScrollBar()\SliderSize_L)
      
      If SG_ScrollBar()\Flags_L & #PB_ScrollBar_Vertical
        Box(SG_Gadget()\X_Pos_L + 1, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L , 10, SG_Gadget()\BackGroundDetail_L)
        Box(SG_Gadget()\X_Pos_L + 1, SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L - 10, SG_Gadget()\Width_L, 10, SG_Gadget()\BackGroundDetail_L)
        DrawBox(SG_Gadget()\X_Pos_L+ 1, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L-1, 10, 0)
        DrawBox(SG_Gadget()\X_Pos_L+ 1, SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L - 10, SG_Gadget()\Width_L-1, 10,  0)
        
        ; Draw the arrows
        OffSetX_L = SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L>>1 + 1
        OffSetY_L = SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L - 10
        Draw_Triangle(OffSetX_L, SG_Gadget()\Y_Pos_L + 3, OffSetX_L + 4, SG_Gadget()\Y_Pos_L + 8, OffSetX_L - 4, SG_Gadget()\Y_Pos_L + 8, $000000)
        Draw_Triangle(OffSetX_L, OffSetY_L + 8, OffSetX_L + 4, OffSetY_L + 3, OffSetX_L - 4, OffSetY_L + 3, $000000)
        
        ; draw the Slider
        OffSetY_L = (SG_ScrollBar()\Value_L * (SG_Gadget()\Height_L-20)) / (SG_ScrollBar()\Max_L - SG_ScrollBar()\Min_L + 1)
        Box(SG_Gadget()\X_Pos_L + 1, SG_Gadget()\Y_Pos_L + OffSetY_L + 11, SG_Gadget()\Width_L-1, SG_ScrollBar()\SliderSize_L-1, SG_Gadget()\BackGroundDetail_L)
        DrawBox(SG_Gadget()\X_Pos_L + 1, SG_Gadget()\Y_Pos_L + OffSetY_L + 11, SG_Gadget()\Width_L-1, SG_ScrollBar()\SliderSize_L-1, 0)
        
      Else
        Box(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, 10, SG_Gadget()\Height_L, SG_Gadget()\BackGroundDetail_L)
        Box(SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L - 10, SG_Gadget()\Y_Pos_L, 10, SG_Gadget()\Height_L, SG_Gadget()\BackGroundDetail_L)
        DrawBox(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, 10, SG_Gadget()\Height_L, 0)
        DrawBox(SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L - 10, SG_Gadget()\Y_Pos_L, 10, SG_Gadget()\Height_L, 0)
        ; Draw the arrows
        OffSetY_L = SG_Gadget()\Y_Pos_L + SG_Gadget()\Height_L/2
        OffSetX_L = SG_Gadget()\X_Pos_L + SG_Gadget()\Width_L - 10
        Draw_Triangle(SG_Gadget()\X_Pos_L + 3, OffSetY_L, SG_Gadget()\X_Pos_L + 7, OffSetY_L+4, SG_Gadget()\X_Pos_L + 7, OffSetY_L-4, $000000)
        Draw_Triangle(OffSetX_L + 7, OffSetY_L, OffSetX_L + 3, OffSetY_L+4, OffSetX_L + 3, OffSetY_L-4, $000000)
        
        ; draw the Slider
        OffSetX_L = (SG_ScrollBar()\Value_L * (SG_Gadget()\Width_L-20)) / (SG_ScrollBar()\Max_L - SG_ScrollBar()\Min_L + 1)
        ; Set the Textcolor
        If SG_Gadget()\Disabled_L
          Box(SG_Gadget()\X_Pos_L + OffSetX_L + 10, SG_Gadget()\Y_Pos_L+ 1, SG_ScrollBar()\SliderSize_L, SG_Gadget()\Height_L-1, SG_Gadget()\DisabledColor_L)
        Else
          Box(SG_Gadget()\X_Pos_L + OffSetX_L + 10, SG_Gadget()\Y_Pos_L+ 1, SG_ScrollBar()\SliderSize_L, SG_Gadget()\Height_L-1, SG_Gadget()\BackGroundDetail_L)
        EndIf
        DrawBox(SG_Gadget()\X_Pos_L + OffSetX_L + 10, SG_Gadget()\Y_Pos_L+ 1, SG_ScrollBar()\SliderSize_L, SG_Gadget()\Height_L-1, 0)
        
      EndIf
      ;}
      
    Case #SG_GadgetType_Image ;{
      ChangeCurrentElement(SG_Image(), SG_Gadget()\AddList_P)
      If SG_Image()\Flags_L & #PB_Image_Border
        DrawBox(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 0)
      EndIf
      ;}
      
    Case #SG_GadgetType_ButtonImage ;{
      ChangeCurrentElement(SG_ButtonImage(), SG_Gadget()\AddList_P)
      If ((SG_ButtonImage()\Toggle_L And SG_ButtonImage()\Toggle_State_L)) Or (SG_Gadget()\SG_GadgetID_L = SG_CurrentGadget_GL And SG_EventType_L = #SG_EventType_LeftClick)
        DrawImage(SG_Gadget()\BackGroundDetail_L, SG_Gadget()\X_Pos_L+1, SG_Gadget()\Y_Pos_L+1, SG_Gadget()\Width_L, SG_Gadget()\Height_L)
        DrawBox(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 1)
      Else
        DrawImage(SG_Gadget()\BackGroundDetail_L, SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L)
        DrawBox(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 0)
      EndIf
      ;}
      
    Case #SG_GadgetType_Frame3D ;{
      ChangeCurrentElement(SG_Frame3D(), SG_Gadget()\AddList_P)
      Length_L = TextWidth(SG_Frame3D()\Text_S)
      If cFlags_L = #PB_Frame3D_Single
        DrawBox3D(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 0, Length_L)
      ElseIf SG_Frame3D()\Flags_L = #PB_Frame3D_Double
        DrawBox3D(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 3, Length_L)
      ElseIf SG_Frame3D()\Flags_L = #PB_Frame3D_Flat
        DrawBox3D(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 2, Length_L)
      Else
        DrawBox3D(SG_Gadget()\X_Pos_L, SG_Gadget()\Y_Pos_L, SG_Gadget()\Width_L, SG_Gadget()\Height_L, 5, Length_L)
      EndIf
      FrontColor(SG_Gadget()\TextColor_L)
      DrawingMode(#PB_2DDrawing_Transparent)
      DrawText(SG_Gadget()\X_Pos_L + 7, SG_Gadget()\Y_Pos_L - TextHeight(SG_Frame3D()\Text_S)>>1, SG_Frame3D()\Text_S)
      
      ;}
      
  EndSelect
  ; EndIf
  ; EndIf
  ; Wend
  ; StopDrawing()
  ; EndIf
  
EndProcedure
ProcedureDLL SG_DrawGadgets2(StartGadget_L.l, EndGadget_L.l) ; draws the gadgets to the current screen
  
  If StartDrawing(ScreenOutput())
    ResetList(SG_Gadget())
    While NextElement(SG_Gadget())
      ; draw all gadgets, or only some ; but then draw dependent scrollbars with them
      If StartGadget_L = -1 Or (SG_Gadget()\SG_GadgetID_L >= StartGadget_L And SG_Gadget()\SG_GadgetID_L <= EndGadget_L ) Or (SG_Gadget()\SG_GadgetID_L-2000 >= StartGadget_L And SG_Gadget()\SG_GadgetID_L-2000 <= EndGadget_L )
        If SG_Gadget()\SG_GadgetID_L <> SG_FocusGadget_GL 
          If SG_Gadget()\Hidden_L = 0 ; not hidden
            SG_DrawGadgetsReal() ; draw it
          EndIf
        Else
          a = @SG_Gadget()
        EndIf
      EndIf
    Wend
    
    If a
      ChangeCurrentElement(SG_Gadget(), a) ; set the currently active gadget-element
      If SG_Gadget()\Hidden_L = 0 ; not hidden -> max happen by creation
        SG_DrawGadgetsReal() ; draw it
      EndIf
    EndIf
    StopDrawing()
  EndIf
  
EndProcedure
ProcedureDLL SG_DrawGadgets()
  SG_DrawGadgets2(-1, 0)
EndProcedure



; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 1854
; FirstLine = 1779
; Folding = -----------------------------------
; HideErrorLog